local AudioHandler = class("AudioHandler")

function AudioHandler:getInstance()
	if not self.instance then
		self.instance = AudioHandler.new()
	end
	return self.instance
end

function AudioHandler:ctor()

	self.music_Path = {
		Music_Main = "res/music/mainMusic.mp3",
	}
	self.effect_Path = {
        Effect_Click = "res/music/selectEffect.mp3",
		Effect_Hit = "res/music/hitEffect.mp3",
		Effect_LevelUP = "res/music/levelUpEffect.mp3",
		Effect_Luck = "res/music/luckEffect.mp3",
		Effect_Soul = "res/music/soulEffect.mp3",
	}
	

end

function AudioHandler:preloadMusicRes()
	for i,v in pairs(self.music_Path) do
		cc.SimpleAudioEngine:getInstance():preloadMusic(cc.FileUtils:getInstance():fullPathForFilename(v))
	end
	for i,v in pairs(self.effect_Path) do
		cc.SimpleAudioEngine:getInstance():preloadEffect(cc.FileUtils:getInstance():fullPathForFilename(v))
	end
end

function AudioHandler:setMainBackgroundMusicState(state)
	if state == true then
		cc.SimpleAudioEngine:getInstance():playMusic(cc.FileUtils:getInstance():fullPathForFilename(self.music_Path.Music_Main),true)
	elseif state == false then
		cc.SimpleAudioEngine:getInstance():stopMusic()
	end
	cc.UserDefault:getInstance():setBoolForKey("Music_Main",state)
	cc.UserDefault:getInstance():flush()
end

function AudioHandler:setEffectState(state)
	cc.UserDefault:getInstance():setBoolForKey("Sound",state)
	cc.UserDefault:getInstance():flush()
end

return AudioHandler