
local CreateScene = class("CreateScene",function()
    return cc.Scene:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function CreateScene.create()
    local scene = CreateScene.new()
    scene:createLayerMenu()

    return scene
end

function CreateScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function CreateScene:createLayerMenu()

    local job = 1
    local sex = 0

    local node = tolua.cast(cc.CSLoader:createNode("ui/create/CreateScene.csb"), "ccui.Widget")
    self:addChild(node)
	
	-- tipsLayer
	local tipsLayerClass = require("src.tips.SystemTipsLayer")
	tipsLayerClass:create()
	local tipsLayer = tipsLayerClass:getInstance()
    self:addChild(tipsLayer,100)
	
	--RichTipsLayer
	--require("src.wdDefine")
	local tipsLayerClass = require("src.tips.RichTipsLayer")
	tipsLayerClass:create()
	local tipsLayer = tipsLayerClass:getInstance()
    self:addChild(tipsLayer,102)
	tipsLayer:setPosition(cc.p(0,0))
	
    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local role = tolua.cast(node:getChildByName("Role_Sprite"), "cc.Sprite")


    --local jobTable = {[0]="warrior",[1]="magician",[2]="taoist"}
    --local sexTable = {[0]="m",[1]="f"}
    
    
    local jobText = tolua.cast(ccui.Helper:seekWidgetByName(node,"Job_Text"), "ccui.Text")
    local atkText = tolua.cast(ccui.Helper:seekWidgetByName(node,"Atk_Text"), "ccui.Text")
    local equipText = tolua.cast(ccui.Helper:seekWidgetByName(node,"Equip_Text"), "ccui.Text")
    local futureText = tolua.cast(ccui.Helper:seekWidgetByName(node,"Future_Text"), "ccui.Text")


    local function showRoleChange()
        role:setSpriteFrame(wd.getPlayerImageName(job,sex))
        if sex == 1 then
            role:setFlippedX(true)
        else
            role:setFlippedX(false)
        end
        jobText:setString(wd.getJobDescString(job))
        atkText:setString(wd.getAtkDescString(job))
        equipText:setString(wd.getEquipDescString(job))
        futureText:setString(wd.getFutureDescString(job))
    end
    
    local rolePanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Role"), "ccui.Button")

    local warriorM_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Warrior_M_Button"), "ccui.Button")
    local magicianM_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Magician_M_Button"), "ccui.Button")
    local taoistM_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Taoist_M_Button"), "ccui.Button")
    local warriorF_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Warrior_F_Button"), "ccui.Button")
    local magicianF_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Magician_F_Button"), "ccui.Button")
    local taoistF_Btn = tolua.cast(ccui.Helper:seekWidgetByName(rolePanel,"Taoist_F_Button"), "ccui.Button")
    

    local selectSprite = tolua.cast(rolePanel:getChildByName("Select_Sprite"), "cc.Sprite")
    
    local function selectCallback(sender,eventType)

        if eventType == ccui.TouchEventType.ended then
           if sender:getTag() == 1 then
                job = 1
                sex = 0

           elseif sender:getTag() == 2 then
                job = 1
                sex = 1

           elseif sender:getTag() == 3 then
                job = 2
                sex = 0
                
            elseif sender:getTag() == 4 then
                job = 2
                sex = 1

            elseif sender:getTag() == 5 then
                job = 3
                sex = 0
                
            elseif sender:getTag() == 6 then
                job = 3
                sex = 1
                
           end
           
           selectSprite:setPosition(sender:getPosition())
           showRoleChange()
        end
    end
    
    warriorM_Btn:addTouchEventListener(selectCallback)
    magicianM_Btn:addTouchEventListener(selectCallback)
    taoistM_Btn:addTouchEventListener(selectCallback)
    
    warriorF_Btn:addTouchEventListener(selectCallback)
    magicianF_Btn:addTouchEventListener(selectCallback)
    taoistF_Btn:addTouchEventListener(selectCallback)

    
  
--    local maleBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SexMale_Button"), "ccui.Button")
--    local famaleBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SexFamale_Button"), "ccui.Button")

    
--    local function selectSexCallback(sender,eventType)
--
--        if eventType == ccui.TouchEventType.ended then
--            if sender:getTag() == 0 then
--                maleBtn:setBright(false)
--                maleBtn:setEnabled(false)
--                famaleBtn:setBright(true)
--                famaleBtn:setEnabled(true)
--                sex = 0
--            elseif sender:getTag() == 1 then
--                maleBtn:setBright(true)
--                maleBtn:setEnabled(true)
--                famaleBtn:setBright(false)
--                famaleBtn:setEnabled(false)
--                sex = 1
--            end
--            showRoleChange()
--        end
--    end
    
--    maleBtn:addTouchEventListener(selectSexCallback)
--    famaleBtn:addTouchEventListener(selectSexCallback)
    
    local nameField = tolua.cast(ccui.Helper:seekWidgetByName(node,"Name_TextField"), "ccui.TextField")
	local randomBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Random_Button"), "ccui.Button")
	randomBtn:setPressedActionEnabled(true)
    randomBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				wd.TranscodingSend:getRandName()
            end
        end
    )
	
	
    local function createCallback(sender,eventType)

        if eventType == ccui.TouchEventType.ended then
        
        
            if nameField:getString():len() > 0 then 
                wd.TranscodingSend:setCharactor(nameField:getString(), wd.getJobString(job), wd.getSexString(sex))
            else
                --cclog("name can not be empty")
				wd.showRichTips(4,"名字不能为空")
            end
            --wd.Transcoding:getInstance():setCharactor("fff", "02", "F")

--[[
            local scene = require("src.game.MainScene")

            local gameScene = scene.create()

            if cc.Director:getInstance():getRunningScene() then
                cc.Director:getInstance():replaceScene(gameScene)
            else
                cc.Director:getInstance():runWithScene(gameScene)
            end
            ]]--
        end
    end

    local createBtn = ccui.Helper:seekWidgetByName(node,"Start_Button")
    createBtn:addTouchEventListener(createCallback)
    
    
    local function createCallback(EventCustom)
        wd.TranscodingSend:getRankingList(2)
        
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Start_Main")
		cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Rand_Name")
        --[[
        local scene = require("src.game.MainScene")

        local gameScene = scene.create()

        if cc.Director:getInstance():getRunningScene() then
                cc.Director:getInstance():replaceScene(gameScene)
        else
                cc.Director:getInstance():runWithScene(gameScene)
        end
        ]]
        local scene = require("src.loading.LoadingScene")
        local gameScene = scene.create()

        if cc.Director:getInstance():getRunningScene() then
            cc.Director:getInstance():replaceScene(gameScene)
        else
            cc.Director:getInstance():runWithScene(gameScene)
        end
    end
    

    local listener = cc.EventListenerCustom:create("Start_Main", createCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

	local function onGetRandName()
		local name = wd.GlobalData:getInstance():getRandName()
		nameField:setString(name)
	end

	local listener = cc.EventListenerCustom:create("Get_Rand_Name", onGetRandName)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end


return CreateScene