local MainScene = class("MainScene",function()
    return cc.Scene:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

MainScene.battleLayer = nil

function MainScene.create()
    local scene = MainScene.new()
    
    --cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/toolsImage.plist", "ui/other/toolsImage.png")
    --cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/effect.plist", "ui/other/effect.png")
    --cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/equipEffect.plist", "ui/other/equipEffect.png")
    
    scene:createLayerMenu()
    return scene
end

function MainScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    self.rankingList = nil

    self.battleLayer = nil

	self.chatWholeLayer = nil
	self.chatSystemLayer = nil
	
	self.familyMineLayer = nil
	self.familyListLayer = nil
	
    self.firstChargeBtn = nil

	
    self.mapLabel = nil
    self.mapLevel = wd.GlobalData:getInstance():getLastLoginMapId()
	--self.mapLevel = 1
	self.selectTag = 1
	self.chatTime = 0
	self.firstEnter = true
	self.newQuick = false
	self.newBoss = false
end

function MainScene:destroy()

end


function MainScene:keypadEvent()

    local function onKeyReleased(keyCode, event)
        if keyCode == cc.KeyCode.KEY_BACK then
            wd.SdkApi:exitSdk()
        elseif keyCode == cc.KeyCode.KEY_MENU  then
        end
    end

    local listener = cc.EventListenerKeyboard:create()
    listener:registerScriptHandler(onKeyReleased, cc.Handler.EVENT_KEYBOARD_RELEASED)

    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self)
end

function MainScene:hangsMapStatus()
	local mapName = ""
    local mapCount = wd.GlobalData:getInstance():getMapCount()  --从1开始
	if self.mapLevel < mapCount then
		mapName =  wd.GlobalData:getInstance():getMapName(self.mapLevel)
	else
		mapName = wd.GlobalData:getInstance():getPKMapName(self.mapLevel-101)
	end
    if(self.mapLevel ==  wd.GlobalData:getInstance():getLastLoginMapId()) then
        self.mapLabel:setString(string.format("在[%s]挂机中",mapName))
    else
        self.mapLabel:setString(string.format("正赶往[%s]", mapName))
    end

end

function MainScene:showBattleLayer(level,isBossFight)
    self.mapLevel = level
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(level)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setVisible(false)
        local layerClass = require("src.game.battle.BattleOfflineLayer")
		local layer = layerClass.create()
		layer:setVisible(false)
		self:addChild(layer)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setMapIndex(level,isBossFight)
    end
    self.battleLayer:setNewTipsState(self.newQuick,self.newBoss)
	
    self:hangsMapStatus()
end

function MainScene:setArenaBattle(ranking,name,level)
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setArenaBattle(ranking,name,level)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setArenaBattle(ranking,name,level)
    end
	--[[if name and level then
		wd.showRichTips(wd.tipsType.System,string.format("下一场将PK玩家:%s Lv%d",name,level))
	end--]]
end

function MainScene:setEctypeBattle(ectypeFightFlag,ectypeTag,name) --挑战副本boss
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
    else
        self.battleLayer:setVisible(true)
    end
    self.battleLayer:setEctypeFight(ectypeFightFlag,ectypeTag,name)
end


function MainScene:setFamilyBossBattle(ranking,name,level,hp)
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setFamilyBossBattle(ranking,name,level,hp)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setFamilyBossBattle(ranking,name,level,hp)
    end
    --[[if name and level then
        wd.showRichTips(wd.tipsType.System,string.format("下一场将PK玩家:%s Lv%d",name,level))
    end--]]
end

function MainScene:showChatLayer()
	if self.chatWholeLayer == nil then
		local layerClass = require("game.chat.ChatWholeLayer")
		local layer = layerClass.create()
		self:addChild(layer)
		self.chatWholeLayer = layer
		layer:setVisible(false)
		layer:setPosition(-10000,0)
	else
		self.chatWholeLayer:setPosition(0,0)
		self.chatWholeLayer:setVisible(true)
		self.chatWholeLayer:onEnter()
	end
end

function MainScene:setRevengeFight(revengeFightFlag)
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setRevengeFight(revengeFightFlag)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setRevengeFight(revengeFightFlag)
    end
end

--[[function MainScene:setBossFight(bossFightFlag,name,level)
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setBossFight(bossFightFlag)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setBossFight(bossFightFlag)
    end
	if name and level then
		wd.showRichTips(wd.tipsType.System,string.format("下一场将挑战BOSS:%s Lv%d",name,level))
	end
end--]]

function MainScene:setPKFight(pkFightFlag,name,level)
    if self.battleLayer == nil then
        local class = require("src.game.battle.BattleLayer")
        local layer = class.create()
        layer:createLayerMenu(0)
        self:addChild(layer)
        self.battleLayer = layer
        self.battleLayer:setPKFight(pkFightFlag,name,level)
    else
        self.battleLayer:setVisible(true)
        self.battleLayer:setPKFight(pkFightFlag,name,level)
    end
	--[[if name and level then
		wd.showRichTips(wd.tipsType.System,string.format("下一场将PK玩家:%s Lv%d",name,level))
	end--]]
end

function MainScene:setRanking()

    -- self.rankingList:removeAllItems()

    -- local number = wd.GlobalData:getInstance():getGladiatorCount()
    -- if number > 20 then
    --     number = 20
    -- end
    
    -- local function attrCallback(sender,eventType)
    --     if eventType == ccui.TouchEventType.ended then
    --         --self:showEnemySprite(sender:getTag())
            
    --         local layerClass = require("src.game.arena.PlayerLayer")
    --         local layer = layerClass.create()
    --         layer:createLayerMenu(wd.PlayerType.ENEMY)
    --         self:addChild(layer)
			
    --         wd.TranscodingSend:getPlayerData(sender:getTag())  -- roldId
    --     end
    -- end
    

    -- for i=0,number-1 do
    --     local ranking = i+1
    
    --     local gladiator = wd.GlobalData:getInstance():getGladiatorData(i)
                
    --     local btn = ccui.Button:create("main_ranking_subbox.png", "main_ranking_subbox.png", "", ccui.TextureResType.plistType)
    --     btn:setAnchorPoint(cc.p(0,0))
    --     btn:setTag(gladiator:getRoleId())
    --     btn:addTouchEventListener(attrCallback)
    --     self.rankingList:pushBackCustomItem(btn)

    --     local gladiatorNode = tolua.cast(cc.CSLoader:createNode("ui/main/RankingNode.csb"),"ccui.Widget")
    --     btn:addChild(gladiatorNode)
		
    --     local image = tolua.cast(gladiatorNode:getChildByName("Head_Sprite"), "cc.Sprite")
    --     image:setSpriteFrame(wd.getHeadImageName(gladiator:getOccupation(), gladiator:getSex()))

    --     local job = tolua.cast(gladiatorNode:getChildByName("Job_Title"), "cc.Sprite")
    --     job:setSpriteFrame(wd.getEquipTitleName(gladiator:getOccupation()))

    --     local nameLabel = tolua.cast(gladiatorNode:getChildByName("Name_Label"), "ccui.Text")
    --     nameLabel:setString(gladiator:getName())

    --     local powerLabel = tolua.cast(gladiatorNode:getChildByName("Power_Label"), "ccui.Text")
    --     powerLabel:setString(string.format("%d",gladiator:getPower()))

    --     local levelLabel = tolua.cast(gladiatorNode:getChildByName("Level_Label"), "ccui.Text")
    --     levelLabel:setString(string.format("Lv%d",gladiator:getLevel()))

    --     local rankingLabel = tolua.cast(gladiatorNode:getChildByName("Number_Label"), "ccui.TextAtlas")
    --     rankingLabel:setString(string.format("%d",i+1))
		
	-- 	local rankingBg =  tolua.cast(gladiatorNode:getChildByName("Ranking_Bg"), "cc.Sprite")
        
    --     if ranking > 0 and ranking <= 3 then
    --         local rankingSprite = tolua.cast(gladiatorNode:getChildByName("Ranking_Sprite"), "cc.Sprite")
    --         rankingSprite:setVisible(true)
    --         rankingSprite:setSpriteFrame(string.format("main_ranking_No%d.png",ranking))
	-- 		rankingBg:setSpriteFrame(string.format("main_ranking_bg_No%d.png",ranking))
	-- 		local nameBg = tolua.cast(gladiatorNode:getChildByName("Name_Bg"), "cc.Sprite")
    --         nameBg:setVisible(true)
	-- 	else
	-- 		rankingBg:setSpriteFrame("main_ranking_subbox.png")
    --     end
    -- end
end

function MainScene:checkUpdate()
    local layerClass = require("src.update.UpdateCheckLayer")
    local layer = layerClass.create()
    self:addChild(layer,10)
end

function MainScene:setFlyAnimation(node)

    local bezierTable ={}
    local flyTable ={}
    local originTable ={}


    local bezier1 = {  
        cc.p(-350, 0),  
        cc.p(-700, -100),  
        cc.p(-1150, 400)
    }

    local bezier2 = {  
        cc.p(-350, 100),  
        cc.p(-620, -200),  
        cc.p(-900, 400)
    }

    local bezier3 = {  
        cc.p(-200, -100),  
        cc.p(-300, 0),  
        cc.p(-600, 200)
    }

    bezierTable[1] = bezier1
    bezierTable[2] = bezier2
    bezierTable[3] = bezier3


    local height = (768 - self.visibleSize.height)/2

    local size1 = cc.size(1200,500 - height)
    local size2 = cc.size(1200,400 - height)
    local size3 = cc.size(1200,600 - height)
    
    originTable[1] = size1
    originTable[2] = size2
    originTable[3] = size3


    local fly1Effect = cc.Sprite:create()
    flyTable[1] = fly1Effect
    fly1Effect:setTag(1)
    node:addChild(fly1Effect)

    local fly2Effect = cc.Sprite:create()
    flyTable[2] = fly2Effect
    fly2Effect:setTag(2)
    node:addChild(fly2Effect)

    local fly3Effect = cc.Sprite:create()
    flyTable[3] = fly3Effect
    fly3Effect:setTag(3)
    node:addChild(fly3Effect)


    local animation = cc.Animation:create()
    for i = 1, 7 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("fly_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    
    local function delayCallBackFunc(sender)
        sender:setPosition(originTable[sender:getTag()].width, originTable[sender:getTag()].height)
    end
    
    local i=1

    flyTable[i]:setPosition(originTable[i].width, originTable[i].height)

    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)
    flyTable[i]:runAction(repeatAction)

    local bezierAction = cc.BezierBy:create(8, bezierTable[i])

    local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
    local afterDelayAction = cc.DelayTime:create(1)
    local beforeDelayAction = cc.DelayTime:create(1)
    local sequenceAction = cc.Sequence:create(beforeDelayAction, bezierAction, delayCallBack, afterDelayAction)
    local repeatAction = cc.RepeatForever:create(sequenceAction)

    flyTable[i]:runAction(repeatAction)
    
    local i=2
    
    flyTable[i]:setPosition(originTable[i].width, originTable[i].height)

    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)
    flyTable[i]:runAction(repeatAction)

    local bezierAction = cc.BezierBy:create(6, bezierTable[i])

    local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
    local afterDelayAction = cc.DelayTime:create(1)
    local beforeDelayAction = cc.DelayTime:create(4)
    local sequenceAction = cc.Sequence:create(beforeDelayAction, bezierAction, delayCallBack, afterDelayAction)
    local repeatAction = cc.RepeatForever:create(sequenceAction)

    flyTable[i]:runAction(repeatAction)
    
    local i=3

    flyTable[i]:setPosition(originTable[i].width, originTable[i].height)

    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)
    flyTable[i]:runAction(repeatAction)

    local bezierAction = cc.BezierBy:create(5, bezierTable[i])

    local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
    local afterDelayAction = cc.DelayTime:create(1)
    local beforeDelayAction = cc.DelayTime:create(6)
    local sequenceAction = cc.Sequence:create(beforeDelayAction, bezierAction, delayCallBack, afterDelayAction)
    local repeatAction = cc.RepeatForever:create(sequenceAction)

    flyTable[i]:runAction(repeatAction)

end

function MainScene:createLayerMenu()

    local role = wd.GlobalData:getInstance():getRoleData()

    local mainLayer = tolua.cast(cc.CSLoader:createNode("ui/main/MainScene.csb"), "ccui.Widget")
    self:addChild(mainLayer)
    mainLayer:setContentSize(self.visibleSize)
    mainLayer:setPosition(self.origin)

    ccui.Helper:doLayout(mainLayer)
	
	-- tipsLayer
	local tipsLayerClass = require("src.tips.SystemTipsLayer")
	tipsLayerClass:create()
	local tipsLayer = tipsLayerClass:getInstance()
    self:addChild(tipsLayer,100)
	tipsLayer:setPosition(cc.p(0,0))
    
	-- AttributeTipsLayer
	local tipsLayerClass = require("src.tips.AttributeTipsLayer")
	tipsLayerClass:create()
	local tipsLayer = tipsLayerClass:getInstance()
    self:addChild(tipsLayer,101)
	tipsLayer:setPosition(cc.p(0,0))
	
	--RichTipsLayer
	local tipsLayerClass = require("src.tips.RichTipsLayer")
	tipsLayerClass:create()
	local tipsLayer = tipsLayerClass:getInstance()
    self:addChild(tipsLayer,102)
	tipsLayer:setPosition(cc.p(0,0))
	
    local roleSprite = tolua.cast(mainLayer:getChildByName("Role_Sprite"), "cc.Sprite")
    roleSprite:setSpriteFrame(wd.getPlayerImageName(role:getOccupation(), role:getSex()))
	if role:getSex() == 0 then
        roleSprite:setFlippedX(true)
    else
        roleSprite:setFlippedX(false)
    end
	local scaleBig = cc.ScaleBy:create(0.5,1.01)
	local reverseBig = scaleBig:reverse()
	local scaleSmall = cc.ScaleBy:create(0.5,0.98)
	local reverseSmall = scaleSmall:reverse()
	local sequence = cc.Sequence:create(scaleBig,reverseBig,scaleSmall,reverseSmall)
	local repeatAct = cc.RepeatForever:create(sequence)
	roleSprite:runAction(repeatAct)
	
    local propertyPanel = mainLayer:getChildByName("Panel_property")
    
    local playerHead = tolua.cast(propertyPanel:getChildByName("Player_Head"), "cc.Sprite")
    playerHead:setSpriteFrame(wd.getHeadImageName(role:getOccupation(), role:getSex()))

    local nameLabel = tolua.cast(propertyPanel:getChildByName("Name_Label"), "ccui.Text")
    local levelLabel = tolua.cast(propertyPanel:getChildByName("Level_Label"), "ccui.TextAtlas")
    local powerLabel = tolua.cast(propertyPanel:getChildByName("Power_Label"), "ccui.TextAtlas")
    local vipLabel = tolua.cast(propertyPanel:getChildByName("Vip_Label"), "ccui.TextAtlas")
    local goldLabel = tolua.cast(propertyPanel:getChildByName("Gold_Label"), "ccui.Text")
    local gemLabel = tolua.cast(propertyPanel:getChildByName("Gem_Label"), "ccui.Text")
    local mapLabel = tolua.cast(propertyPanel:getChildByName("Map_Label"), "ccui.Text")
    self.mapLabel = mapLabel
    
    local expBar = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Exp_Progress"), "ccui.LoadingBar")
    local expLabel = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Exp_Label"), "ccui.Text")

    --战斗力燃烧动画
    local attackEffect = tolua.cast(propertyPanel:getChildByName("main_power_title"):getChildByName("Attack_Effect"), "cc.Sprite")
    local animation = cc.Animation:create()
    for i = 1, 10 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("fightingCapacity_%02d.png", i)))
    end
    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)
    attackEffect:runAction(repeatAction)


    local function updateData()

        nameLabel:setString(role:getName())
        levelLabel:setString(wd.int2string(role:getLevel()))
        powerLabel:setString(wd.int2string(role:getPower()))
        vipLabel:setString(wd.int2string(role:getVip()))
        goldLabel:setString(wd.int2string(role:getGold()))
        gemLabel:setString(wd.int2string(role:getGem()))
        print(role:getGem())
		if role:getExp()>= role:getExp_max() then
			expBar:setPercent(100);
			expLabel:setString(string.format("%d/已满级 (100%%)", role:getExp()));
		else
			expBar:setPercent(role:getExp()/role:getExp_max()*100);
			expLabel:setString(string.format("%d/%d (%0.1f%%)", role:getExp(), role:getExp_max(), role:getExp()/role:getExp_max()*100));
		end
    end

    local roleBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Role_Button"), "ccui.Button")
	local x,y = roleBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.Role] = {}
	wd.newGuidePos[wd.newGuideStep.Role].pos = roleBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.Role].size = roleBtn:getContentSize()
    roleBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.RoleLayer")
                local layer = layerClass.create()
                self:addChild(layer)
				--local event = cc.EventCustom:new("Handle_NewGuile")
				--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
            end
        end
    )
    
    local pkMapBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"map_pk_btn"), "ccui.Button")
    pkMapBtn:setPressedActionEnabled(true)
    pkMapBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local isOpen,msg = wd.checkOpen(wd.openKey.PkMap)
				if isOpen then
					local event = cc.EventCustom:new("Check_New_Tip")
                    cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                    wd.pkHandler:requestPKPlayerList()
                    local layerClass = require("src.game.map.PKMapLayer")
                    local layer = layerClass.create()
                    self:addChild(layer)
				else
					wd.showRichTips(3,msg)
				end
            end
        end
    )
    local pkMapSprite = tolua.cast(pkMapBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
	local roleSubBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Role_Sub_Button"), "ccui.Button")
	roleSubBtn:setPressedActionEnabled(true)
    
    ------------------------------新手引导----------------------------
    
    local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
    if clippingLayer then
       clippingLayer:setGuidance(roleSubBtn,30,50,115,115)
       local msgTable = {}
       local msg = {}
       table.insert(msg,"欢迎来到杀敌爆装的世界，现在请按我的指引穿戴起")
       table.insert(msg,"{r=[武器]}")
       table.insert(msg,"装备！")
       table.insert(msgTable,msg)
       clippingLayer:setMsg(msgTable)
       self:addChild(clippingLayer)
    end
    
    ------------------------------------------------------------------
    
    roleSubBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.RoleLayer")
                local layer = layerClass.create()
                self:addChild(layer)
                if clippingLayer then
                    clippingLayer:removeFromParent()
                    clippingLayer = nil
                end
            end
        end
    )
	local roleNewSprite = tolua.cast(roleSubBtn:getChildByName("Tips_Effect"), "cc.Sprite")

    local battleBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Battle_Button"), "ccui.Button")
	local x,y = battleBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.Battle] = {}
	wd.newGuidePos[wd.newGuideStep.Battle].pos = battleBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.Battle].size = battleBtn:getContentSize()
    battleBtn:setPressedActionEnabled(true)
    battleBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:showBattleLayer(self.mapLevel)
				-- if cc.UserDefault:getInstance():getBoolForKey("FirstBattle") then
				-- 	local newLayerClass = require("src.game.NewWelcomeLayer")
				-- 	local newLayer = newLayerClass.create()
				-- 	newLayer:createLayerMenu(wd.newWelcomeKey.Battle)
				-- 	self.battleLayer:addChild(newLayer)
				-- end
				--local event = cc.EventCustom:new("Handle_NewGuile")
				--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				
            end
        end
    )
    
    ------------------------------新手引导打开挂机地图----------------------------
    local openBattle = function(EventCustom)
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(battleBtn,30,50,115,115)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"现在已学会穿戴和强化装备了，咱们进入地图")
            table.insert(msg,"{r=[战斗]}")
            table.insert(msg,"吧！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            battleBtn:addTouchEventListener(function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    self:showBattleLayer(self.mapLevel)
                    if clippingLayer then
                        local event = cc.EventCustom:new("guidance_battleIsOpen")
                        cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                        clippingLayer:removeFromParent()
                        clippingLayer = nil
                    end
                end
            end)
        end
    end
    local listener = cc.EventListenerCustom:create("guidance_battleOpen", openBattle)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    --------------------------------------------------------------------
    
    
    local battleEffect = tolua.cast(battleBtn:getChildByName("Battle_Effect"), "cc.Sprite")
	local battleNewSprite = tolua.cast(battleBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    local animation = cc.Animation:create()
    for i = 1, 12 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("battle_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    battleEffect:runAction(repeatAction)

    local ectypeBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Ectype_Button"), "ccui.Button")
    ectypeBtn:setPressedActionEnabled(true)
    ectypeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local isOpen,msg = wd.checkOpen(wd.openKey.Ectype)
				if isOpen then
                    local layerClass = require("src.game.ectype.EctypeScene")
                    local layer = layerClass.create()
                    self:addChild(layer)
				else
					wd.showRichTips(3,msg)
				end
            end
        end
    )
    
    wd.TranscodingSend:getMonthCardAwardState()
    local monthCardBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"month_card"), "ccui.Button")
    monthCardBtn:setPressedActionEnabled(true)
    monthCardBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.monthCard.MonthCardScene")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    
    local monthCardNewSprite = tolua.cast(monthCardBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    
    
    
    local newcomerBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Newcomer_Button"), "ccui.Button")
    newcomerBtn:setPressedActionEnabled(true)
    
    local giftNum = tonumber(role:getRoleExtendData("online_gift"))
    if giftNum < 5 then
        local giftTime = tonumber(role:getRoleExtendData("online_gift_time"))
        local data = require("res.config.xinshouhaoli")
        local leftTime = tolua.cast(newcomerBtn:getChildByName("gift_time"), "ccui.Text")
        
        local nowTime,hour,minute,second
        local endTime = giftTime + data[giftNum + 1].time

        newcomerBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    local layerClass = require("src.game.newcomerGift.NewcomerGiftTips")
                    local layer = layerClass.create()
                    layer:createLayerMenu()
                    self:addChild(layer)
                end
            end
        )
        
        local function changeNewcomer()
            wd.showRichTips(4,"领取成功")
            giftNum = tonumber(role:getRoleExtendData("online_gift"))
            giftTime = tonumber(role:getRoleExtendData("online_gift_time"))
            endTime = giftTime + data[giftNum + 1].time
        end
        local listener = cc.EventListenerCustom:create("get_newcomer_gift", changeNewcomer)
        cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
        
        local function countDown()
            if giftNum >= 5 then
                cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("get_newcomer_gift")
                newcomerBtn:stopAllActions()
                newcomerBtn:setVisible(false)
                return
            end 
            nowTime = endTime - os.time()
            if nowTime > 0 then
                hour = math.floor(nowTime/3600)
                minute = math.floor((nowTime - hour * 3600)/60)
                second = nowTime%60
                leftTime:setString(string.format("%02d:%02d:%02d",hour,minute,second))
            else
                leftTime:setString("可领取")
                -- giftNum = tonumber(role:getRoleExtendData("online_gift"))
                -- giftTime = tonumber(role:getRoleExtendData("online_gift_time"))
                -- endTime = giftTime + data[giftNum + 1].time
            end
        end 

        local delay = cc.DelayTime:create(1.0)
        local sequence = cc.Sequence:create(cc.CallFunc:create(countDown),delay)
        newcomerBtn:runAction(cc.RepeatForever:create(sequence))
    else
        newcomerBtn:setVisible(false)
    end
    

    local packageBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Package_Button"), "ccui.Button")
	local x,y = packageBtn:getPosition()
	wd.packageBtnPos = packageBtn:getParent():convertToWorldSpace(cc.p(x,y))
    packageBtn:setPressedActionEnabled(true)
    packageBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.package.PackageEquipLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	local packageNewSprite = tolua.cast(packageBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    
    local skillBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Skill_Button"), "ccui.Button")
    skillBtn:setPressedActionEnabled(true)
    skillBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.skill.SkillLayer")
                local layer = layerClass.create()
                self:addChild(layer)
				-- if cc.UserDefault:getInstance():getBoolForKey("FirstSkill") then
				-- 	local newLayerClass = require("src.game.NewWelcomeLayer")
				-- 	local newLayer = newLayerClass.create()
				-- 	newLayer:createLayerMenu(wd.newWelcomeKey.Skill)
				-- 	layer:addChild(newLayer)
				-- end
            end
        end
    )
	local skillNewSprite = tolua.cast(skillBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
	local shopBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Shop_Button"), "ccui.Button")
    shopBtn:setPressedActionEnabled(true)
    shopBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				wd.shopHandler:requestOpenShop()
				
                local layerClass = require("src.game.shop.ShopItemLayer")
                local layer = layerClass.create()
                self:addChild(layer)
                -- wd.showRichTips(4,"暂未开放")
            end
        end
    )
    
	local shopEffect = tolua.cast(shopBtn:getChildByName("Shop_Effect"), "cc.Sprite")

    local animation = cc.Animation:create()
    for i = 1, 25 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("shop_%02d.png", i)))
    end
    
    animation:setDelayPerUnit(0.15)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    shopEffect:runAction(repeatAction)
	
	local settingBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Setting_Button"), "ccui.Button")
    settingBtn:setPressedActionEnabled(true)
    settingBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.setting.SettingLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	
	local mailBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Mail_Button"), "ccui.Button")
    mailBtn:setPressedActionEnabled(true)
    mailBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.mailHandler :requestOpenMail()
                    
                local layerClass = require("src.game.mail.MailLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	local mailNewSprite = tolua.cast(mailBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
    local tripodBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Tripod_Button"), "ccui.Button")
    tripodBtn:setPressedActionEnabled(true)
    tripodBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.tripod.MeltingLayer")
                local layer = layerClass.create()
                self:addChild(layer)
				-- if cc.UserDefault:getInstance():getBoolForKey("FirstTripod") then
				-- 	local newLayerClass = require("src.game.NewWelcomeLayer")
				-- 	local newLayer = newLayerClass.create()
				-- 	newLayer:createLayerMenu(wd.newWelcomeKey.Tripod)
				-- 	layer:addChild(newLayer)
				-- end
            end
        end
    )
	local tripodNewSprite = tolua.cast(tripodBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    
    local tripodEffect = tolua.cast(tripodBtn:getChildByName("Tripod_Effect"), "cc.Sprite")

    local animation = cc.Animation:create()
    for i = 1, 12 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("tripod_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.05)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    tripodEffect:runAction(repeatAction)
    
    local arenaBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Arena_Button"), "ccui.Button")
    arenaBtn:setPressedActionEnabled(true)
    arenaBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local isOpen,msg = wd.checkOpen(wd.openKey.Arena)
				if isOpen then
					local layerClass = require("src.game.arena.ArenaLayer")
					local layer = layerClass.create(cc.p(self.visibleSize.width/2-140,self.visibleSize.height/2-70))
					self:addChild(layer)
					-- if cc.UserDefault:getInstance():getBoolForKey("FirstArena") then
					-- 	local newLayerClass = require("src.game.NewWelcomeLayer")
					-- 	local newLayer = newLayerClass.create()
					-- 	newLayer:createLayerMenu(wd.newWelcomeKey.Arena)
					-- 	layer:addChild(newLayer)
					-- end
				else
					wd.showRichTips(3,msg)
				end
            end
        end
    )
	local arenaNewSprite = tolua.cast(arenaBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    
    local arenaEffect = tolua.cast(mainLayer:getChildByName("Panel_1"):getChildByName("Arena_Effect"), "cc.Sprite")

    local animation = cc.Animation:create()
    for i = 1, 12 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("arena_%02d.png", i)))
    end
    
    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    arenaEffect:runAction(repeatAction)
    
	local firstChargeBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Firstcharge_Button"), "ccui.Button")
    firstChargeBtn:setPressedActionEnabled(true)
    firstChargeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.firstcharge.FirstChargeLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	local firstChargeEffect = tolua.cast(firstChargeBtn:getChildByName("Firstcharge_Effect"), "cc.Sprite")
	firstChargeEffect:setLocalZOrder(-1)
    local animation = cc.Animation:create()
    for i = 1, 10 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("firstcharge_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.15)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    firstChargeEffect:runAction(repeatAction)
	
	
	local chargeBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Charge_Button"), "ccui.Button")
    chargeBtn:setPressedActionEnabled(true)
    chargeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --wd.showSystemTips("暂未开放")
				local layerClass = require("src.game.charge.ChargeLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	local chargeEffect = tolua.cast(chargeBtn:getChildByName("Charge_Effect"), "cc.Sprite")
    local animation = cc.Animation:create()
    for i = 1, 11 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("charge_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.15)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    chargeEffect:runAction(repeatAction)
	
    if role:getChargeDouble() or role:getChargeFirst() then
        firstChargeBtn:setVisible(true)
		chargeBtn:setVisible(false)
    else
        firstChargeBtn:setVisible(false)
		chargeBtn:setVisible(true)
    end
    
    -- if role:getChargeDouble() == true or role:getChargeFirst() == true then
    --     firstChargeBtn:setVisible(true)
	-- 	chargeBtn:setVisible(false)
    -- else
    --     firstChargeBtn:setVisible(false)
	-- 	chargeBtn:setVisible(true)
    -- end
	
	local soulBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Soul_Button"), "ccui.Button")
    soulBtn:setPressedActionEnabled(true)
    soulBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local isOpen,msg = wd.checkOpen(wd.openKey.SoulShop)
				if isOpen then
					local layerClass = require("src.game.soul.SoulShopLayer")
					local layer = layerClass.create()
					self:addChild(layer)
				else
					wd.showRichTips(3,msg)
				end
                -- wd.showRichTips(4,"暂未开放")
            end
        end
    )
	local soulNewSprite = tolua.cast(soulBtn:getChildByName("Tips_Effect"), "cc.Sprite")
    
	local soulEffect = tolua.cast(soulBtn:getChildByName("Soul_Effect"), "cc.Sprite")

    local animation = cc.Animation:create()
    for i = 1, 12 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("soul_%02d.png", i)))
    end
    
    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    soulEffect:runAction(repeatAction)
	
	local activtyBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Activty_Button"), "ccui.Button")
    activtyBtn:setPressedActionEnabled(true)
    activtyBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.activity.ActivityLayer")
                local layer = layerClass.create()
                self:addChild(layer)
                -- wd.showRichTips(4,"暂未开放")
            end
        end
    )
	local activityNewSprite = tolua.cast(activtyBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
	local lotteryBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Lottery_Button"), "ccui.Button")
    lotteryBtn:setPressedActionEnabled(true)
    lotteryBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.activity.LotteryLayer")
                local layer = layerClass.create()
                self:addChild(layer)

		        wd.activityHandler:requestOpenLottery()
            end
        end
    )
    
    local looteryStartTime = wd.GlobalData:getInstance():getActivityStartTime(106)
    local looteryEndTime = wd.GlobalData:getInstance():getActivityEndTime(106)
    
    if os.time() < looteryEndTime and os.time() >= looteryStartTime then
        local delay = cc.DelayTime:create(2)
        local fun = cc.CallFunc:create(function() 
            if os.time() > looteryEndTime then
                lotteryBtn:stopAllActions()
                lotteryBtn:setVisible(false)
            end  
        end)
        local action = cc.RepeatForever:create(cc.Sequence:create(fun,delay))
        lotteryBtn:runAction(action)
        lotteryBtn:setVisible(true)
    end
    
	local lotteryNewSprite = tolua.cast(lotteryBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
	local sevendaysBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Sevendays_Button"), "ccui.Button")
    sevendaysBtn:setPressedActionEnabled(true)
    sevendaysBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --wd.showSystemTips("暂未开放")
                -- local layerClass = require("src.game.activity.SevenDayLayer")
				local layerClass = require("src.game.activity.OpenActScene")
                local layer = layerClass.create()
                self:addChild(layer)
                wd.activityHandler:requestStartActivityState()
				wd.activityHandler:requestOpenActData()
            end
        end
    )
	local sevendaySprite = tolua.cast(sevendaysBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	local sevendayEffect = tolua.cast(sevendaysBtn:getChildByName("Firstcharge_Effect"), "cc.Sprite")
	sevendayEffect:setLocalZOrder(-1)
    local animation = cc.Animation:create()
    for i = 1, 10 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("firstcharge_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.15)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    sevendayEffect:runAction(repeatAction)
	
	
	print(os.date("%x",wd.GlobalData:getInstance():getServerOpenTime()))
	print(os.date("%x",desTime))
	local desTime = (os.time()-wd.GlobalData:getInstance():getLoginTimeDifference()) - wd.GlobalData:getInstance():getServerOpenTime()
	if desTime < 0 then
		desTime = 0
	else
		desTime = 6*24*3600 - desTime
		if desTime < 0 then
			desTime = 0
		end
	end
	
	if desTime <= 0 then
		sevendaysBtn:setVisible(false)
	else
		sevendaysBtn:setVisible(true)
	end
    
    local vipBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"VIP_Button"), "ccui.Button")
    vipBtn:setPressedActionEnabled(true)
    vipBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --wd.showSystemTips("暂未开放")
                local layerClass = require("src.game.charge.VipLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    local vipNewSprite = tolua.cast(vipBtn:getChildByName("Tips_Effect"), "cc.Sprite")


	---------------------family-----------------------------------------------------------------------------
	
	local guildBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Guild_Button"), "ccui.Button")
    guildBtn:setPressedActionEnabled(true)
    guildBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local isOpen,msg = wd.checkOpen(wd.openKey.Family)
				if isOpen then
					wd.familyHandler:requestOpenFamily()
				else
					wd.showRichTips(3,msg)
				end
                -- wd.showRichTips(4,"暂未开放")
            end
        end
    )
	
    local guildEffect = tolua.cast(guildBtn:getChildByName("Guild_Effect"), "cc.Sprite")
    local animation = cc.Animation:create()
    for i = 1, 12 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("family_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.15)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    local repeatAction = cc.RepeatForever:create(action)

    guildEffect:runAction(repeatAction)
    
    
	-- havenot join family
	local function onOpenFamilyList()
		wd.familyHandler:requestGetAllFamilyInfo()
		local layerClass = require("game.family.Family_List_AllLayer")
		self.familyListLayer = layerClass.create()
		self.familyListLayer:setFamilyListType(wd.familyListType.Unjoined)
		self.familyListLayer:createLayerMenu()
		self:addChild(self.familyListLayer)
	end
	local listenerOpenList = cc.EventListenerCustom:create("Have_Not_Join_Family", onOpenFamilyList)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerOpenList, 1)
	
	local function onRemoveFamilyListLayer()
		if self.familyListLayer ~= nil then
			self.familyListLayer = nil
		end
	end
	local listenerOpenFamily = cc.EventListenerCustom:create("RemoveFamilyListLayer", onRemoveFamilyListLayer)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerOpenFamily, 1)
	
	-- have join family
	local function onOpenMyFamily()
		onRemoveFamilyListLayer()
		if not self.familyMineLayer then
			local layerClass = require("game.family.Family_Member_InfoLayer")
			self.familyMineLayer = layerClass.create()
			self:addChild(self.familyMineLayer)
		else
			local event = cc.EventCustom:new("Upgrade_FamilyInfo")
			cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
		end
	end
	local listenerOpenFamily = cc.EventListenerCustom:create("Open_Family", onOpenMyFamily)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerOpenFamily, 1)
	
	local function onRemoveFamilyMineLayer()
		if self.familyMineLayer ~= nil then
			self.familyMineLayer = nil
		end
	end
	local listenerOpenFamily = cc.EventListenerCustom:create("RemoveFamilyMineLayer", onRemoveFamilyMineLayer)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerOpenFamily, 1)
	
----------------------------------------------------------------------------------------------------------------------------
	
	local giftBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Gift_Button"), "ccui.Button")
    giftBtn:setPressedActionEnabled(true)
    giftBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				wd.giftHandler:requestFinishAwardState()
                local layerClass = require("game.gift.GiftAchieveLayer")
                local layer = layerClass.create()
                self:addChild(layer)
                if self.clippingLayer then
                    self.clippingLayer:removeFromParent()
                    self.clippingLayer = nil
                end
            end
        end
    )
    ------------------------------新手引导----------------------------
    local listener = cc.EventListenerCustom:create("guidance_giftOpen", function(EventCustom) 
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(giftBtn,30,50,115,80)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"{r=[成就]}")
            table.insert(msg,"在这里，以后要按时领取奖励哦！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            self.clippingLayer = clippingLayer
        end
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    --------------------------------------------------------------------

    local checkInBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"CheckIn_Button"), "ccui.Button")
    checkInBtn:setPressedActionEnabled(true)
    checkInBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("game.checkIn.CheckInLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    
    local giftNewSprite = tolua.cast(giftBtn:getChildByName("Tips_Effect"), "cc.Sprite")
	
	local chatBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Chat_Button"), "ccui.Button")
    chatBtn:setPressedActionEnabled(true)
    chatBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:showChatLayer()
				if self.firstEnter then
					local event = cc.EventCustom:new("Get_Chat_Msg")
					cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
					self.firstEnter = false
				end
            end
        end
    )
	
	local chatSubBox = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Chat_ScrollBox"), "ccui.Layout")
	local function getMsgCallBack(EventCustom)
		if os.time() - self.chatTime >= 5 then
			local chatName,chatMsg = wd.chatHandler:getLastMsgWord()
			if chatName and chatMsg then
				local chatSprite = cc.Sprite:create()
				local nameLabel = ccui.Text:create()
				local msgLabel = ccui.Text:create()
				nameLabel:setString(string.format("%s: ",chatName))
				msgLabel:setString(chatMsg)
				nameLabel:setFontSize(20)
				msgLabel:setFontSize(20)
				nameLabel:setAnchorPoint(cc.p(0,0.5))
				msgLabel:setAnchorPoint(cc.p(0,0.5))
				nameLabel:setColor(cc.c3b(0xff,0,0))
				chatSprite:setContentSize(cc.size(nameLabel:getContentSize().width+msgLabel:getContentSize().width,30))
				chatSprite:addChild(nameLabel)
				nameLabel:addChild(msgLabel)
				nameLabel:setPosition(cc.p(0,0))
				msgLabel:setPosition(cc.p(nameLabel:getContentSize().width,nameLabel:getContentSize().height/2))
				chatSubBox:addChild(chatSprite)
				chatSprite:setPosition(cc.p(chatSubBox:getContentSize().width+chatSprite:getContentSize().width/2,chatSubBox:getContentSize().height))
				local moveBy = cc.MoveBy:create((chatSprite:getContentSize().width+chatSubBox:getContentSize().width)/100,cc.p(-(chatSprite:getContentSize().width+chatSubBox:getContentSize().width),0))
				local function moveByCallBack() 
					chatSprite:removeFromParent()
				end
				local moveByCallBackFunc = cc.CallFunc:create(moveByCallBack)
				local sequence = cc.Sequence:create(moveBy,moveByCallBackFunc)
				chatSprite:runAction(sequence)
			end
			self.chatTime = os.time()
		end
	end
	local listenerGetMsg = cc.EventListenerCustom:create("Get_Chat_Msg", getMsgCallBack)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerGetMsg, 1)
	
	
    local rankingList = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Ranking_ListView"), "ccui.ListView")
    self.rankingList = rankingList
    
    local rankingBtn = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Ranking_Button"), "ccui.Button")
    rankingBtn:setPressedActionEnabled(true)
    rankingBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.ranking.LevelRankingLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    
    local function updateCallback(EventCustom)
        updateData()
        
        if role:getChargeDouble() == true or role:getChargeFirst() == true then
            firstChargeBtn:setVisible(true)
			chargeBtn:setVisible(false)
        else
            firstChargeBtn:setVisible(false)
			chargeBtn:setVisible(true)
        end
        
    end

    local listener = cc.EventListenerCustom:create("Update_Main", updateCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function battleWinCallback(EventCustom)
		local expStr = string.format("经验+%d",wd.GlobalData:getInstance():getBattleResultExp())
		local goldStr = string.format("+%d",wd.GlobalData:getInstance():getBattleResultGold())
		local fontSize = goldLabel:getFontSize()
		local expX,expY = expLabel:getPosition()
		local expPos = expLabel:getParent():convertToWorldSpace(cc.p(expX,expY+10))
		local goldX,goldY = goldLabel:getPosition()
		local goldPos = goldLabel:getParent():convertToWorldSpace(cc.p(goldX,goldY-fontSize*2))
		
		local expShowLabel = ccui.Text:create()
		local goldShowLabel = ccui.Text:create()
		expShowLabel:setFontSize(fontSize)
		goldShowLabel:setFontSize(fontSize)
		expShowLabel:setColor(cc.c3b(0,255,0))
		goldShowLabel:setColor(cc.c3b(0,255,0))
		expShowLabel:setString(expStr)
		goldShowLabel:setString(goldStr)
        expBar:addChild(expShowLabel)
		goldLabel:addChild(goldShowLabel)
		expShowLabel:setPosition(cc.p(160,36))
		goldShowLabel:setPosition(cc.p(goldLabel:getContentSize().width+20,12))
		local expDelayTime = cc.DelayTime:create(2)
		local expFadeout = cc.FadeOut:create(2)
		local function expCallBack()
			expShowLabel:removeFromParent()
		end
		local expCallBackFunc = cc.CallFunc:create(expCallBack)
		local expSequence = cc.Sequence:create(expDelayTime,expFadeout,expCallBackFunc)
		local goldDelayTime = cc.DelayTime:create(2)
		local goldFadeout = cc.FadeOut:create(2)
		local function goldCallBack()
			goldShowLabel:removeFromParent()
		end
		local goldCallBackFunc = cc.CallFunc:create(goldCallBack)
		local goldSequence = cc.Sequence:create(goldDelayTime,goldFadeout,goldCallBackFunc)
		expShowLabel:runAction(expSequence)
		goldShowLabel:runAction(goldSequence)
		--[[wd.showSystemTips(expStr,cc.c3b(0,255,0),fontSize,expPos)
		wd.showSystemTips(goldStr,cc.c3b(0,255,0),fontSize,goldPos)--]]
	end	
	local listener = cc.EventListenerCustom:create("Battle_Win", battleWinCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    updateData()
    self:showBattleLayer(self.mapLevel)
    self:showChatLayer()
    
    local backGround = tolua.cast(ccui.Helper:seekWidgetByName(mainLayer,"Panel_BackGround"), "ccui.Widget")

    self:setFlyAnimation(backGround)
    
    -- self:setRanking()
    
    self:keypadEvent()
    
    self:checkUpdate()
	
	self:handleNewGuide()
	
	
	local function checkNewFlag()
		--wd.TranscodingSend:getVipItemList()

		-- tripod
		if wd.GlobalData:getInstance():getEquipItemCount() >= 20 then
			wd.showNewTipsEffect(tripodNewSprite)
		else
			wd.hideNewTipsEffect(tripodNewSprite)
		end

		-- skill 
		if wd.GlobalData:getInstance():getToolsItemCountForId(wd.ItemId.SkillDrug) >= 10 then
			wd.showNewTipsEffect(skillNewSprite)
		else
			wd.hideNewTipsEffect(skillNewSprite)
		end
		
		-- soul
		if wd.GlobalData:getInstance():getToolsItemCountForId(wd.ItemId.SoulToken) > 0 then
			wd.showNewTipsEffect(soulNewSprite)
		else
			wd.hideNewTipsEffect(soulNewSprite)
		end
		
		-- battle
		if role:getQuickBattleBuy() > 0 then
			wd.showNewTipsEffect(battleNewSprite)
			
			if role:getQuickBattleBuy() > 0 then
				self.newQuick = true
			else
				self.newQuick = false
			end
			-- if role:getBossChallengeNum() > 0 then
			-- 	self.newBoss = true
			-- else
			-- 	self.newBoss = false
			-- end
			
		else
			wd.hideNewTipsEffect(battleNewSprite)
			self.newQuick = false
			self.newBoss = false
		end
		if self.battleLayer then
			self.battleLayer:setNewTipsState(self.newQuick,self.newBoss)
		end
		
		-- arena
		if role:getChallengeNumber() > 0 then
			wd.showNewTipsEffect(arenaNewSprite)
		else
			wd.hideNewTipsEffect(arenaNewSprite)
		end
		
        
        -- mapPk
        local isOpen,msg = wd.checkOpen(wd.openKey.PkMap)
		if wd.GlobalData:getInstance():getRolePkNumber() > 0 and isOpen then
            wd.showNewTipsEffect(pkMapSprite)
        else
            local pkEndTime = tonumber(wd.GlobalData:getInstance():getRoleData():getRoleExtendData("end_time"))
		    if pkEndTime and pkEndTime > 0 and pkEndTime < os.time() and tonumber(wd.GlobalData:getInstance():getRoleData():getRoleExtendData("finish")) == 0 then 
                wd.showNewTipsEffect(pkMapSprite)
            else
                wd.hideNewTipsEffect(pkMapSprite)
            end
		end

        --kaifuhuodong
        -- local sevendaySpriteVisible = false
        -- local sevenDayList = wd.activityHandler:getSevenDayList()
		-- for index,awardItem in ipairs(sevenDayList) do
        --     if awardItem.state == 1 then
        --         sevendaySpriteVisible = true
        --         break
        --     end
        -- end
        -- if not sevendaySpriteVisible then
        --     for n = 1,7 do
        --         local data = wd.activityHandler:getAwardListByOpenActType(n)
        --         for index,awardItem in ipairs(data) do
        --             if awardItem.state == 1 then
        --                 sevendaySpriteVisible = true
        --                 break
        --             end
        --         end
        --         if sevendaySpriteVisible then
        --             break
        --         end
        --     end
        -- end
        
        -- if sevendaySpriteVisible then
        --     wd.showNewTipsEffect(sevendaySprite)
        -- else 
        --     wd.hideNewTipsEffect(sevendaySprite)
        -- end
        

		-- role
		if wd.GlobalData:getInstance():checkHaveCanWearEquip() then
			wd.showNewTipsEffect(roleNewSprite)
		else
            local can_best = false
            for i = wd.WearRegion.WEAPON , wd.WearRegion.RRING do 
                can_best = wd.GlobalData:getInstance():checkHaveBestWearEquipByRegion(i);
                if can_best then
                    break;
                end
            end

            if can_best then
                wd.showNewTipsEffect(roleNewSprite)
            else 
                wd.hideNewTipsEffect(roleNewSprite)
            end
		end
		
		-- vip
		local vipLevel = wd.GlobalData:getInstance():getRoleVip()
		local hasVipNew = false
		for i = 0,vipLevel do
			local vipItem = wd.GlobalData:getInstance():getVipXmlData(i)
			if vipItem ~= nil then
				if not vipItem:getIsBuy() then
					wd.showNewTipsEffect(vipNewSprite)
					hasVipNew = true
					break
				end
			end
		end
		if hasVipNew == false then
			wd.hideNewTipsEffect(vipNewSprite)
		end
		
		-- lottery
		if role:getNewLuck() then
			wd.showNewTipsEffect(lotteryNewSprite)
		else
			wd.hideNewTipsEffect(lotteryNewSprite)
		end
		
		-- achieve
		if role:getNewAchieve() then
			wd.showNewTipsEffect(giftNewSprite)
		else
			wd.hideNewTipsEffect(giftNewSprite)
		end
		
        
        -- monthCard
        wd.hideNewTipsEffect(monthCardNewSprite)
        for i = 0 ,1 do
            local monthCardItem = wd.GlobalData:getInstance():getMonthCardItem(i)
            if monthCardItem and monthCardItem:getActivityState() == wd.awardState.CanGet then
                wd.showNewTipsEffect(monthCardNewSprite)
                break
            end 
        end
        
		-- activity
		if role:getNewActivity() then
			wd.showNewTipsEffect(activityNewSprite)
		else
			wd.hideNewTipsEffect(activityNewSprite)
		end
		
		-- mail
		if role:getNewMail() then
			wd.showNewTipsEffect(mailNewSprite)
		else
			wd.hideNewTipsEffect(mailNewSprite)
		end
	end
	
	checkNewFlag()
	local listener = cc.EventListenerCustom:create("Check_New_Tip", checkNewFlag)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);


    local function alertPromt( )
        local alertLayer = require("src.game.AlertLayer")
        local layer = alertLayer.create()
        self:addChild(layer,11)
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Check_Login_Again")
    end
    local listener = cc.EventListenerCustom:create("Check_Login_Again", alertPromt)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

end

function MainScene:handleNewGuide()
	-- if wd.GlobalData:getInstance():getCreateRoleFlag() then
	-- 	print("do newguide.......")
	-- 	local layerClass = require("src.game.WelcomeLayer")
	-- 	local layer = layerClass.create()
	-- 	self:addChild(layer,10)
	-- end
end

return MainScene