
local NewWelcomeLayer = class("NewWelcomeLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function NewWelcomeLayer.create()
    local layer = NewWelcomeLayer.new()
    --layer:createLayerMenu()
    return layer
end

function NewWelcomeLayer:ctor()
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/newguide/newguide.plist", "ui/newguide/newguide.png")
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.fontSize = 23
	self.upHeight = 23
	self.titleSprite = 
	{
		[1] = "new_title_battle.png",
		[2] = "new_titile_arena.png",
		[3] = "new_title_skill.png",
		[4] = "new_title_pk.png",
		[5] = "new_title_tripod.png",
	}
	self.userKey = {
		[1] = "FirstBattle",
		[2] = "FirstArena",
		[3] = "FirstSkill",
		[4] = "FirstPK",
		[5] = "FirstTripod",
	}
	self.content = {
		[1] = "从您进入游戏后就已经在自动战斗了，即使{r=[退出游戏]}甚至{r=[关闭手机]}也在{r=[升级]}，{r=[打宝]}(不消耗流量)，只要你随时再回到游戏时就能收获一堆的经验/金币/装备。",
		[2] = "点击{r=[挑战对手]}可获得大量黑铁矿石，还有几率爆出{r=[对手身上的装备]}，另外竞技排名越高，每天免费领大量元宝等奖励哟！",
		[3] = "在{r=[技能设置]}中可以设置战斗的技能，技能按顺序施放！技能升级能对已学会的技能进行升级，最高级后可进阶为威力绝顶的{r=[神级技能]}哟！",
		[4] = "在{r=[PK地图]}中可以进行热血沸腾的pk激情，享受{r=[杀敌爆装备]}的无限乐趣，若是胆小者千万不要在PK地图中挂机哟，可前往安全地图进行挂机。",
		[5] = "在{r=[龙鼎]}中可进行三大操作，{r=[龙鼎熔炼]}可以将不需要的装备熔化提升角色属性；{r=[装备洗练]}可以将装备的极品属性打造成独一无二；{r=[神器升灵]}可以提升神器的灵性等级。",
	}
end

function NewWelcomeLayer:createLayerMenu(tag)
    local node = tolua.cast(cc.CSLoader:createNode("ui/newguide/NewWelcomeLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
	local welcomeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Enter_Button"), "ccui.Button")
    welcomeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				--[[local layerClass = require("src.game.NewGuideLayer")
				local layer = layerClass.create()
				self:getParent():addChild(layer,10)--]]
				cc.UserDefault:getInstance():setBoolForKey(self.userKey[tag],false)
				cc.UserDefault:getInstance():flush()
				self:removeFromParent()
            end
        end
    )
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	local contentPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Content_Panel"), "ccui.Widget")
	local title = tolua.cast(mainPanel:getChildByName("New_Title"),"cc.Sprite")
	title:setSpriteFrame(self.titleSprite[tag])
	
	local richTextLabel = ccui.RichText:create()
	local richElementList = self:parseWord(tag)
	if richElementList then
		for i,v in ipairs(richElementList) do
			richTextLabel:pushBackElement(v)
		end
	end
	
	richTextLabel:formatText()
	local size = richTextLabel:getContentSize()
	local width = contentPanel:getContentSize().width -20
	if size.width > width -self.fontSize then
		self.upHeight = math.ceil(size.width / width) * size.height
	else
		self.upHeight = self.fontSize
	end
	
	richTextLabel:ignoreContentAdaptWithSize(false)
	richTextLabel:setContentSize(width,self.upHeight)
	contentPanel:addChild(richTextLabel)
	richTextLabel:setPosition(width/2+10,contentPanel:getContentSize().height-self.upHeight/2-10)
end

function NewWelcomeLayer:parseWord(tag)
	local richElementList = {}
	local startIndex,lastIndex,str,color,index,colorStr
	local parsedStr = self.content[tag]
	self.tag = 1
	if type(parsedStr) == "string" then	
		local circleTime = 0
		while (string.find(parsedStr,"{") ~= nil)	
		do
			if circleTime > 30 then
				break
			end
			
			index= string.find(parsedStr,"{")
			local strType = string.sub(parsedStr,index+1,index+1)
			-- 红
			if strType == "r" then
				startIndex,lastIndex,str = string.find(parsedStr,"{r=%[(.-)%]}")  
				color = wd.announcementColor["RED"]
			end
			if startIndex and lastIndex and str then
				richElementList = self:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
				parsedStr = string.sub(parsedStr,lastIndex+1,-1)
			end
			circleTime = circleTime + 1
		end
		parsedStr = string.sub(parsedStr,1,-1) 
		local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
		self.tag = self.tag+1
		table.insert(richElementList,richElement)
		
		return richElementList
	end
end
function NewWelcomeLayer:parseStrAndSetRichElement(richElementList,parsedStr,startIndex,lastIndex,str,color)
	if not color then
		color = cc.c3b(255,0,0)
	end
	parsedStr = string.sub(parsedStr,1,startIndex-1)
	local richElement = ccui.RichElementText:create(self.tag,cc.c3b(255,255,255),255,parsedStr,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	richElement = ccui.RichElementText:create(self.tag,color,255,str,"Helvetica",self.fontSize)
	self.tag = self.tag+1
	table.insert(richElementList,richElement)
	return richElementList
end


return NewWelcomeLayer