local RoleAttribute = class("RoleAttribute")


local function getVip(role)
	return role:getVip()
end

local function getVip_exp(role)
	return role:getVip_exp()
end

local function getVip_exp_max(role)
	return role:getVip_exp_max()
end

local function getGold(role)
	return role:getGold()
end

local function getGem(role)
	return role:getGem()
end

local function getPower(role)
	return role:getPower()
end
local function getExp(role)
	return role:getExp()
end

local function getExp_max(role)
	return role:getExp_max()
end

local function getPackageCapacity(role)
	return role:getPackageCapacity()
end

local function getLevel(role)
	return role:getLevel()
end

local function getHp(role)
	return role:getHp()
end

local function getMp(role)
	return role:getMp()
end

local function getPAttack_min(role)
	return role:getPAttack_min()
end

local function getPAttack_max(role)
	return role:getPAttack_max()
end

local function getMAttack_min(role)
	return role:getMAttack_min()
end
local function getMAttack_max(role)
	return role:getMAttack_max()
end

local function getTAttack_min(role)
	return role:getTAttack_min()
end

local function getTAttack_max(role)
	return role:getTAttack_max()
end

local function getPDefence_min(role)
	return role:getPDefence_min()
end

local function getPDefence_max(role)
	return role:getPDefence_max()
end

local function getMDefence_min(role)
	return role:getMDefence_min()
end

local function getMDefence_max(role)
	return role:getMDefence_max()
end

local function getTDefence_min(role)
	return role:getTDefence_min()
end

local function getTDefence_max(role)
	return role:getTDefence_max()
end
local function getLuck(role)
	return role:getLuck()
end

local function getAccuracy(role)
	return role:getAccuracy()
end

local function getDodge(role)
	return role:getDodge()
end

local function getCrit(role)
	return role:getCrit()
end

local function getCritDam(role)
	return role:getCritDam()
end

local function getVertigo(role)
	return role:getVertigo()/100
end

local function getManaprevent(role)
	return role:getManaprevent()/100
end
local function getReincarnate(role)
	return role:getReincarnate()/100
end

local function getDrainlife(role)
	return role:getDrainlife()/100
end

local function getHonor(role)
	return role:getHonor()
end

local function getKill(role)
	return role:getKill()
end

local function getAttack_min(tripod)
	return tripod:getAttack_min()
end

local function getAttack_max(tripod)
	return tripod:getAttack_max()
end

local function getDefence_min(tripod)
	return tripod:getDefence_min()
end

local function getDefence_max(tripod)
	return tripod:getDefence_max()
end

function RoleAttribute:ctor()
	self.RoleBaseAttribute =
	{
		--["Vip"] = {name = "VIP等级", getFunc = getVip,},
		--["Vip_exp"] = {name = "VIP经验", getFunc = getVip_exp,},
		--["Vip_exp_max"] = {name = "VIP最大经验", getFunc = getVip_exp_max,},
		--["Gold"] = {name = "金币", getFunc = getGold,},
		--["Gem"] = {name = "元宝", getFunc = getGem,},
		--["Power"] = {name = "战力", getFunc = getPower,},
		--["Exp"] = {name = "经验", getFunc = getExp,},
		--["Exp_max"] = {name = "最大经验", getFunc = getExp_max,},
		--["PackageCapacity"] = {name = "背包容量", getFunc = getPackageCapacity,},
		--["Level"] = {name = "等级", getFunc = getLevel,},
		["Hp"] = {name = "血量", getFunc = getHp,},
		["Mp"] = {name = "魔法值", getFunc = getMp,},
		["PAttack_min"] = {name = "最小物攻", getFunc = getPAttack_min,},
		["PAttack_max"] = {name = "最大物攻", getFunc = getPAttack_max,},
		["MAttack_min"] = {name = "最小魔攻", getFunc = getMAttack_min,},
		["MAttack_max"] = {name = "最大魔攻", getFunc = getMAttack_max,},
		["TAttack_min"] = {name = "最小道攻", getFunc = getTAttack_min,},
		["TAttack_max"] = {name = "最大道攻", getFunc = getTAttack_max,},
		["PDefence_min"] = {name = "最小物防", getFunc = getPDefence_min,},
		["PDefence_max"] = {name = "最大物防", getFunc = getPDefence_max,},
		["MDefence_min"] = {name = "最小魔防", getFunc = getMDefence_min,},
		["MDefence_max"] = {name = "最大魔防", getFunc = getMDefence_max,},
		["TDefence_min"] = {name = "最小道防", getFunc = getTDefence_min,},
		["TDefence_max"] = {name = "最大道防", getFunc = getTDefence_max,},
		["Luck"] = {name = "幸运", getFunc = getLuck,},
		["Accuracy"] = {name = "准确", getFunc = getAccuracy,},
		["Dodge"] = {name = "闪避", getFunc = getDodge,},
		["Crit"] = {name = "暴击", getFunc = getCrit,},
		["CritDam"] = {name = "暴击伤害", getFunc = getCritDam,},
		["Vertigo"] = {name = "麻痹", getFunc = getVertigo,},
		["Manaprevent"] = {name = "护体", getFunc = getManaprevent,},
		["Reincarnate"] = {name = "复活", getFunc = getReincarnate,},
		["Drainlife"] = {name = "吸血", getFunc = getDrainlife,},
		["Honor"] = {name = "荣耀值", getFunc = getHonor,},
		["Kill"] = {name = "杀戮值", getFunc = getKill,},
	} 
	self.meltingAttribute = {
		["Hp"] = {name = "血量", getFunc = getHp,},
		["Mp"] = {name = "魔法值", getFunc = getMp,},
		["Attack_min"] = {name = "最小攻击", getFunc = getAttack_min,},
		["Attack_max"] = {name = "最大攻击", getFunc = getAttack_max,},
		["Defence_min"] = {name = "最小防御", getFunc = getDefence_min,},
		["Defence_max"] = {name = "最大防御", getFunc = getDefence_max,},
	}
end

function RoleAttribute:getInstance()
	if not self.instance then
		self.instance = RoleAttribute.new()
	end
	return self.instance
end

return RoleAttribute



