--[[
 * 开服活动主界面视图
 * @authors cgq
 * @email 704648733@qq.com
 * @date    2015-10-26 17:04:33
 * @version 1.0.0
]]
local OpenActScene = class("OpenActScene",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function OpenActScene.create()
    local layer = OpenActScene.new()
    layer:createLayerMenu()
    return layer
end

function OpenActScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.tickSchedule = nil
	self.awardState = {
		CanGet = 0,
		HadGet = 1,
		NoPlace = 2,
	}
	self.selectTag = 1
	self.rankList = {}
	self.isOverTime = false
	self.btnList = {}
end


function OpenActScene:clear()
	if self.tickSchedule ~= nil then
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
		self.tickSchedule = nil
	end
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_SevenDayList")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_OpenActData")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Start_Award")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item_Msg")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_OpenAct_Award")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Ranking_List")
end

function OpenActScene:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/activity/OpenActScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Button_Close")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )

	local btnListView = tolua.cast(ccui.Helper:seekWidgetByName(node,"ListView_Btns"), "ccui.ListView")
	self.infoListView = tolua.cast(ccui.Helper:seekWidgetByName(node,"ListView_Info"), "ccui.ListView")
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	self.title_icon = tolua.cast(mainPanel:getChildByName("Sprite_Title"),"cc.Sprite")
	self.act1_widget = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_1"), "ccui.Widget")
	self.timeLabel = tolua.cast(mainPanel:getChildByName("Time_Label"), "ccui.Text")
	self.timeLabelOther = tolua.cast(mainPanel:getChildByName("Time_Label_Other"), "ccui.Text")
	self.timeLabelOther1 = tolua.cast(mainPanel:getChildByName("Time_Label_Other1"), "ccui.Text")
	self.Decs_Label = tolua.cast(mainPanel:getChildByName("Decs_Label"), "ccui.Text")
	
	local function onBtnTouch(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			if self.selectTag == sender:getTag() then
				return
			end
			local lastBtn = btnListView:getChildByTag(self.selectTag)
			local curBtn = btnListView:getChildByTag(sender:getTag())
			if lastBtn and curBtn then
				local lastNode = lastBtn:getChildByTag(self.selectTag)
				local curNode = curBtn:getChildByTag(sender:getTag())
				local lastSelectBox = tolua.cast(lastNode:getChildByName("Panel_Mask"), "ccui.Widget")
				local curSelectBox = tolua.cast(curNode:getChildByName("Panel_Mask"), "ccui.Widget")
				if lastSelectBox and curSelectBox then
					lastSelectBox:setVisible(true)
					curSelectBox:setVisible(false)
				end
			end
			if sender:getTag() == wd.openActivityType.SevenDay then
				wd.activityHandler:requestStartActivityState()
			else
				wd.activityHandler:requestOpenActData()
			end
			if sender:getTag() == wd.openActivityType.LevelRank then
    			wd.TranscodingSend:getRankingList(1)
    		elseif sender:getTag() == wd.openActivityType.AreneRank then
    			wd.TranscodingSend:getRankingList(3)
    		elseif sender:getTag() == wd.openActivityType.PowerRank then
    			wd.TranscodingSend:getRankingList(2)
    		end

			cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_SevenDayList")
			cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_OpenActData")
			cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Start_Award")
			cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_OpenAct_Award")

			self.selectTag = sender:getTag()
			self:showSubView(sender:getTag())
		end
	end
	
	
	local function initBtnList(selectTag)        
        local desTime = (os.time()-wd.GlobalData:getInstance():getLoginTimeDifference()) - wd.GlobalData:getInstance():getServerOpenTime()
	    local tab = os.date("*t",wd.GlobalData:getInstance():getServerOpenTime())
	    local y = tab.year
	    local m = tab.month
	    local d = tab.day
	    local hour = tab.hour
	    local min = tab.min
	    local sec = tab.sec

		if desTime < 0 then
			desTime = 0
		else
			desTime = 2*24*3600 + (23-hour)*3600+(59-min)*60 + (59-sec) - desTime
			if desTime < 0 then
				desTime = 0
			end
		end
        
        
		for i,v in ipairs(wd.openActivityInfo) do
			if v.isShow == true then
				local btnCon = ccui.Widget:create()
				local btnNode = tolua.cast(cc.CSLoader:createNode("ui/activity/OpenBtnNode.csb"),"ccui.Widget")
				local btn = tolua.cast(btnNode:getChildByName("Button_Item"),"ccui.Button")
				btn:setTitleText(v.text)
				btn:setTag(i)
                btn:setTouchEnabled(false)
				btnCon:addTouchEventListener(onBtnTouch)
                btnCon:setTouchEnabled(true)
				btnNode:setTag(i)
				
				-- local newActSprite = cc.Sprite:create()
				-- newActSprite:setSpriteFrame("newTips_01.png")
				-- local role = wd.GlobalData:getInstance():getRoleData()
				-- if role:getNewActivity() and wd.GlobalData:getInstance():getActivityIsNewById(v.id) then
				-- 	btn:addChild(newActSprite)
				-- 	newActSprite:setPosition(cc.p(15,btn:getContentSize().height-5))
				-- 	wd.showNewTipsEffect(newActSprite)
				-- end
				local selectBox = tolua.cast(btnNode:getChildByName("Panel_Mask"), "ccui.Widget")
				if selectTag then
					if i == selectTag then
						selectBox:setVisible(false)
						self:showSubView(i)
					else
						selectBox:setVisible(true)
					end
				end
				local overSprite = tolua.cast(btnNode:getChildByName("Over_Sprite"), "cc.Sprite")
				if i == wd.openActivityType.LevelRank or i == wd.openActivityType.AreneRank or i == wd.openActivityType.PowerRank then
					if desTime == 0 then
						overSprite:setVisible(true)
					else
						overSprite:setVisible(false)
					end
				else
					overSprite:setVisible(false)
				end
				btnCon:setTag(i)
				btnCon:setContentSize(cc.size(155,67))
				btnCon:setAnchorPoint(cc.p(0,0))
				btnCon:addChild(btnNode)
				btnListView:pushBackCustomItem(btnCon)
				self.btnList[i] = btnNode
			end
		end
	end
	
	local function refreshBtnList()
		btnListView:removeAllItems()
		initBtnList(self.selectTag)
	end
	
	initBtnList(1)
	
	local function getCallback(EventCustom)
        local getData = wd.GlobalData:getInstance():getMessage("Get_Item_Msg")
		local itemInfo = wd.getItemInfo(getData)
		if itemInfo == nil or itemInfo.name == nil or itemInfo.color == nil or itemInfo.count == nil then
			return
		end
		local msg = {}
		table.insert(msg,"获得")
		table.insert(msg,string.format("{t=[%s],c=[%d]}",itemInfo.name,itemInfo.color))
		table.insert(msg,string.format("*%d",itemInfo.count))
		wd.showRichTips(wd.tipsType.Get,msg)
    end

    local listener = cc.EventListenerCustom:create("Get_Item_Msg", getCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

    local function rankingListCallback(EventCustom)
        self:refleshRankingList()
		-- wd.activityHandler:requestOpenActData()
		local event = cc.EventCustom:new("Update_OpenActData")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
    end

    local listener = cc.EventListenerCustom:create("Ranking_List", rankingListCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

function OpenActScene:showSubView(tag)
	self.infoListView:removeAllChildren()
	self.title_icon:setSpriteFrame(string.format("open_activity_title%d.png",tag))
	self:updateLeftTime()
	--todo
	if tag == wd.openActivityType.SevenDay then
		self.act1_widget:setVisible(true)
		self.timeLabel:setVisible(true)
		self.timeLabelOther:setVisible(false)
		self.timeLabelOther1:setVisible(false)
		self.Decs_Label:setVisible(false)
	elseif tag == wd.openActivityType.ChargeDay then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(true)
		local day = wd.GlobalData:getInstance():getOpenActRechargeDay()
		if day then
			if day < 0 then
				day = 0
			end
		else
			day = 0
		end
		self.timeLabelOther1:setString(string.format("已累计天数：%d天",day))
		self.Decs_Label:setVisible(false)
	elseif tag == wd.openActivityType.ChargeAct then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(true)
		local num = wd.GlobalData:getInstance():getOpenActRechargeAmount()
		if num then
			if num < 0 then
				num = 0
			end
		else
			num = 0
		end
		self.timeLabelOther1:setString(string.format("已充值：%d元宝",num))
		self.Decs_Label:setVisible(false)
	elseif tag == wd.openActivityType.ConsumeAct then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(true)
		local num = wd.GlobalData:getInstance():getOpenActConsumeAmount()
		if num then
			if num < 0 then
				num = 0
			end
		else
			num = 0
		end
		self.timeLabelOther1:setString(string.format("已消费：%d元宝",num))
		self.Decs_Label:setVisible(false)
	elseif tag == wd.openActivityType.LevelRank then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(false)
		self.Decs_Label:setVisible(true)
		self.Decs_Label:setString(string.format("活动内容：活动结束时，取等级前五的勇士们发放奖励，需手动领取"))
	elseif tag == wd.openActivityType.AreneRank then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(false)
		self.Decs_Label:setVisible(true)
		self.Decs_Label:setString(string.format("活动内容：活动结束时，取竞技前五的勇士们发放奖励，需手动领取"))
	elseif tag == wd.openActivityType.PowerRank then
		self.act1_widget:setVisible(false)
		self.timeLabel:setVisible(false)
		self.timeLabelOther:setVisible(true)
		self.timeLabelOther1:setVisible(false)
		self.Decs_Label:setVisible(true)
		self.Decs_Label:setString(string.format("活动内容：活动结束时，取战力前五的勇士们发放奖励，需手动领取"))
	end

	if tag == wd.openActivityType.SevenDay then
		self:setSevenDay()
	else
		self:setOtherAct(tag)
	end	
end

-- 设置七天登陆的信息
function OpenActScene:setSevenDay()
	local function onUpdateSevenDayList()
		self.infoListView:removeAllItems()
		local sevenDayList = wd.activityHandler:getSevenDayList()
		-- wd.cgq(sevenDayList)
		for index,awardItem in ipairs(sevenDayList) do
			local widget = ccui.Widget:create()
			local awardItemNode =  tolua.cast(cc.CSLoader:createNode("ui/activity/SevenDayNode.csb"),"ccui.Widget")
			local mainPanel = tolua.cast(awardItemNode:getChildByName("Main_Panel"), "ccui.Widget")
			local size = mainPanel:getContentSize()
			size.width = self.infoListView:getContentSize().width
			widget:setContentSize(size)
			mainPanel:setContentSize(size)
			mainPanel:setSwallowTouches(false)
			
			local conditionLabel = tolua.cast(mainPanel:getChildByName("Condition_Label"), "ccui.Text")
			conditionLabel:setString(awardItem.condition)
			local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
			nameLabel:setVisible(false)
			local placeLabel = tolua.cast(mainPanel:getChildByName("Left_Label"), "ccui.Text")
			local leftNum = awardItem.place - awardItem.curPlace
			if leftNum < 0 then
				leftNum = 0
			end
			placeLabel:setString(string.format("%d",leftNum))
			
			local getBtn = tolua.cast(mainPanel:getChildByName("Get_Button"),"ccui.Button")
			getBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						if awardItem.type == 1 then
							wd.activityHandler:requestStartActivityAward(awardItem.id,0)
						else
							local layerClass = require("src.game.activity.SelectAwardLayer")
							local layer = layerClass.create()
							layer:createLayerMenu(awardItem.id,awardItem.awardList)
							self:addChild(layer)
						end
					end
				end
			)
			
			local hadGetSprite = tolua.cast(mainPanel:getChildByName("HadGet_Sprite"), "cc.Sprite")
			local fullSprite = tolua.cast(mainPanel:getChildByName("Full_Sprite"), "cc.Sprite")
			local wdcSprite = tolua.cast(mainPanel:getChildByName("Wdc_Sprite"),"cc.Sprite")
			
			if awardItem.state == self.awardState.CanGet then
				getBtn:setVisible(true)
				hadGetSprite:setVisible(false)
				fullSprite:setVisible(false)
			elseif awardItem.state == self.awardState.HadGet then
				getBtn:setVisible(false)
				hadGetSprite:setVisible(true)
				fullSprite:setVisible(false)
			elseif awardItem.state == self.awardState.NoPlace then
				getBtn:setVisible(false)
				hadGetSprite:setVisible(false)
				fullSprite:setVisible(true)
			end
			wdcSprite:setVisible(false)
			
			local itemListView = tolua.cast(mainPanel:getChildByName("Item_ListView"), "ccui.ListView")
			itemListView:setSwallowTouches(false)
			itemListView:removeFromParent()
			widget:addChild(itemListView,1)
			for index,itemInfo in ipairs(awardItem.awardList) do
				local btn = ccui.Button:create("role_equip_button.png", "role_equip_button.png", "", ccui.TextureResType.plistType)
				btn:setAnchorPoint(cc.p(0,0))
				local itemNode = tolua.cast(cc.CSLoader:createNode("ui/gift/ItemNode.csb"),"ccui.Widget")
				btn:addChild(itemNode)
				local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
				local colorStr
				local quantityVisible = true
				local image = tolua.cast(itemNode:getChildByName("Tools_Sprite"), "cc.Sprite")
				image:setSpriteFrame(string.format("%d.png",itemInfo.itemId))
				if itemInfo.itemType == wd.ItemType.Special then 
					colorStr = string.format("%02d.png",5)
				elseif itemInfo.itemType == wd.ItemType.Tools then 
					local item = wd.GlobalData:getInstance():getToolsItemInXml(tonumber(itemInfo.itemId))
					colorStr = string.format("%02d.png",item:getQuality())
					btn:addTouchEventListener(
						function(sender,eventType)
							if eventType == ccui.TouchEventType.ended then
								local layerClass =  require("game.package.ToolsTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(itemInfo.itemId,true)
								self:addChild(layer)
							end
						end
					)
					if item:getQuality() == 5 then
						wd.itemEffect(image)
					end
				elseif itemInfo.itemType == wd.ItemType.Equip then 
					local equip = wd.GlobalData:getInstance():getEquipItemInXml(tonumber(itemInfo.itemId))
					colorStr = string.format("%02d.png",equip:getColor())
					btn:addTouchEventListener(
						function(sender,eventType)
							if eventType == ccui.TouchEventType.ended then
								local layerClass = require("src.game.shop.ArtifactTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(equip)
								self:addChild(layer)
							end
						end
					)
					wd.equipEffect(equip, image)
					quantityVisible = false
				end
				color:setSpriteFrame(colorStr)
				
				local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
				quantityLabel:setVisible(quantityVisible)
				quantityLabel:setString(string.format("%d", itemInfo.itemCount))
				itemListView:pushBackCustomItem(btn)
			end
			
			widget:setAnchorPoint(cc.p(0,0))
			widget:setTag(index)
			widget:addChild(awardItemNode)
			awardItemNode:setPosition(cc.p(0,0))
			awardItemNode:setTag(index)
			self.infoListView:pushBackCustomItem(widget)
		end
	end
	local listener = cc.EventListenerCustom:create("Update_SevenDayList", onUpdateSevenDayList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local function onGetStartAward()
		--wd.showSystemTips("领取成功")
		wd.activityHandler:requestStartActivityState()
	end
	local listener = cc.EventListenerCustom:create("Get_Start_Award", onGetStartAward)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

--设置其他活动
function OpenActScene:setOtherAct(actType)
	local function onUpdateOtherAct()
		self.infoListView:removeAllItems()
		local levelRankList = {}

		local levelSize = wd.GlobalData:getInstance():getOpenActLevelListSize()
		for i = 0 ,levelSize-1 do
			local levelItem = wd.GlobalData:getInstance():getOpenActLevelList(i)
			local item = {}
			item.rank = levelItem:getRank()
			item.role_id = levelItem:getRoleId()
			item.role_nickname = levelItem:getRoleNameStr()
			levelRankList[item.rank] = item
		end

        local powerRankList = {}

        local powerSize = wd.GlobalData:getInstance():getOpenActPowerListSize()
		for j = 0 ,powerSize-1 do
			local powerItem = wd.GlobalData:getInstance():getOpenActPowerList(j)
			local item = {}
			item.rank = powerItem:getRank()
			item.role_id = powerItem:getRoleId()
			item.role_nickname = powerItem:getRoleNameStr()
			powerRankList[item.rank] = item
		end

		local areneRankList = {}

		local areneSize = wd.GlobalData:getInstance():getOpenActRankListSize()
		for i = 0 ,areneSize-1 do
			local areneItem = wd.GlobalData:getInstance():getOpenActRankList(i)
			local item = {}
			item.rank = areneItem:getRank()
			item.role_id = areneItem:getRoleId()
			item.role_nickname = areneItem:getRoleNameStr()
			areneRankList[item.rank] = item
		end

		local statuList = {}

		local statuSize = wd.GlobalData:getInstance():getOpenActStatuListSize()
		for i = 0 ,statuSize-1 do
			local statuItem = wd.GlobalData:getInstance():getOpenActStatuList(i)
			local item = {}
			item.id = statuItem:getID()
			item.state = statuItem:getState()
			statuList[item.id] = item
		end

		-- wd.cgq(levelRankList,areneRankList,statuList)
		local data = wd.activityHandler:getAwardListByOpenActType(actType-1)
		-- wd.cgq(data)
		for index,awardItem in ipairs(data) do
			-- wd.cgq(awardItem)
			local widget = ccui.Widget:create()
			local awardItemNode =  tolua.cast(cc.CSLoader:createNode("ui/activity/SevenDayNode.csb"),"ccui.Widget")
			local mainPanel = tolua.cast(awardItemNode:getChildByName("Main_Panel"), "ccui.Widget")
			local size = mainPanel:getContentSize()
			size.width = self.infoListView:getContentSize().width
			widget:setContentSize(size)
			mainPanel:setContentSize(size)
			mainPanel:setSwallowTouches(false)
			
			local conditionLabel = tolua.cast(mainPanel:getChildByName("Condition_Label"), "ccui.Text")
			local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
			nameLabel:setString("")
			local leftLabel = tolua.cast(mainPanel:getChildByName("Left_Label"), "ccui.Text")
			leftLabel:setVisible(false)
			local titleSprite = tolua.cast(mainPanel:getChildByName("Title_Sprite"),"cc.Sprite")
			titleSprite:setVisible(false)
			
			local getBtn = tolua.cast(mainPanel:getChildByName("Get_Button"),"ccui.Button")			
			local hadGetSprite = tolua.cast(mainPanel:getChildByName("HadGet_Sprite"), "cc.Sprite")
			local fullSprite = tolua.cast(mainPanel:getChildByName("Full_Sprite"), "cc.Sprite")
			local wdcSprite = tolua.cast(mainPanel:getChildByName("Wdc_Sprite"),"cc.Sprite")
			wdcSprite:setVisible(false)
			local cannotGetBtn = tolua.cast(mainPanel:getChildByName("CannotGet_Button"),"ccui.Button")
			cannotGetBtn:setVisible(false)
			cannotGetBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						wd.showRichTips(4,"领取条件不足")
					end
				end
			)

			local rank
			local isCanGet = false
			if actType == wd.openActivityType.ChargeDay then
				conditionLabel:setVisible(true)
				conditionLabel:setString(self:getChargeDayStr(awardItem.condition))
				nameLabel:setVisible(false)
				if wd.GlobalData:getInstance():getOpenActRechargeDay() >= awardItem.condition then
					isCanGet = true
				end
			elseif actType == wd.openActivityType.ChargeAct then
				conditionLabel:setVisible(true)
				conditionLabel:setString(self:getChargeNumStr(awardItem.condition))
				nameLabel:setVisible(false)
				if wd.GlobalData:getInstance():getOpenActRechargeAmount() >= awardItem.condition then
					isCanGet = true
				end
			elseif actType == wd.openActivityType.ConsumeAct then
				conditionLabel:setVisible(true)
				conditionLabel:setString(self:getConsumeNumStr(awardItem.condition))
				nameLabel:setVisible(false)
				if wd.GlobalData:getInstance():getOpenActConsumeAmount() >= awardItem.condition then
					isCanGet = true
				end
			elseif actType == wd.openActivityType.LevelRank then
				-- conditionLabel:setString(self:getRankStr(awardItem.condition))
				titleSprite:setVisible(true)
				titleSprite:setSpriteFrame(string.format("open_activity_level%d.png",index))
				conditionLabel:setVisible(false)
				nameLabel:setVisible(true)
				if levelSize > 0 then
					rank = levelRankList[index]
				else
					rank = self.rankList[index]
				end
			elseif actType == wd.openActivityType.AreneRank then
				-- conditionLabel:setString(self:getRankStr(awardItem.condition))
				titleSprite:setVisible(true)
				titleSprite:setSpriteFrame(string.format("open_activity_arene%d.png",index))
				conditionLabel:setVisible(false)
				nameLabel:setVisible(true)
				if areneSize > 0 then
					rank = areneRankList[index]
				else
					rank = self.rankList[index]
				end
			elseif actType == wd.openActivityType.PowerRank then
				-- conditionLabel:setString(self:getRankStr(awardItem.condition))
				titleSprite:setVisible(true)
				titleSprite:setSpriteFrame(string.format("open_activity_arene%d.png",index))
				conditionLabel:setVisible(false)
				nameLabel:setVisible(true)
				if areneSize > 0 then
					rank = powerRankList[index]
				else
					rank = self.rankList[index]
				end
			end

			if rank then
				nameLabel:setString(rank.role_nickname)
				if rank.role_id and self:isCanGetRankAward(rank.role_id) then
					isCanGet = true
				else
					isCanGet = false
				end
			end

			local statu = statuList[awardItem.id]
			if statu then
				if statu.state == 1 then
					getBtn:setVisible(false)
					hadGetSprite:setVisible(true)
				else
					if isCanGet then
						getBtn:setVisible(true)
						hadGetSprite:setVisible(false)
					else
						getBtn:setVisible(false)
						hadGetSprite:setVisible(false)
						if actType == wd.openActivityType.LevelRank or actType == wd.openActivityType.AreneRank or actType == wd.openActivityType.PowerRank then
							wdcSprite:setVisible(true)
						else
							cannotGetBtn:setVisible(true)
						end
					end
				end
			else
				if isCanGet then
					getBtn:setVisible(true)
					hadGetSprite:setVisible(false)
				else
					getBtn:setVisible(false)
					hadGetSprite:setVisible(false)
					if actType == wd.openActivityType.LevelRank or actType == wd.openActivityType.AreneRank or actType == wd.openActivityType.PowerRank then
						wdcSprite:setVisible(true)
					else
						cannotGetBtn:setVisible(true)
					end
				end
			end
			fullSprite:setVisible(false)
			
			getBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
						if rank then
							if self.isOverTime then
								if awardItem.awardType == 1 then
									wd.activityHandler:requestOpenActAward(awardItem.id,0)
								else
									local layerClass = require("src.game.activity.SelectAwardLayer")
									local layer = layerClass.create()
									layer:createLayerMenu(awardItem.id,awardItem.awardList)
									layer:setIsSevenBool(false)
									self:addChild(layer)
								end
							else
								wd.showRichTips(4,"活动尚未结束哦")
							end
						else
							if awardItem.awardType == 1 then
								wd.activityHandler:requestOpenActAward(awardItem.id,0)
							else
								local layerClass = require("src.game.activity.SelectAwardLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(awardItem.id,awardItem.awardList)
								layer:setIsSevenBool(false)
								self:addChild(layer)
							end
						end
					end
				end
			)
			
			local itemListView = tolua.cast(mainPanel:getChildByName("Item_ListView"), "ccui.ListView")
			itemListView:setSwallowTouches(false)
			itemListView:removeFromParent()
			widget:addChild(itemListView,1)
			for index,itemInfo in ipairs(awardItem.awardList) do
				local btn = ccui.Button:create("role_equip_button.png", "role_equip_button.png", "", ccui.TextureResType.plistType)
				btn:setAnchorPoint(cc.p(0,0))
				local itemNode = tolua.cast(cc.CSLoader:createNode("ui/gift/ItemNode.csb"),"ccui.Widget")
				btn:addChild(itemNode)
				local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
				local colorStr
				local quantityVisible = true
				local image = tolua.cast(itemNode:getChildByName("Tools_Sprite"), "cc.Sprite")
				image:setSpriteFrame(string.format("%d.png",itemInfo.itemId))
				if itemInfo.itemType == wd.ItemType.Special then 
					colorStr = string.format("%02d.png",5)
				elseif itemInfo.itemType == wd.ItemType.Tools then 
					local item = wd.GlobalData:getInstance():getToolsItemInXml(tonumber(itemInfo.itemId))
					colorStr = string.format("%02d.png",item:getQuality())
					btn:addTouchEventListener(
						function(sender,eventType)
							if eventType == ccui.TouchEventType.ended then
								local layerClass =  require("game.package.ToolsTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(itemInfo.itemId,true)
								self:addChild(layer)
							end
						end
					)
					if item:getQuality() == 5 then
						wd.itemEffect(image)
					end
				elseif itemInfo.itemType == wd.ItemType.Equip then 
					local equip = wd.GlobalData:getInstance():getEquipItemInXml(tonumber(itemInfo.itemId))
					colorStr = string.format("%02d.png",5)
					btn:addTouchEventListener(
						function(sender,eventType)
							if eventType == ccui.TouchEventType.ended then
								local layerClass = require("src.game.shop.ArtifactTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(equip)
								self:addChild(layer)
							end
						end
					)
					wd.equipEffect(equip, image)
					quantityVisible = false
				elseif itemInfo.itemType == wd.ItemType.Soul then
					local soulItem = wd.soulHandler:getSoulInXmlForId(tonumber(itemInfo.itemId))
					colorStr = string.format("%02d.png",soulItem.grade)
				    btn:addTouchEventListener(
				        function(sender,eventType)
				            if eventType == ccui.TouchEventType.ended then
				                local layerClass = require("src.game.soul.SoulTipsLayer")
								local layer = layerClass.create()
								layer:createLayerMenu(soulItem,0)
								self:addChild(layer)
				            end
				        end
				    )
				end
				color:setSpriteFrame(colorStr)
				
				local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
				quantityLabel:setVisible(quantityVisible)
				quantityLabel:setString(string.format("%d", itemInfo.itemCount))
				itemListView:pushBackCustomItem(btn)
			end
			
			widget:setAnchorPoint(cc.p(0,0))
			widget:setTag(index)
			widget:addChild(awardItemNode)
			awardItemNode:setPosition(cc.p(0,0))
			awardItemNode:setTag(index)
			self.infoListView:pushBackCustomItem(widget)
		end
	end
	local listener = cc.EventListenerCustom:create("Update_OpenActData", onUpdateOtherAct)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

	local function onGetOpenActAward()
		--wd.showSystemTips("领取成功")
		wd.activityHandler:requestOpenActData()
	end
	local listener = cc.EventListenerCustom:create("Get_OpenAct_Award", onGetOpenActAward)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

-- 累充天数的字符串
function OpenActScene:getChargeDayStr(value)
	if value == 1 then
		return string.format("累计第一天充值")
	elseif value == 2 then
		return string.format("累计第二天充值")
	elseif value == 3 then
		return string.format("累计第三天充值")
	elseif value == 4 then
		return string.format("累计第四天充值")
	elseif value == 5 then
		return string.format("累计第五天充值")
	elseif value == 6 then
		return string.format("累计第六天充值")
	elseif value == 7 then
		return string.format("累计第七天充值")
	else
		return ""
	end
end

-- 累充数值的字符串
function OpenActScene:getChargeNumStr(value)
	return string.format("累计充值\n%d元宝",value)
end

-- 消费数值的字符串
function OpenActScene:getConsumeNumStr(value)
	return string.format("累计消费\n%d元宝",value)
end

-- 排行的字符串
function OpenActScene:getRankStr(value)
	if value == 1 then
		return string.format("唯我独尊\n烈血第一")
	elseif value == 2 then
		return string.format("万夫莫敌\n烈血第二")
	elseif value == 3 then
		return string.format("霸气无双\n烈血第三")
	elseif value == 4 then
		return string.format("如日中天\n烈血第四")
	elseif value == 5 then
		return string.format("名传天下\n烈血第五")
	else
		return ""
	end
end

-- 刷新排行榜数据
function OpenActScene:refleshRankingList()
	self.rankList = {}
	for i=1,5 do
		local gladiator = wd.GlobalData:getInstance():getGladiatorData(i-1)
		local item = {}
		if gladiator then
			item.role_id = gladiator:getRoleId()
			item.role_nickname = gladiator:getName()
		else
			item.role_nickname = "虚位以待"
		end
		self.rankList[i] = item
	end
end

-- 判断可不可领取 排行相关
function OpenActScene:isCanGetRankAward(role_id)
	if role_id == wd.GlobalData:getInstance():getRoleId() then
		return true
	else
		return false
	end
end

-- 刷新剩余时间
function OpenActScene:updateLeftTime()
	local day = 6
	if self.selectTag < 5 then
		day = 6
	else
		day = 2
	end
	local desTime = (os.time()-wd.GlobalData:getInstance():getLoginTimeDifference()) - wd.GlobalData:getInstance():getServerOpenTime()
	if desTime < 0 then
		desTime = 0
	else
    
        if self.selectTag >=5 then
			local tab = os.date("*t",wd.GlobalData:getInstance():getServerOpenTime())
		    local y = tab.year
		    local m = tab.month
		    local d = tab.day
		    local hour = tab.hour
		    local min = tab.min
		    local sec = tab.sec
		    desTime = day*24*3600 + (23 - hour)*3600 + (59-min)*60 + (59-sec) - desTime
		else
		    desTime = day*24*3600 - desTime
        end 
		if desTime < 0 then
			desTime = 0
		end
	end
	if self.tickSchedule ~= nil then
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
		self.tickSchedule = nil
	end
	self.isOverTime = false
	if desTime ~= 0 then
        if self.selectTag < 5 then
            local d,h,m,s
            local function setTime()
                if desTime ~= 0 then
                    d = os.date("%d",desTime)
                    h = os.date("%H",desTime)
                    m = os.date("%M",desTime)
                    s = os.date("%S",desTime)
                    if tonumber(d) > 0 then
                        self.timeLabel:setString(string.format("任务剩余时间：%d天",d))
                        self.timeLabelOther:setString(string.format("任务剩余时间：%d天",d))
                    else
                        self.timeLabel:setString(string.format("任务剩余时间：%02d:%02d:%02d",h,m,s))
                        self.timeLabelOther:setString(string.format("任务剩余时间：%02d:%02d:%02d",h,m,s))
                    end
                else
                    if self.tickSchedule ~= nil then
                        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
                        self.tickSchedule = nil
                    end
                    self.timeLabel:setString("活动时间结束")
                    self.timeLabelOther:setString("活动时间结束")
                    self.isOverTime = true
                end
            end
            setTime()
            local function timeTick()
                setTime()
                desTime = desTime - 1
                if desTime < 0  then
                    desTime = 0
                end
            end
            self.tickSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(timeTick, 1, false)
        else
			local d,h,m,s
			local function setTime()
				if desTime ~= 0 then
					local aa = desTime/3600
					if aa >= 24 and aa < 48 then
						self.timeLabel:setString(string.format("任务剩余时间：%d天",1))
						self.timeLabelOther:setString(string.format("任务剩余时间：%d天",1))
					elseif aa >= 48 then
						self.timeLabel:setString(string.format("任务剩余时间：%d天",2))
						self.timeLabelOther:setString(string.format("任务剩余时间：%d天",2))
					else
						h = math.floor(aa)
						m = math.floor((desTime - h*3600)/60)
						s = desTime - h*3600 - m*60
						self.timeLabel:setString(string.format("任务剩余时间：%02d:%02d:%02d",h,m,s))
						self.timeLabelOther:setString(string.format("任务剩余时间：%02d:%02d:%02d",h,m,s))
					end
				else
					if self.tickSchedule ~= nil then
						cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.tickSchedule)
						self.tickSchedule = nil
					end
					self.timeLabel:setString("活动时间结束")
					self.timeLabelOther:setString("活动时间结束")
					self.isOverTime = true
				end
			end
			setTime()
			local function timeTick()
				setTime()
				desTime = desTime - 1
				if desTime < 0  then
					desTime = 0
				end
			end
			self.tickSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(timeTick, 1, false)
		end
	else
		self.timeLabel:setString("活动时间结束")
		self.timeLabelOther:setString("活动时间结束")
		self.isOverTime = true
	end
end

return OpenActScene

