
local BattleLayer = class("BattleLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end
local BUFF_TAG = 100

function BattleLayer.create()
    local layer = BattleLayer.new()
    --layer:createLayerMenu()
    return layer
end

function BattleLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.battleHandler = wd.battleHandler
    self.schedulerID = nil
	cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/attackEffect.plist", "ui/other/attackEffect.png")
    self.battleTable = {}
	self.battleHandler:setBattleTable({})
    self.panelTable = {}
	self.buffInfoList = {}
	self.decBuffInfoList = {}
	self.actionType = -1
    self.arenaRanking = 0
	self.revengeFight = false
	self.bossFightFlag = false
    self.ectypeFightFlag = false
	self.bossFightIndex = 0
	self.pkFightFlag = false
    self.familyBossBattle = 0
	self.lastUseSkill = 0
    self.level = 0
    self.index = 0
    self.before = 0
    self.round = 0
	self.tickRound = 0
    self.attack = 0
	self.frontTag = 1
	self.fontSize = 18
	self.subBloodFontSize = 25
	self.otherBloodFontSize = 20
	self.battleHandler:setElementFontSize(self.fontSize)
	self.upHeight = self.fontSize
    self.mapName = nil
    self.roundLabel = nil
    self.labelView = nil
    self.battleSchedule = nil
    self.actionSchedule = nil
    self.isFamilyBoss = false
    self.familyBossHp = 0
	
	self.headPosition ={}

    self.theend = 0
end


function BattleLayer:setArenaBattle(ranking,name,level)
    self.arenaRanking = ranking
	if name and level then
		if self.tipsBox and self.tipsLabel then
			self.tipsBox:setVisible(true)
			self.tipsLabel:setString(string.format("下一场将PK玩家:%s Lv%d",name,level))
		end
	end
end

function BattleLayer:setFamilyBossBattle(ranking,name,level,hp)
    self.familyBossBattle = ranking
    self.familyBossHp = tonumber(hp)
	if name and level then
		if self.tipsBox and self.tipsLabel then
			self.tipsBox:setVisible(true)
			self.tipsLabel:setString(string.format("下一场将挑战BOSS:%s %s",name,level))
		end
	end
end

function BattleLayer:setRevengeFight(revengeFightFlag)
    self.revengeFight = revengeFightFlag
end

function BattleLayer:setBossFight(bossFightFlag,bossFightType,name,level)
    self.bossFightFlag = bossFightFlag
    self.bossFightType = bossFightType
	if name and level then
		if self.tipsBox and self.tipsLabel then
			self.tipsBox:setVisible(true)
			self.tipsLabel:setString(string.format("下一场将挑战:%sBOSS Lv%d",name,level))
		end
	end
end

function BattleLayer:setEctypeFight(ectypeFightFlag,ectypeTag,name)
    self.ectypeFightFlag = ectypeFightFlag
    self.ectypeTag = ectypeTag
	if name then
		if self.tipsBox and self.tipsLabel then
			self.tipsBox:setVisible(true)
			self.tipsLabel:setString(string.format("下一场将挑战副本:%s",name))
		end
	end
end

function BattleLayer:setPKFight(pkFightFlag,name,level)
    self.pkFightFlag = pkFightFlag
	if name and level then
		if self.tipsBox and self.tipsLabel then
			self.tipsBox:setVisible(true)
			self.tipsLabel:setString(string.format("下一场将PK玩家:%s Lv%d",name,level))
		end
	end
end

function BattleLayer:gameTheEnd()
    wd.GlobalData:getInstance():gameTheEnd()
end


function BattleLayer:setMapIndex(index,isBossFight)
	if isBossFight then
		self.bossFightIndex = index	
	else
		self.index = index
	end
    if self.mapName then
		local mapCount = wd.GlobalData:getInstance():getMapCount()
		if self.index < mapCount then
			self.mapName:setSpriteFrame(string.format("map_name_lv%d.png",self.index))
		else
			self.mapName:setSpriteFrame(string.format("maptitle_%d.png",self.index))
		end
    end
end

function BattleLayer:resetRole()
    local player = self.panelTable[0]:getChildByName("battle_player0")
    player:setVisible(false)
    local player = self.panelTable[1]:getChildByName("battle_player0")
    player:setVisible(false)
    local player = self.panelTable[0]:getChildByName("battle_player1")
    player:setVisible(false)
    local player = self.panelTable[1]:getChildByName("battle_player1")
    player:setVisible(false)
end


function BattleLayer:getRoleData()

    self:resetRole()

    local teamMember = {[0]=0,[1]=0}

    local roleNumber = wd.GlobalData:getInstance():getBattleRoleNumber()

    for i=0,roleNumber-1 do
        local roleTable = {}
        
        local team = wd.GlobalData:getInstance():getBattleRoleTeam(i)
		
        local str = string.format("battle_player%d",teamMember[team])
		
        local player = self.panelTable[team]:getChildByName(str)
        player:setVisible(true)

        roleTable.pos = wd.GlobalData:getInstance():getBattleRolePos(i)
        roleTable.name = wd.GlobalData:getInstance():getBattleRoleName(i)
        roleTable.player = player
		local x,y = player:getPosition()
		if not self.headPosition[team] then
			self.headPosition[team] = {}	
		end
		self.headPosition[team][teamMember[team]] = cc.p(x,y)
        roleTable.headSprite = tolua.cast(player:getChildByName("Player_Head"), "cc.Sprite")
		roleTable.deadTitle = tolua.cast(player:getChildByName("Dead_Title"), "cc.Sprite")
        roleTable.nameLabel = tolua.cast(player:getChildByName("Name_Label"), "ccui.Text")
        roleTable.levelLabel = tolua.cast(player:getChildByName("Level_Label"), "ccui.TextAtlas")
        roleTable.hpLabel = tolua.cast(player:getChildByName("Hp_Label"), "ccui.TextAtlas")
        roleTable.mpLabel = tolua.cast(player:getChildByName("Mp_Label"), "ccui.TextAtlas")
        roleTable.hpBar = tolua.cast(player:getChildByName("Hp_Progress"), "ccui.LoadingBar")
        roleTable.mpBar = tolua.cast(player:getChildByName("Mp_Progress"), "ccui.LoadingBar")
        roleTable.hp = wd.GlobalData:getInstance():getBattleRoleHp(i)
        roleTable.mp = wd.GlobalData:getInstance():getBattleRoleMp(i)
        roleTable.lostHp = 0
        roleTable.lostMp = 0
		
        roleTable.nameLabel:setString(roleTable.name)
        roleTable.levelLabel:setString(wd.GlobalData:getInstance():getBattleRoleLevel(i))
        local roleTypes = wd.GlobalData:getInstance():getBattleRoleType(i)
        roleTable.roleTypes = roleTypes
        if self.isFamilyBoss == false or roleTypes == wd.PlayerType.SELF then
        roleTable.hpLabel:setString(string.format("%d/%d", roleTable.hp-roleTable.lostHp, roleTable.hp))
        roleTable.hpBar:setPercent((roleTable.hp-roleTable.lostHp)/roleTable.hp*100)
       	else
       		roleTable.hpLabel:setString(string.format("%d/%d", roleTable.hp-roleTable.lostHp, self.familyBossHp))
       		roleTable.hpBar:setPercent((roleTable.hp-roleTable.lostHp)/self.familyBossHp*100)
       	end
        roleTable.mpLabel:setString(string.format("%d/%d", roleTable.mp-roleTable.lostMp, roleTable.mp))


        roleTable.mpBar:setPercent((roleTable.mp-roleTable.lostMp)/roleTable.mp*100)

        self.battleTable[roleTable.pos] = roleTable
        self.battleHandler:setBattleTable(self.battleTable)
        teamMember[team] = teamMember[team] + 1
		
		if roleTable.hp ~= 0 then
			roleTable.deadTitle:setVisible(false)
		end
		
		if team == wd.PlayerType.ENEMY then
			self.battleHandler:setEnemyMsg(roleTable.name)
		end
		-- head
		if roleTable.headSprite then
			local headSpriteName
			local roleType = wd.GlobalData:getInstance():getBattleRoleType(i)
			if roleType == wd.PlayerType.SELF then
				local roleJob =  wd.GlobalData:getInstance():getBattleRoleOccupation(i)
				local roleSex = wd.GlobalData:getInstance():getBattleRoleSex(i)
				headSpriteName= wd.getHeadImageName(roleJob, roleSex)
				
			elseif roleType == wd.PlayerType.ENEMY then
				local id = wd.GlobalData:getInstance():getBattleRoleTag(i)
                if id >= 17001 and id <= 17035 then
					if id == 17006 or id == 17011 or id == 17016 or id == 17021 or id == 17026 or id == 17031 then
						id = 17001
					elseif id == 17007 or id == 17012 or id == 17017 or id == 17022 or id == 17027 or id == 17032 then
						id = 17002
					elseif id == 17008 or id == 17013 or id == 17018 or id == 17023 or id == 17028 or id == 17033 then
						id = 17003
					elseif id == 17009 or id == 17014 or id == 17019 or id == 17024 or id == 17029 or id == 17034 then
						id = 17004
					elseif id == 17010 or id == 17015 or id == 17020 or id == 17025 or id == 17030 or id == 17035 then
						id = 17005
					end
				    headSpriteName = string.format("%d.png",id)
                else
					headSpriteName = string.format("%d.png",id)
			    end
            end
			if headSpriteName then
				roleTable.headSprite:setSpriteFrame(headSpriteName)
			end
		end
		
		self.buffInfoList[(teamMember[team])*10+team] = {}
		self.decBuffInfoList[(teamMember[team])*10+team] = {}
		
		local buffLabel = ccui.Text:create()
		buffLabel:setTag(BUFF_TAG)
		buffLabel:setFontSize(20)
		buffLabel:setColor(cc.c3b(0xff,0xff,0))
		player:addChild(buffLabel)
		buffLabel:setPosition(-30,-65)
    end
	self:showRichLabel("enemy")
end

function BattleLayer:showChange(roleTable)
    local curHp = roleTable.hp - roleTable.lostHp
    local curMp = roleTable.mp - roleTable.lostMp
    
    if curHp < 0 then
        curHp = 0
		roleTable.deadTitle:setVisible(true)
	else
		roleTable.deadTitle:setVisible(false)
    end
    if curMp < 0 then
        curMp = 0
    end
    
    if self.isFamilyBoss == false or roleTable.roleTypes == wd.PlayerType.SELF then
        roleTable.hpLabel:setString(string.format("%d/%d", curHp, roleTable.hp))
        roleTable.hpBar:setPercent((curHp)/roleTable.hp*100)
   	elseif self.isFamilyBoss == true then
   		roleTable.hpLabel:setString(string.format("%d/%d", curHp, self.familyBossHp))
   		roleTable.hpBar:setPercent((curHp)/self.familyBossHp*100)
   	end
    roleTable.mpLabel:setString(string.format("%d/%d", curMp, roleTable.mp))
    roleTable.mpBar:setPercent((curMp)/roleTable.mp*100)
end

function BattleLayer:doAction(round, attack)
	
	local oneActionNumber =  wd.GlobalData:getInstance():getBattleActionNumber(round,attack)
	
	for oneAction = 0,oneActionNumber - 1 do
		self.battleHandler:setAttackMsg(round,attack,oneAction)
	end
	self:showRichLabel("fight")
end

function BattleLayer:createRichLabelByElementList(richElementList)
	local richTextLabel = ccui.RichText:create()
	if richElementList then
		for i,v in ipairs(richElementList) do
			richTextLabel:pushBackElement(v)
		end
	end
	
	richTextLabel:formatText()
	local size = richTextLabel:getContentSize()
	if size.width > self.labelViewSize.width-self.fontSize then
		self.upHeight = math.ceil(size.width / self.labelViewSize.width) * size.height
	else
		self.upHeight = self.fontSize
	end
	--print("height "..self.upHeight)
	richTextLabel:ignoreContentAdaptWithSize(false)
	richTextLabel:setContentSize(self.labelViewSize.width,self.upHeight)
	--richTextLabel:setAnchorPoint(cc.p(0,0))
	richTextLabel:setTag(self.frontTag)
	return richTextLabel
end

function BattleLayer:addLabelToLabelView(richLabel)
	if richLabel then
		self.labelView:addChild(richLabel)
		richLabel:setPosition(cc.p(richLabel:getContentSize().width/2+10,richLabel:getContentSize().height/2))
		
	end
	local child
	for i= self.frontTag-1,1,-1 do
		if self.labelView:getChildByTag(i) then
			child = self.labelView:getChildByTag(i)
			if self.upHeight*(self.frontTag-i) < self.labelViewSize.height then
				local x,y = child:getPosition()
				child:setPosition(cc.p(child:getContentSize().width/2+10,self.upHeight+y+10))
			else 			
				self.labelView:removeChildByTag(i)
			end
		end
	end
	self.frontTag = self.frontTag + 1
end

function BattleLayer:showRichLabel(showType)
	local richElementList
	if showType == "fight" then
		richElementList= self.battleHandler:getFightElementList()
	elseif showType == "end" then
		richElementList = self.battleHandler:getEndElementList()
	elseif showType == "enemy" then
		richElementList = self.battleHandler:getEnemyElementList()
	elseif showType == "tick" then
		richElementList = self.battleHandler:getTickElementList()
	end
	if richElementList then
		self.battleHandler:resetElementList()
		for index,elementTable in ipairs(richElementList) do
			local richLabel = self:createRichLabelByElementList(elementTable)
			self:addLabelToLabelView(richLabel)
			self:showBattleEffect()
			self:setBuffLabel()
		end
	end
end

function BattleLayer:getTargetHeadMoveAction()
	local moveByLeft = cc.MoveBy:create(0.05,cc.p(-5,0))
	local reverseLeft = moveByLeft:reverse()
	local moveByRight = cc.MoveBy:create(0.05,cc.p(5,0))
	local reverseRight = moveByRight:reverse()
	local sequence = cc.Sequence:create(moveByLeft,reverseLeft,moveByRight,reverseRight)
	local repeatAct = cc.Repeat:create(sequence,2)
	return repeatAct
end

function BattleLayer:getAtkerHeadMoveAction(atkerTeam)
	local moveX
	if atkerTeam == wd.PlayerType.ENEMY then
		moveX = -15
	else
		moveX = 15
	end
	local moveBy = cc.MoveBy:create(0.5,cc.p(moveX,0))
	local reverse = moveBy:reverse()
	
	local sequence = cc.Sequence:create(moveBy,reverse)
	return sequence
end

-- BattleEffect
function BattleLayer:showBattleEffect()
	local battleInfoList = self.battleHandler:getBattleInfoList()
	self.battleHandler:resetBattleInfoList()
	for i,v in ipairs(battleInfoList) do
		local roleTable = self.battleTable[v.target_Pos]
		if v.type == wd.ActionType.HP_CHANGE or v.type == wd.ActionType.DOD_OCCUR or v.type == wd.ActionType.CRIT_OCCUR or v.type == wd.ActionType.STRIKE_BACK or v.type == wd.ActionType.DOUBLE_HIT then
			roleTable.lostHp = roleTable.lostHp + v.value
		elseif v.type == wd.ActionType.MP_CHANGE then
			roleTable.lostMp = roleTable.lostMp +  v.value
		elseif v.type == wd.ActionType.RAIN_HP then
			roleTable.lostHp = roleTable.hp -  v.value
		elseif v.type == wd.ActionType.RAIN_MP then
			roleTable.lostMp = 0
		end
		self:showChange(roleTable)
			
		local atkerTeam = v.atker_Pos%10
		local atkerTeamMember = math.floor(v.atker_Pos/10)-1
		local name = string.format("battle_player%d",atkerTeamMember) 
		local atkerPlayer = self.panelTable[atkerTeam]:getChildByName(name)
		if atkerPlayer then
			atkerPlayer:stopAllActions()
			atkerPlayer:setPosition(self.headPosition[atkerTeam][atkerTeamMember])
			atkerPlayer:runAction(self:getAtkerHeadMoveAction(atkerTeam))
		end
		
		local targetTeam = v.target_Pos%10
		local targetTeamMember = math.floor(v.target_Pos/10)-1
		local name = string.format("battle_player%d",targetTeamMember) 
		local targetPlayer = self.panelTable[targetTeam]:getChildByName(name)
		if targetPlayer then
			-- hitAction
			if ((v.type == wd.ActionType.HP_CHANGE and v.atker_Team ~= v.target_Team) 
				or v.type == wd.ActionType.DOD_OCCUR or v.type == wd.ActionType.CRIT_OCCUR ) and v.value >= 0 then
				self:showSoundEffect()
				-- head move action
				targetPlayer:setPosition(self.headPosition[targetTeam][targetTeamMember])
				targetPlayer:runAction(self:getTargetHeadMoveAction())
				
				-- hit action
				local hitSprite = cc.Sprite:create()
				targetPlayer:addChild(hitSprite)
				hitSprite:setRotation(targetTeam == wd.PlayerType.ENEMY and -90 or 90)
				hitSprite:setFlippedX(targetTeam == wd.PlayerType.ENEMY)
				local animation = cc.Animation:create()
				if v.skill ~= 0  then
					for i = 1, 8 do
						animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("skill_%02d.png", i)))
					end
					animation:setDelayPerUnit(0.0625)
					hitSprite:setPosition(cc.p(((targetTeam == wd.PlayerType.ENEMY) and 100 or -100),0))
				else
					for i = 1, 6 do
						animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("attack_%02d.png", i)))
					end
					animation:setDelayPerUnit(0.083)
					hitSprite:setPosition(cc.p(((targetTeam == wd.PlayerType.ENEMY) and -20 or 20),0))
				end
				animation:setLoops(1)
				local function playAnimateCallBackFunc()
					hitSprite:removeFromParent()
				end
				local playAnimateCallBack = cc.CallFunc:create(playAnimateCallBackFunc)
				local animate = cc.Animate:create(animation)
				local hitSequence = cc.Sequence:create(animate,playAnimateCallBack)
				hitSprite:runAction(hitSequence)
				self:showSoundEffect()
			end
			
			-- blood action
			if v.type == wd.ActionType.HP_CHANGE or v.type == wd.ActionType.DOD_OCCUR or v.type == wd.ActionType.CRIT_OCCUR or v.type == wd.ActionType.STRIKE_BACK or v.type == wd.ActionType.DOUBLE_HIT  or v.type == wd.ActionType.RAIN_HP then
				local node = cc.Node:create()
				local valueLabel = ccui.Text:create()
				local effectLabel = ccui.Text:create()
				valueLabel:setFontSize(self.subBloodFontSize)
				effectLabel:setFontSize(self.subBloodFontSize)
				node:setAnchorPoint(cc.p(0,0))
				valueLabel:setAnchorPoint(cc.p(0,0))
				effectLabel:setAnchorPoint(cc.p(0,0))
				local str,effectStr,color,pos,delay
				if (v.type == wd.ActionType.HP_CHANGE and v.value >= 0) or v.type == wd.ActionType.DOD_OCCUR or v.type == wd.ActionType.CRIT_OCCUR or v.type == wd.ActionType.STRIKE_BACK or v.type == wd.ActionType.DOUBLE_HIT  then
					str =  string.format("-%d",math.abs(v.value))
					color = cc.c3b(255,   0,   0)
					effectStr = ""
					if v.type == wd.ActionType.DOD_OCCUR or v.type == wd.ActionType.CRIT_OCCUR or v.type == wd.ActionType.STRIKE_BACK or v.type == wd.ActionType.DOUBLE_HIT then
						effectStr = string.format("%s",wd.actionTypeString(v.type))
					end
					--delay = 0.5
					pos = cc.p(-20,0)
					if v.type == wd.ActionType.DOUBLE_HIT or v.type == wd.ActionType.STRIKE_BACK then
						delay = 0.7
					else
						delay = 0
					end
				elseif (v.type == wd.ActionType.HP_CHANGE and v.value < 0) then
						str =  string.format("+%d",math.abs(v.value))
						color = cc.c3b(0,   255,   0)
						delay = 0.5
						
					if math.abs(v.passiveSkill - 360001) < 100 then
						effectStr = "噬血术"
						pos = cc.p(((targetTeam == wd.PlayerType.ENEMY) and -180 or 80),40)
					elseif math.abs(v.passiveSkill - 390001) < 100 then
						effectStr = "缚龙血阵"
						pos = cc.p(((targetTeam == wd.PlayerType.ENEMY) and -180 or 80),-20)
					else
						effectStr = "吸血"
						pos = cc.p(((targetTeam == wd.PlayerType.ENEMY) and -180 or 80),10)
					end
					
				else
					str =  string.format("+%d",math.abs(v.value))
					color = cc.c3b(0,   255,   0)
					effectStr = "复活"
					delay = 1.2
					pos = cc.p(((targetTeam == wd.PlayerType.ENEMY) and -180 or 80),20)
				end
				if effectStr then
					effectLabel:setColor(cc.c3b(255,255,0))
					effectLabel:setString(effectStr)
				end
				valueLabel:setString(str)
				valueLabel:setColor(color)
				local width = valueLabel:getContentSize().width + effectLabel:getContentSize().width+20
				node:setContentSize(cc.size(width,40))
				node:addChild(effectLabel)
				node:addChild(valueLabel)
				effectLabel:setPosition(cc.p(0,0))
				valueLabel:setPosition(cc.p(effectLabel:getContentSize().width+10,0))
				targetPlayer:addChild(node)
				node:setPosition(pos)
				node:setVisible(false)
				local delayTime = cc.DelayTime:create(delay)
				local function delayCallBack()
					node:setVisible(true)
					local moveBy = cc.MoveBy:create(2,cc.p(0,80))
					local function moveByCallBackFunc()
						node:removeFromParent()
					end
					local moveByCallBack = cc.CallFunc:create(moveByCallBackFunc)
					local sequence = cc.Sequence:create(moveBy,moveByCallBack)
					node:runAction(sequence)
				end
				local delayCallBackFunc = cc.CallFunc:create(delayCallBack)
				local delaySequence = cc.Sequence:create(delayTime,delayCallBackFunc)
				node:runAction(delaySequence)
			end
			
			-- skill 
			if v.skill ~= self.lastUseSkill then
				self.lastUseSkill = v.skill
				if v.skill ~= 0 then
					local skillLabel = ccui.Text:create()
					skillLabel:setFontSize(self.otherBloodFontSize)
					skillLabel:setColor(cc.c3b(255,255,0))
					local skillName = wd.GlobalData:getInstance():getSkillNameBySkillId(v.skill)
					targetPlayer:addChild(skillLabel)
					skillLabel:setString(skillName)
					skillLabel:setPosition(cc.p(((targetTeam == wd.PlayerType.ENEMY) and -100 or 170),20))
					local moveBy = cc.MoveBy:create(1.5,cc.p(((targetTeam == wd.PlayerType.ENEMY) and -100 or 100),0))
					local function moveByCallBackFunc()
						skillLabel:removeFromParent()
					end
					local moveByCallBack = cc.CallFunc:create(moveByCallBackFunc)
					local sequence = cc.Sequence:create(moveBy,moveByCallBack)
					skillLabel:runAction(sequence)
				end
			end
			
			-- buff
			if v.type == wd.ActionType.ADD_BUFF or v.type == wd.ActionType.DEC_BUFF then
				local buffItem = wd.skillHandler:getBuffItemById(v.value)
				if buffItem then
					local buffName = buffItem:getName()
					local roundTime = buffItem:getRoundTime()
					local buffInfo = {}
					buffInfo.id = v.value
					buffInfo.buffName = buffName
					buffInfo.roundTime = roundTime
					if v.value == 13 then
						buffInfo.roundTime = 1
					end
					if buffInfo.roundTime < 99 and v.value ~= 14 and v.value ~= 9 then
						if v.type == wd.ActionType.ADD_BUFF then
							table.insert(self.buffInfoList[v.target_Pos],buffInfo)
						else
							table.insert(self.decBuffInfoList[v.target_Pos],buffInfo)
						end
					end
				end
			end
			
		end
	end
end



function BattleLayer:setBuffLabel()
	if self.buffInfoList ~= {} then
		for target,buffInfo in pairs(self.buffInfoList) do
			if buffInfo ~= {} then
				local team = target%10
				local teamMember = math.floor(target/10)-1
				local name = string.format("battle_player%d",teamMember)
				local player = self.panelTable[team]:getChildByName(name)
				if player then
					local buffLabel = player:getChildByTag(BUFF_TAG)
					if buffLabel then
						local str = "" 
						for i,v in ipairs(buffInfo) do
							if v.roundTime == 0 then
								if self.decBuffInfoList[target]~= {} then
									for k,p in ipairs(self.decBuffInfoList[target]) do
										if p.id == v.id then
											table.remove(self.buffInfoList[target],i)
											table.remove(self.decBuffInfoList[target],k)
											break
										end
 									end
								end
							end
							local startIndex,lastIndex,curStr = string.find(str,"%[(.-)%]")  
							if curStr then
								-- 护盾特殊处理
								if v.id == 13 then
									str=curStr..((v.roundTime <= 0) and "" or string.format("%s",v.buffName))
								else
									str=curStr..((v.roundTime <= 0) and "" or string.format("%s %d",v.buffName,v.roundTime))
								end
									
							else
								-- 护盾特殊处理
								if v.id == 13 then
									str=((v.roundTime <= 0) and "" or string.format("%s",v.buffName))
								else
									str=((v.roundTime <= 0) and "" or string.format("%s %d",v.buffName,v.roundTime))
								end
							end
							if str ~= "" then
								str = string.format("[ %s ]",str)
							end
						end
						buffLabel:setString(str)
					end
				end
			end
		end
	end
end

function BattleLayer:resetBuffLabel()
	if self.buffInfoList ~= {} then
		for target,buffInfo in pairs(self.buffInfoList) do
			if buffInfo ~= {} then
				local team = target%10
				local teamMember = math.floor(target/10)-1
				local name = string.format("battle_player%d",teamMember)
				local player = self.panelTable[team]:getChildByName(name)
				if player then
					local buffLabel = player:getChildByTag(BUFF_TAG)
					if buffLabel then
						buffLabel:setString("")
					end
				end
			end
		end
	end
	self.buffInfoList = {}
	self.decBuffInfoList = {}
end

function BattleLayer:setBuffRoundTime()
	if self.buffInfoList ~= {} then
		for target,buffInfo in pairs(self.buffInfoList) do
			if buffInfo ~= {} then
				for i,v in ipairs(buffInfo) do
					v.roundTime = v.roundTime - 1
					if v.roundTime <=0 then
						v.roundTime = 0
					end
				end
			end
		end
	end
end

function BattleLayer:addBattleEndSprite(node)
	self.searchSprite = cc.Sprite:create()
	node:addChild(self.searchSprite)
	self.searchSprite:setPosition(cc.p(self.visibleSize.width/2,self.visibleSize.height/2+50))
	self.searchSprite:setVisible(false)
	self.searchAnimation = cc.Animation:create()
	for i = 1, 17 do
		self.searchAnimation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("search_%02d.png", i)))
	end
	self.searchAnimation:setDelayPerUnit(0.1)
	self.searchAnimation:setLoops(1)
	self.searchAnimation:retain()
	
	self.tickSprite = cc.Sprite:create()
	node:addChild(self.tickSprite)
	self.tickSprite:setPosition(cc.p(self.visibleSize.width/2,self.visibleSize.height/2+105))
	
	self.resultSprite = cc.Sprite:create()
	node:addChild(self.resultSprite)
	self.resultSprite:setPosition(cc.p(self.visibleSize.width/2,self.visibleSize.height/2+105))
end

function BattleLayer:setBattleSearchSprite(state)
	if state == true then
		local animate = cc.Animate:create(self.searchAnimation)
		local repeatAction = cc.RepeatForever:create(animate)
		self.searchSprite:runAction(repeatAction)
		self.searchSprite:setVisible(true)
	else
		self.searchSprite:stopAllActions()
		self.searchSprite:setVisible(false)
		self.tickSprite:setVisible(false)
	end
end

function BattleLayer:createLayerMenu(level)

    self.index = level

    local node = tolua.cast(cc.CSLoader:createNode("ui/battle/BattleScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
	
	self:addBattleEndSprite(node)
	
    ccui.Helper:doLayout(node)

    local layout = node:getChildByName("Panel_head")
	
	local vsPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_vs_title"), "ccui.Widget")
	self.tipsBox = tolua.cast(vsPanel:getChildByName("Tips_Box"), "cc.Sprite")
	self.tipsLabel = tolua.cast(self.tipsBox:getChildByName("Desc_Label"), "ccui.Text")

    self.mapName = tolua.cast(layout:getChildByName("Map_Title"), "cc.Sprite")
	local mapCount = wd.GlobalData:getInstance():getMapCount()
    if self.index < mapCount then
		self.mapName:setSpriteFrame(string.format("map_name_lv%d.png",self.index))
	else
		self.mapName:setSpriteFrame(string.format("maptitle_%d.png",self.index))
	end

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
	local x,y = backBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.BackMain] = {}
	wd.newGuidePos[wd.newGuideStep.BackMain].pos = backBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.BackMain].size = backBtn:getContentSize()
    local function backCallback(sender,eventType)

        if eventType == ccui.TouchEventType.ended then
			local event = cc.EventCustom:new("Check_New_Tip")
			cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
            self:setVisible(false)
			--local event = cc.EventCustom:new("Handle_NewGuile")
			--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
            if self.clippingLayer then
                local event = cc.EventCustom:new("guidance_giftOpen")
                cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                self.clippingLayer:removeFromParent()
                self.clippingLayer = nil
            end
        end
    end
    
    ------------------------------新手引导----------------------------
   local listener = cc.EventListenerCustom:create("guidance_closeBattleLayer", function(EventCustom) 
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(backBtn,30,50,115,80)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"差点忘了，成就还可以领取")
            table.insert(msg,"{r=[元宝等道具]}")
            table.insert(msg,"哦！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            self.clippingLayer = clippingLayer
        end
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    --------------------------------------------------------------------

    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(backCallback)
    
    local packageBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Package_Button"), "ccui.Widget")
    packageBtn:setPressedActionEnabled(true)

    packageBtn:addTouchEventListener(
    function (sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            local layerClass = require("src.game.package.PackageEquipLayer")
            local layer = layerClass.create()
            self:addChild(layer)
        end
    end
    )
    
    local skillBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Skill_Button"), "ccui.Button")
    skillBtn:setPressedActionEnabled(true)
    skillBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.skill.SkillLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    
    local tripodBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Tripod_Button"), "ccui.Button")
    tripodBtn:setPressedActionEnabled(true)
    tripodBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if self.clippingLayer then
                    self.clippingLayer:removeFromParent()
                    self.clippingLayer = nil
                end
                local layerClass = require("src.game.tripod.MeltingLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
    
    ------------------------------新手引导----------------------------
   listener = cc.EventListenerCustom:create("guidance_tripodOpen", function(EventCustom) 
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(tripodBtn,30,50,115,80)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"多余的装备还可以在龙鼎回收，有概率获得")
            table.insert(msg,"{r=[红色神器]}")
            table.insert(msg,"哦！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            self.clippingLayer = clippingLayer
        end
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    --------------------------------------------------------------------
    
    
    local mapBtn = ccui.Helper:seekWidgetByName(node,"Selectmap_Button")
    mapBtn:setPressedActionEnabled(true)
    
    ------------------------------新手引导----------------------------
    local openBattle = function(EventCustom)
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(mapBtn,30,50,115,80)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"这怪物太弱了，咱们去")
            table.insert(msg,"{r=[换个地图]}")
            table.insert(msg,"玩玩！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            self.clippingLayer = clippingLayer
            self.guidanceIndex = 0
        end
    end
    listener = cc.EventListenerCustom:create("guidance_battleIsOpen", openBattle)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    local touchLayer
    listener = cc.EventListenerCustom:create("guidance_waitBoss", function(EventCustom)
        local winSize = cc.Director:getInstance():getWinSize()
        touchLayer = ccui.Layout:create()
        touchLayer:setContentSize(winSize.width,winSize.height)
        touchLayer:setTouchEnabled(true)
        self:addChild(touchLayer)
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    listener = cc.EventListenerCustom:create("Battle_Win", function(EventCustom) 
        if touchLayer and not self.bossFightFlag then
            touchLayer:removeFromParent()
            touchLayer = nil
            local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
            if clippingLayer then
                clippingLayer:setGuidance(mapBtn,30,50,115,80)
                local msgTable = {}
                local msg = {}
                table.insert(msg,"挑战BOSS胜利就会开启新的地图，咱们进入")
                table.insert(msg,"{r=[下一个地图]}")
                table.insert(msg,"咯！")
                table.insert(msgTable,msg)
                clippingLayer:setMsg(msgTable)
                self:addChild(clippingLayer)
                self.clippingLayer = clippingLayer
                self.guidanceIndex = 1
                cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Battle_Win")
            end
        end
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    --------------------------------------------------------------------
    
    mapBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("Check_New_Tip")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				local layerClass
				if self.index > mapCount then
					wd.pkHandler:requestPKPlayerList()
					layerClass = require("src.game.map.PKMapLayer")
					
				else
					layerClass = require("src.game.map.MapLayer")
				end
                local layer = layerClass.create(self.guidanceIndex)
                self:getParent():addChild(layer)
                self:setVisible(false)
                self.guidanceIndex = nil
                if self.clippingLayer then
                    self.clippingLayer:removeFromParent()
                    self.clippingLayer = nil
                end
            end
        end
    )
	
	local bossBtn = ccui.Helper:seekWidgetByName(node,"Boss_Button")
    bossBtn:setPressedActionEnabled(true)
    bossBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				-- local layerClass = require("src.game.boss.BossEliteLayer")
                -- local layer = layerClass.create()
                -- self:addChild(layer)
				wd.showRichTips(4,"暂未开放")
            end
        end
    )
	self.newBossSprite = tolua.cast(bossBtn:getChildByName("Tips_Effect"),"cc.Sprite")
    
	local quickBtn = ccui.Helper:seekWidgetByName(node,"Quick_Button")
	local x,y = quickBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.Quick] = {}
	wd.newGuidePos[wd.newGuideStep.Quick].pos = quickBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.Quick].size = quickBtn:getContentSize()
    quickBtn:setPressedActionEnabled(true)
    quickBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --wd.showSystemTips("暂未开放")
                local layerClass = require("src.game.battle.QuickBattleLayer")
                local layer = layerClass.create()
                layer:createLayerMenu(0, self.index)
                self:addChild(layer)
				--local event = cc.EventCustom:new("Handle_NewGuile")
				--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                if self.clippingLayer then
                    self.clippingLayer:removeFromParent()
                    self.clippingLayer = nil
                end
            end
        end
    )
    
    ------------------------------新手引导----------------------------
    local listener = cc.EventListenerCustom:create("guidance_quickBattle", function(EventCustom) 
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(quickBtn,30,50,115,80)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"是不是升级很慢呢，别急，咱们可以使用")
            table.insert(msg,"{r=[加速战斗]}")
            table.insert(msg,"，瞬间获得2小时经验！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self:addChild(clippingLayer)
            self.clippingLayer = clippingLayer
        end
    end)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    
    --------------------------------------------------------------------
    
	self.newQuickSprite = tolua.cast(quickBtn:getChildByName("Tips_Effect"),"cc.Sprite")
	
	local settingBtn = ccui.Helper:seekWidgetByName(node,"Setting_Button")
    settingBtn:setPressedActionEnabled(true)
    settingBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.battle.BattleSettingsLayer")
                local layer = layerClass.create()
                self:addChild(layer)
            end
        end
    )
	
	--[[local statisticsBtn = ccui.Helper:seekWidgetByName(node,"Statistics_Button")
    statisticsBtn:setPressedActionEnabled(true)
    statisticsBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.showSystemTips("暂未开放")
            end
        end
    )--]]
    
    self.roundLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Round_Label"), "ccui.TextAtlas")
    self.roundLabel:setString(string.format("0"))
    
    
    local leftPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_player_left"), "ccui.Layout")
    local rightPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_player_right"), "ccui.Layout")
    
    self.panelTable = {[0] = leftPanel, [1] = rightPanel}
    
	self.labelView = cc.Layer:create()
    local msgPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_message"), "ccui.Layout")
    msgPanel:addChild(self.labelView)
	self.labelViewSize = cc.size(msgPanel:getContentSize().width,msgPanel:getContentSize().height-20)
    self.labelView:setContentSize(self.labelViewSize)
	self.labelView:setPosition(0,8)	
	
	
    local scheduleTabel = {}

    function scheduleTabel.oneAction(dt)

        if self.theend == 0 then
            if self.before ~= self.round + 1 then
                self.before = self.round + 1
                self.roundLabel:setString(string.format("%d",self.before))
            end

            self:doAction(self.round, self.attack)
			
            self.attack = self.attack + 1
			
            if self.attack >= wd.GlobalData:getInstance():getBattleAttackNumber(self.round) then
                self.attack = 0
                self.round = self.round + 1
				self:setBuffRoundTime()
            end
            if self.round >= wd.GlobalData:getInstance():getBattleRoundNumber() then
				
				cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.actionSchedule)
				self.tickRound = 10
				
                self.battleSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(scheduleTabel.battleStart, 1, false)
				self.battleHandler:setTickMsg(self.tickRound)
				self:showRichLabel("tick")
				
                if wd.GlobalData:getInstance():getBattleResultWinTeam() == 0 then
					self.battleHandler:setEndMsg("win")
					local event = cc.EventCustom:new("Battle_Win")
					cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                else
					self.battleHandler:setEndMsg("lose")
                end

                if wd.GlobalData:getInstance():getBattleResultIsUpLevel() ~= 0 then
					self.battleHandler:setEndMsg("levelUp")
					self:showLevelUpSoundEffect()
                else
                    self:gameTheEnd()
                end
				
				self:showRichLabel("end")
				
                self.before = 0
                self.round = 0
                self.attack = 0
                self.battleTable = {}
				self.battleHandler:setBattleTable(self.battleTable)
                self.theend = 1
            end
        else
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.actionSchedule)
        end
    end

   function scheduleTabel.battleStart(dt)
		if not self.searchSprite:isVisible() then
			self:setBattleSearchSprite(true)
		end
		if self.tickRound ~= 0 then
			if self.tickRound == 10 then
				self:showEndAction("result")
			elseif self.tickRound <= 3 then
				self.tickSprite:setVisible(true)
				self.tickSprite:setSpriteFrame(string.format("reciprocal_%02d.png",self.tickRound))
			end
			self.tickRound = self.tickRound - 1
		else
			if self.tipsBox then
				self.tipsBox:setVisible(false)
			end
			if self.arenaRanking > 0 then
                self.isFamilyBoss = false
				wd.TranscodingSend:setArenaBattle(self.arenaRanking)
				self.arenaRanking = 0
			elseif self.revengeFight then
                self.isFamilyBoss = false
				wd.mailHandler:requestRevengeFight()
				self.revengeFight = false
            elseif self.familyBossBattle > 0 then
				self.isFamilyBoss = true
				wd.TranscodingSend:startFamilyBoss(self.familyBossBattle)
				self.familyBossBattle = 0
			elseif self.bossFightFlag then
				-- wd.TranscodingSend:setBattleBoss(self.bossFightIndex)  --ljg
                local role = wd.GlobalData:getInstance():getRoleData()
                local packge = NetPackage:create()
                packge:add("role_id",role:getRoleId())
                packge:add("map_id",self.bossFightIndex + 1)
                packge:add("type",self.bossFightType)
                packge = packge:encode()
                wd.TranscodingSend:luaSend(packge,ePCFightMapBoss)
				-- wd.bossHandler:requestFightBoss()
            elseif self.ectypeFightFlag then--挑战副本boss
                local role = wd.GlobalData:getInstance():getRoleData()
                local packge = NetPackage:create()
                packge:add("role_id",role:getRoleId())
                packge:add("id",self.ectypeTag)
                packge = packge:encode()
                wd.TranscodingSend:luaSend(packge,ePCFubenFight)
                self.ectypeFightFlag = false
			elseif self.pkFightFlag then
                self.isFamilyBoss = false
				--wd.pkHandler:requestPKPlayerList()
				wd.pkHandler:requestFightPlayer()
				self.pkFightFlag = false
			else
                self.isFamilyBoss = false
				wd.TranscodingSend:setBattle(0, self.index)
				if self.index ~= wd.GlobalData:getInstance():getLastLoginMapId() then
                    wd.GlobalData:getInstance():setLastLoginMapId(self.index)
                    self:getParent():hangsMapStatus()
                end
			end
		end
    end
    
    local function battleCallback(EventCustom)
		if self.bossFightFlag then
			local mapCount = wd.GlobalData:getInstance():getMapCount()  --从1开始
			local bossId   = wd.GlobalData:getInstance():getRoleData():getBossId() - 1--从1开始
			-- local winTeam  = wd.GlobalData:getInstance():getBattleResultWinTeam()
			if self.bossFightIndex < mapCount and self.bossFightIndex + 1 == bossId then
				self.index = self.bossFightIndex + 1
				self:getParent():showBattleLayer(self.index) 
			end
			self.bossFightFlag = false
            self.bossFightType = 0
		end
		self:setBattleSearchSprite(false)
		
        if self.battleSchedule ~= nil then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.battleSchedule)
            self.battleSchedule = nil
        end

        self.roundLabel:setString(string.format("0"))
		self:showEndAction("start")
		self:resetBuffLabel()
        self:getRoleData()

        self.theend = 0
		
        if self.actionSchedule ~= nil then
            cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.actionSchedule)
            self.actionSchedule = nil
        end
        
        self.actionSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(scheduleTabel.oneAction, 2.2, false)
    end
	
	local function setOfflineData()
		local offlineData = wd.GlobalData:getInstance():getOfflineData()
		if offlineData then
			self.battleHandler:setOfflineData(offlineData)
		end
	end
	
	local listener = cc.EventListenerCustom:create("OfflineData_Set", setOfflineData)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    
    local listener = cc.EventListenerCustom:create("Start_Battle", battleCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    
	self.battleSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(scheduleTabel.battleStart, 1, false)
	self.battleHandler:setTickMsg(self.tickRound)
	self:showRichLabel("tick")

end


function BattleLayer:showEndAction(actType)
	local spriteName
	if actType == "result" then
		if (wd.GlobalData:getInstance():getBattleResultWinTeam() ~= 0 and wd.GlobalData:getInstance():getBattleResultWinTeam() ~= 1) then
			return
		end
		spriteName = (wd.GlobalData:getInstance():getBattleResultWinTeam() == 0) and "battleWin" or "battleFailed"
	elseif actType == "start" then
		spriteName = "battleStart"
	end
	self.resultSprite:setSpriteFrame(string.format("%s_01.png",spriteName))
	local function actCallBackFunc()
		self.resultSprite:setVisible(false)
	end
	local actCallBack = cc.CallFunc:create(actCallBackFunc)
	self.resultSprite:setVisible(true)
	self.resultSprite:setOpacity(0)
	local delayTime = cc.DelayTime:create(0.5)
	local spawn = cc.Spawn:create(cc.ScaleBy:create(1,1.2),cc.FadeTo:create(1,255))
	local sequence = cc.Sequence:create(delayTime,spawn,cc.ScaleTo:create(0.5,1),actCallBack)
	self.resultSprite:runAction(sequence)
end

function BattleLayer:showSoundEffect()
	if self:isVisible() then
		if cc.UserDefault:getInstance():getBoolForKey("Sound") then
			cc.SimpleAudioEngine:getInstance():playEffect(cc.FileUtils:getInstance():fullPathForFilename("res/music/hitEffect.mp3"), false)
		end
	end
end
function BattleLayer:showLevelUpSoundEffect()
	if cc.UserDefault:getInstance():getBoolForKey("Sound") then
		cc.SimpleAudioEngine:getInstance():playEffect(cc.FileUtils:getInstance():fullPathForFilename("res/music/levelUpEffect.mp3"), false)
	end
end

function BattleLayer:setNewTipsState(quickFlag,bossFlag)
	if quickFlag then
		wd.showNewTipsEffect(self.newQuickSprite)
	else
		wd.hideNewTipsEffect(self.newQuickSprite)
	end
	if bossFlag then
		wd.showNewTipsEffect(self.newBossSprite)
	else
		wd.hideNewTipsEffect(self.newBossSprite)
	end
end


return BattleLayer