local BattleOfflineLayer = class("BattleOfflineLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
	print(string.format(...))
end


function BattleOfflineLayer.create()
	local layer = BattleOfflineLayer.new()
	layer:createLayerMenu()
	return layer
end

function BattleOfflineLayer:ctor()
	self.visibleSize = cc.Director:getInstance():getVisibleSize()
	self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.battleHandler = wd.battleHandler
end

function BattleOfflineLayer:clear()
	--cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Text_Set")
	--self:removeFromParent()
	self:setVisible(false)
end

function BattleOfflineLayer:createLayerMenu()
	local node = tolua.cast(cc.CSLoader:createNode("ui/battle/BattleOfflineLayer.csb"), "ccui.Widget")
	self:addChild(node)
	
	node:setContentSize(self.visibleSize)
	node:setPosition(self.origin)
	ccui.Helper:doLayout(node)
	
	local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	local x,y = backBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.QuickClose] = {}
	wd.newGuidePos[wd.newGuideStep.QuickClose].pos = self:convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.QuickClose].size = backBtn:getContentSize()
	backBtn:setPressedActionEnabled(true)
    ------------------------------新手引导----------------------------
    local listener = cc.EventListenerCustom:create("guidance_offlineOpen", function(EventCustom) 
        local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
        if clippingLayer then
            clippingLayer:setGuidance(backBtn,30,10,115,115,nil,true)
            local msgTable = {}
            local msg = {}
            table.insert(msg,"哈哈，")
            table.insert(msg,"{r=[瞬间提升N级]}")
            table.insert(msg,"，是不是很爽啊！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
            self.clippingLayer = clippingLayer
            self:addChild(clippingLayer)
        end
    end)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1)
    ------------------------------------------------------------------
    
    
	backBtn:addTouchEventListener(
	function(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			local event = cc.EventCustom:new("Check_New_Tip")
			cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
            if self.clippingLayer then
                self.clippingLayer:removeFromParent()
                self.clippingLayer = nil
            end
			self:clear()
			--local event = cc.EventCustom:new("Handle_NewGuile")
			--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)

			if require("src.game.checkIn.CheckInTime"):check() then
				local layerClass = require("game.checkIn.CheckInLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
			end
			
		end
	end
	)
	local scrollView = tolua.cast(ccui.Helper:seekWidgetByName(node,"ScrollView"), "ccui.ScrollView")
	local function setText()
		local richElementList = self.battleHandler:getOfflineElementList()
		if richElementList then
			if scrollView:getChildByTag(1) then
				scrollView:getChildByTag(1):removeFromParent()
			end
			self.battleHandler:resetOfflineElementList()
			local count = #richElementList
			local labelNode = cc.Node:create()
			labelNode:setContentSize(804,count*(20+10))
			scrollView:setInnerContainerSize(labelNode:getContentSize())
			for index = count ,1,-1 do
				local richLabel = self:createRichLabelByElementList(richElementList[index])
				labelNode:addChild(richLabel)
				richLabel:setPosition(10+richLabel:getContentSize().width/2,scrollView:getInnerContainerSize().height - 20 - (index-1)*(20+10))
			end
			labelNode:setTag(1)
			scrollView:addChild(labelNode)
		end
		scrollView:jumpToTop()
		self:setVisible(true)
		--local event = cc.EventCustom:new("Handle_NewGuile")
		--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	local listenerTextSet = cc.EventListenerCustom:create("Text_Set", setText)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerTextSet, 1)
end

function BattleOfflineLayer:createRichLabelByElementList(richElementList)
	local richTextLabel = ccui.RichText:create()
	if richElementList then
		for i,v in ipairs(richElementList) do
			richTextLabel:pushBackElement(v)
		end
	end
	
	richTextLabel:formatText()
	return richTextLabel
end
return BattleOfflineLayer