
local ChargeLayer = class("ChargeLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function ChargeLayer.create()
    local layer = ChargeLayer.new()
    layer:createLayerMenu()
    return layer
end

function ChargeLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    self.mainPanel = nil
    self.itemPanel = nil
end

function ChargeLayer:setData()

    local levelLabel = tolua.cast(ccui.Helper:seekWidgetByName(self.mainPanel,"VipLevel_Label"), "ccui.TextAtlas")

    local expPanel = tolua.cast(ccui.Helper:seekWidgetByName(self.mainPanel,"Panel_Exp"), "ccui.Widget")
    
    local levelLabelNow = tolua.cast(ccui.Helper:seekWidgetByName(self.mainPanel,"VipLevel_Label_Now"), "ccui.TextAtlas")

    local needexpLabel = tolua.cast(ccui.Helper:seekWidgetByName(expPanel,"NeedExp_Label"), "ccui.Text")

    local needexpTitle = tolua.cast(ccui.Helper:seekWidgetByName(expPanel,"NeedExp_Title"), "ccui.Text")

    local gemTitle = tolua.cast(ccui.Helper:seekWidgetByName(expPanel,"Gem_Title"), "ccui.Text")

    local expBar = tolua.cast(ccui.Helper:seekWidgetByName(expPanel,"Exp_Progress"), "ccui.LoadingBar")

    local expLabel = tolua.cast(ccui.Helper:seekWidgetByName(expPanel,"Exp_Label"), "ccui.Text")

    local function updataCallback()

        local level = wd.GlobalData:getInstance():getRoleVip()

        levelLabel:setString(wd.GlobalData:getInstance():getRoleVip())

        levelLabelNow:setString(wd.GlobalData:getInstance():getRoleVip())
        -- gemLabel:setString(wd.GlobalData:getInstance():getRoleGem())


        local number = wd.GlobalData:getInstance():getVipXmlCount()
        
        local exp = wd.GlobalData:getInstance():getRoleVipExp()
        local expMax = 999999

        if level < number then
            level = level + 1
        end
        
        local item = wd.GlobalData:getInstance():getVipXmlData(level)
        if item ~= nil then
            expMax = item:getMaxExp()
        end
        if level >= number-1 then
            needexpTitle:setString("")
            gemTitle:setString(string.format("VIP已达最高等级"))
            needexpLabel:setString("")
        else
            needexpTitle:setString("VIP"..level)
            needexpLabel:setString(expMax - exp)
        end


        expLabel:setString(string.format("%d/%d", exp, expMax))

        if exp > expMax then   
            exp = expMax
        end

        expBar:setPercent(exp/expMax*100)

    end

    local listener = cc.EventListenerCustom:create("Update_Vip", updataCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);

    updataCallback()
end

function ChargeLayer:initItem()


    local role = wd.GlobalData:getInstance():getRoleData()
    local width = self.itemPanel:getContentSize().width/4
    local height = self.itemPanel:getContentSize().height/2

    local number = wd.GlobalData:getInstance():getChargeXmlCount("gem")

    local function chargeCallback(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            --[[local item = wd.GlobalData:getInstance():getChargeXmlData("gem",sender:getTag())
			local payDir = "http://wendingttlx.51vip.biz:"
            if item ~= nil then
                local role = wd.GlobalData:getInstance():getRoleData()
                local server = wd.GlobalData:getInstance():getGameServerForId(wd.GlobalData:getInstance():getAreaId())
                if server ~= nil and role ~= nil then
					local port = server:getPort()
					payDir = string.format("%s%d",payDir,port)
					print(payDir)
                    wd.SdkApi:pay(item:getMoney(), server:getServerId(), server:getName(), role:getRoleId(), role:getName(), role:getLevel(),payDir, string.format("%d",item:getChargeCode()))
                end
            else
                wd.showRichTips(4,"充值数据有误")
            end--]]
			
			local item = wd.GlobalData:getInstance():getChargeXmlData("gem",sender:getTag())
			if item ~= nil then
				if not wd.SdkApi:isTencentSdk() then
					wd.GlobalData:getInstance():setChargeData(item)
					wd.TranscodingSend:createOrder(item:getChargeCode(),item:getMoney())
				else
					wd.GlobalData:getInstance():setChargeData(item)
					wd.TranscodingSend:tencentPay()
				end
			else
				wd.showRichTips(4,"充值数据有误")
			end
        end
    end

    for i=0,number-1 do
        local item = wd.GlobalData:getInstance():getChargeXmlData("gem",i)
        
        if item == nil then
            break
        end
        
        local chargeNode = cc.CSLoader:createNode("ui/charge/ChargeNode.csb")
        chargeNode:setPosition(width/2+width*((6-i)%4), height/2+height*(math.floor(i/3)>0 and 1 or 0))
        
        local image = tolua.cast(chargeNode:getChildByName("Charge_Item"), "cc.Sprite")
        image:setSpriteFrame(string.format("charge_item%d.png",item:getChargeId()))
        
        local getgamLabel = tolua.cast(chargeNode:getChildByName("GetGem_Label"), "ccui.TextAtlas")
        getgamLabel:setString(item:getGetGem())
        
        local givegamLabel = tolua.cast(chargeNode:getChildByName("GiveGem_Label"), "ccui.Text")
        givegamLabel:setString(string.format("送元宝%d",item:getGiveGem()))
        
        --[[if role:getChargeDouble() == true then
            local double = tolua.cast(chargeNode:getChildByName("Double_Title"), "cc.Sprite")
            double:setVisible(true)
        end--]]
		if item:getDoubleGive() ~= 0 then
			if wd.GlobalData:getInstance():isInOrderList(item:getChargeCode()) == false then
				local double = tolua.cast(chargeNode:getChildByName("Double_Title"), "cc.Sprite")
				double:setVisible(true)
			end
		end
        
        local moneyLabel = tolua.cast(chargeNode:getChildByName("Money_Label"), "ccui.TextBMFont")
        moneyLabel:setString(string.format("¥%d",item:getMoney()))
        
        local buyBtn = tolua.cast(chargeNode:getChildByName("Buy_Button"), "ccui.Widget")
        buyBtn:setTag(i)
        buyBtn:setPressedActionEnabled(true)
        buyBtn:addTouchEventListener(chargeCallback)
        
        self.itemPanel:addChild(chargeNode)
    end
    
end

function ChargeLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/charge/ChargeScene.csb"), "ccui.Widget")
    self:addChild(node)
    self.mainPanel = node
    
    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("Check_New_Tip")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_Vip")
                self:removeFromParent()
            end
        end
    )

    local function vipCallback(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_Vip")
            local layerClass = require("src.game.charge.VipLayer")
            local layer = layerClass.create()
            self:getParent():addChild(layer)
            self:removeFromParent()
        end
    end
    
    -- local vipBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Vip_Button"), "ccui.Button")
    -- vipBtn:addTouchEventListener(vipCallback)
    local govipBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"GoVip_Button"), "ccui.Button")
    govipBtn:setPressedActionEnabled(true)
    govipBtn:addTouchEventListener(vipCallback)
    
    self.itemPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Charge"), "ccui.Widget")

    self:setData()

    self:initItem()
    
end


return ChargeLayer