
local EctypeScene = class("EctypeScene",function()
    return cc.Layer:create()
end)

local ectypeName = 
{
    [1] = "技能boss",
    [2] = "贪财boss",
    [3] = "天魂boss",
    [4] = "神点boss",
}

function EctypeScene.create()
    local layer = EctypeScene.new()
    layer:createLayerMenu()
    return layer
end

function EctypeScene:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
end

function EctypeScene:createLayerMenu()
    local role = wd.GlobalData:getInstance():getRoleData()
    local node = tolua.cast(cc.CSLoader:createNode("ui/ectype/EctypeScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Fuben_Num")
                self:removeFromParent()
            end
        end
    )
    
    local addBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Add_Button"), "ccui.Button")
    addBtn:setPressedActionEnabled(true)
    addBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.tips.TipsBoxLayer")
				local msgTable = {}
				local msg = {}
				local num = role:getRoleExtendData("buy_fuben_num")
				table.insert(msg,"是否花")
				table.insert(msg,string.format("{y=[%d元宝]}",20*(num + 1)))
				table.insert(msg,"购买")
				table.insert(msg,string.format("{g=[%d次]}",1))
				table.insert(msg,"副本挑战次数?")
				table.insert(msgTable,msg)
				local function buyNumber()
                    if wd.GlobalData:getInstance():getRoleGem() < 20*(num + 1) then
                        local layerClass = require("src.game.charge.ChargeTipsScene")
                        local layer = layerClass:create()
                        self:getParent():addChild(layer)
                    else
                        local packge = NetPackage:create()
                        packge:add("role_id",role:getRoleId())
                        packge = packge:encode()
                        wd.TranscodingSend:luaSend(packge,ePCBuyFubenNumber) 
                    end
				end
				local buyLayer = layerClass.create("ui/commonality/16.png", msgTable,buyNumber)
				self:addChild(buyLayer)
            end
        end
    )
    
    local callBack = function(sender,eventType)
        if eventType == ccui.TouchEventType.ended then
            local ectypeTag = sender:getTag()
            self:getParent():setEctypeBattle(true,ectypeTag,ectypeName[ectypeTag])
            cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Fuben_Num")
            self:removeFromParent()
        end
    end
        
    local listView = tolua.cast(ccui.Helper:seekWidgetByName(node,"list_view"), "ccui.ListView")
    
    for n = 1,4 do
        local btn = ccui.Layout:create()
        btn:setContentSize(262,437)
        -- btn:setTouchEnabled(true)
        -- btn:addTouchEventListener(callBack)
        -- btn:setTag()
        local item = tolua.cast(cc.CSLoader:createNode("ui/ectype/EctypeItem.csb"), "ccui.Widget")
        btn:addChild(item)
        
        local bossSprite = item:getChildByName("boss_sprite")
        local bossName = item:getChildByName("boss_name")
        local button = item:getChildByName("button")
        local btnHelp = item:getChildByName("button_help")
        btnHelp:setPressedActionEnabled(true)
        btnHelp:addTouchEventListener(function(sender,eventType) 
            if eventType == ccui.TouchEventType.ended then
                local layer = require("src.game.ectype.EctypeInfoScene"):create(n)
                self:addChild(layer)
            end
        end)
        button:setPressedActionEnabled(true)
        button:addTouchEventListener(callBack)
        button:setTag(n)
        
        bossSprite:setSpriteFrame("ui/ectype/"..n..".png")
        bossName:setSpriteFrame("ui/ectype/0"..n..".png")
        
        listView:pushBackCustomItem(btn)
    end    
    
    local challengeNum = tolua.cast(ccui.Helper:seekWidgetByName(node,"challenge_num"), "ccui.Text")
    
    local updateCallBack = function()
        challengeNum:setString(tonumber(role:getRoleExtendData("fuben_num")))
    end
    updateCallBack()
    local listener = cc.EventListenerCustom:create("Buy_Fuben_Num", updateCallBack)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    
end


return EctypeScene