if nil == wd then
    return
end

function wd.equipEffect(item, node)
    local strengthenLevel = item:getStrengthenLevel()
    local quality = item:getQuality()
    
    wd.equipEffectAction(strengthenLevel, quality, node)
end

function wd.equipEffectAction(strengthenLevel, quality, node)
	if node:getChildByTag(999) then
		node:getChildByTag(999):stopAllActions()
		node:getChildByTag(999):removeFromParent()
		
	end
    if strengthenLevel >= 10 then
        local sprite = cc.Sprite:create()
        local animation = cc.Animation:create()
        
        if strengthenLevel >= 15 then
            for i = 1, 12 do
                animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("star3_%02d.png", i)))
            end
        elseif strengthenLevel >= 13 then
            for i = 1, 16 do
                animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("star2_%02d.png", i)))
            end
        else
            for i = 1, 15 do
                animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("star1_%02d.png", i)))
            end
        end
    
        animation:setDelayPerUnit(0.1)
        animation:setLoops(1)
        local action = cc.Animate:create(animation)

        local repeatAction = cc.RepeatForever:create(action)

        sprite:runAction(repeatAction)
        sprite:setPosition(35,35)
		sprite:setTag(999)
        node:addChild(sprite)
    end
    
    if quality >= 2 then
        local sprite = cc.Sprite:create()
        local animation = cc.Animation:create()
        
        for i = 1, 11 do
            animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("turn_%02d.png", i)))
        end

        animation:setDelayPerUnit(0.1)
        animation:setLoops(1)
        local action = cc.Animate:create(animation)
        local repeatAction = cc.RepeatForever:create(action)

        sprite:runAction(repeatAction)
        sprite:setPosition(35,35)
		sprite:setTag(999)
        node:addChild(sprite)
    end
end

function wd.meltingEquipEffect(node, x ,y)

    local sprite = cc.Sprite:create()
    local animation = cc.Animation:create()

    for i = 1, 4 do
        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("meltingEquip_%02d.png", i)))
    end

    animation:setDelayPerUnit(0.08)
    animation:setLoops(1)
    local action = cc.Animate:create(animation)
    
    local function delayCallBackFunc(sender)
        sprite:removeFromParent()
    end

    local delayCallBack = cc.CallFunc:create(delayCallBackFunc)
    local sequenceAction = cc.Sequence:create(action, delayCallBack)

    sprite:runAction(sequenceAction)
    sprite:setPosition(x,y)
    node:addChild(sprite)

end

function wd.soulEffect(quality,node)
	--[[if not node then
		print("node nil..")
		return
	end
	local sprite = cc.Sprite:create()
	local animation = cc.Animation:create()
	
	if quality == 2 then
		for i = 1, 11 do
			animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("soulSubEffect_%02d.png", i)))
		end
	elseif quality == 3 then
		for i = 1, 11 do
			animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("soulEffect_%02d.png", i)))
		end
	else
		return
	end
		
	

	animation:setDelayPerUnit(0.2)
	animation:setLoops(1)
	local action = cc.Animate:create(animation)

	local repeatAction = cc.RepeatForever:create(action)

	sprite:runAction(repeatAction)
	sprite:setPosition(35,38)
	node:addChild(sprite)--]]
end

function wd.itemEffect(node)
	if not node then
		print("node nil..")
		return
	end
	local sprite = cc.Sprite:create()
	local animation = cc.Animation:create()
	
	for i = 1,22 do
		animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("itemEffect_%02d.png", i)))
	end
		
	animation:setDelayPerUnit(0.08)
	animation:setLoops(1)
	local action = cc.Animate:create(animation)

	local repeatAction = cc.RepeatForever:create(action)

	sprite:runAction(repeatAction)
	sprite:setPosition(35,34)
	node:addChild(sprite)
end

function wd.showNewTipsEffect(sprite)
	if sprite:isVisible() then
		return
	end
	sprite:setVisible(true)
	local animation = cc.Animation:create()
	for i = 1, 9 do
		animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("newTips_%02d.png", i)))
	end
	animation:setDelayPerUnit(0.08)
	animation:setLoops(1)
	local action = cc.Animate:create(animation)

	local repeatAction = cc.RepeatForever:create(action)

	sprite:runAction(repeatAction)
end

function wd.hideNewTipsEffect(sprite)
	if not sprite:isVisible() then
		return
	end
	sprite:stopAllActions()
	sprite:setVisible(false)
end