
local EquipUpgradeLayer = class("EquipUpgradeLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function EquipUpgradeLayer.create()
    local layer = EquipUpgradeLayer.new()
    return layer
end

function EquipUpgradeLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function EquipUpgradeLayer:getEquipUpgrade(serverId)

    local equipUpgrade = nil
    local number = wd.GlobalData:getInstance():getEquipUpgradeCount()
    for i=0,number-1 do
        equipUpgrade = wd.GlobalData:getInstance():getEquipUpgrade(i)
        local contents = equipUpgrade:getUpgradeId()
        
        if contents == serverId then
            return equipUpgrade
        end
    
    end
    
    return nil
end

function EquipUpgradeLayer:getEquipUpgradeList(str)
    local awardList = {}
    local id,itemCount,type,startIndex,endIndex
    while(str ~= "")
    do
        local item = {}
        startIndex,endIndex,type,id,itemCount = string.find(str,"(%d)#(%d+)|(%d+)")
        item.id = tonumber(id)
        item.itemCount = tonumber(itemCount)
        item.type = tonumber(type)
        table.insert(awardList,item)
        str = string.sub(str,endIndex+2,-1)
    end
    return awardList
    
end

function EquipUpgradeLayer:createLayerMenu(serverId)
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/EquipUpgradeLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)


    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )

    local cancelBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Cancel_Button"), "ccui.Widget")
    cancelBtn:setPressedActionEnabled(true)
    cancelBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local item = wd.GlobalData:getInstance():getEquipItemForId(serverId)
    
    
    local equipgUpgrade = self:getEquipUpgrade(item:getEquipId())
   
    local text1 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Text1"), "ccui.Text")
    local text2 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Text2"), "ccui.Text")
    -- local status1 = false
    -- local status2 = false
    -- local status3 = false
    local statusTable = 
    {
        [1] = false,
        [2] = false,
        [3] = false
    }
    

    if equipgUpgrade == nil or equipgUpgrade:getCounts() == "0" then
        ccui.Helper:seekWidgetByName(node,"Text_over"):setVisible(true)
    else
        local list = self:getEquipUpgradeList(equipgUpgrade:getCounts())
        
        -- if list[1] then
        --     local item1 = wd.GlobalData:getInstance():getToolsItemInXml(list[1].id)
        --     ccui.Helper:seekWidgetByName(node,"Text_need1"):setString(item1:getName() .. " X " .. list[1].itemCount)
        -- end
        -- if list[2] then
        --     local item2 = wd.GlobalData:getInstance():getToolsItemInXml(list[2].id)
        --     ccui.Helper:seekWidgetByName(node,"Text_need2"):setString(item2:getName() .. " X " .. list[2].itemCount)
        -- end
        -- if list[3] then
        --     local item3 = wd.GlobalData:getInstance():getToolsItemInXml(list[3].id)
        --     ccui.Helper:seekWidgetByName(node,"Text_need3"):setString(item3:getName() .. " X " .. list[3].itemCount)
        -- end
        
        

        -- local tools1 = wd.GlobalData:getInstance():getToolsItemForId(list[1].id)
        -- local tools2 = wd.GlobalData:getInstance():getToolsItemForId(list[2].id)
        -- local tools3 = wd.GlobalData:getInstance():getToolsItemForId(list[3].id)
        -- if tools1 ~= nil then
        --     ccui.Helper:seekWidgetByName(node,"Text_have1"):setString("X " .. tools1:getQuantity())
        --     if tonumber(tools1:getQuantity()) >= list[1].itemCount then
        --         status1 = true
        --     end
        -- else
        --     ccui.Helper:seekWidgetByName(node,"Text_have1"):setString("X " .. 0)
        -- end

        -- if tools2 ~= nil then
        --     ccui.Helper:seekWidgetByName(node,"Text_have2"):setString("X " .. tools2:getQuantity())
        --     if tonumber(tools2:getQuantity()) >= list[2].itemCount then
        --         status2 = true
        --     end
        -- else
        --     ccui.Helper:seekWidgetByName(node,"Text_have2"):setString("X " .. 0)
        -- end

        -- if tools3 ~= nil then
        --     ccui.Helper:seekWidgetByName(node,"Text_have3"):setString("X " .. tools3:getQuantity())
        --     if tonumber(tools3:getQuantity()) >= list[3].itemCount then
        --         status3 = true
        --     end
        -- else
        --     ccui.Helper:seekWidgetByName(node,"Text_have3"):setString("X " .. 0)
        -- end
        for i,v in ipairs(list) do
            local item = wd.GlobalData:getInstance():getToolsItemInXml(list[i].id)
            ccui.Helper:seekWidgetByName(node,"Text_need"..i):setString(item:getName() .. " X " .. list[i].itemCount)
            local tools = wd.GlobalData:getInstance():getToolsItemForId(list[i].id)
            if tools ~= nil then
                ccui.Helper:seekWidgetByName(node,"Text_have"..i):setString("X " .. tools:getQuantity())
                if tonumber(tools:getQuantity()) >= list[i].itemCount then
                    statusTable[i] = true
                end
            else
                ccui.Helper:seekWidgetByName(node,"Text_have"..i):setString("X " .. 0)
            end
            ccui.Helper:seekWidgetByName(node,"Panel_"..i):setVisible(true)            
        end
        for i,v in ipairs(list) do
            
            local btn = ccui.Button:create("item_button.png", "item_button.png", "", ccui.TextureResType.plistType)
            btn:setAnchorPoint(cc.p(0,0))
            local itemNode = tolua.cast(cc.CSLoader:createNode("ui/boss/ChallengeItemNode.csb"),"ccui.Widget")
            btn:addChild(itemNode)
            itemNode:getChildByName("boss_tips_probability_1"):setVisible(false)
            local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
            if v.type == 1 then
                local item = wd.GlobalData:getInstance():getToolsItemInXml(v.id)
                local colorStr = string.format("%02d.png",item:getQuality())
                local image = tolua.cast(itemNode:getChildByName("Item_Sprite"), "cc.Sprite")
                image:setSpriteFrame(string.format("%d.png",v.id))
                if item:getQuality() == 5 then
                   wd.itemEffect(image)
                end
                local quantityLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
                quantityLabel:setString(" ")
                color:setSpriteFrame(colorStr)
                ccui.Helper:seekWidgetByName(node,"Panel_have" .. i):addChild(btn)
                ccui.Helper:seekWidgetByName(node,"Panel_have" .. i):setScale(0.5)
                ccui.Helper:seekWidgetByName(node,"Panel_have" .. i):setPosition(cc.p(ccui.Helper:seekWidgetByName(node,"Panel_have" .. i):getPositionX(),
                    ccui.Helper:seekWidgetByName(node,"Panel_have" .. i):getPositionY()-20))
            end
        end
    end

    local sureBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Sure_Button"), "ccui.Widget")
    sureBtn:setPressedActionEnabled(true)
    sureBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if equipgUpgrade == nil or equipgUpgrade:getCounts() == "0" then
                    wd.showRichTips(4,"已经达到最高阶级")  
                else
                    if statusTable[1] == true or statusTable[2] == true or statusTable[3] == true then 
                        wd.TranscodingSend:equipmentUpGrade(serverId)
                    else
                        wd.showRichTips(4,"进阶材料不足") 
                    end
                end
                self:removeFromParent()
            end
        end
    )
end


return EquipUpgradeLayer