
local FamilyDataHandler = class("FamilyDataHandler")

local cclog = function(...)
    print(string.format(...))
end


function FamilyDataHandler:ctor()
	self:initData()
	self:registerEventListener()
end

function FamilyDataHandler:getInstance()
	if not self.instance then
		self.instance = FamilyDataHandler.new()
	end
	return self.instance
end

function FamilyDataHandler:destroyInstance()
    if self.instance then
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_All_FamilyInfo")
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Family_MemberList")
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Family_ApplyerList")
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Open_Family_Shop")
        cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Open_Family_Card")        
        self.instance = nil
    end
end

function FamilyDataHandler:initData()
	self.familyList = {}
	self.canJoinFamilyList = {}
	self.changeNotice = {}
	self.memberList = {}
	self.applyerList = {}
	self.shopShowList = {}
	self.buyNameList = {}
	self.familyCard = {}
	self.jobName = {
		[1] = "族长",
		[2] = "副族长",
		[3] = "族员",
	}
	self.cardName = {
		[1] = "一级同福卡",
		[2] = "二级同福卡",
		[3] = "三级同福卡",
		[4] = "四级同福卡",
		[5] = "五级同福卡",
		[6] = "六级同福卡",
		[7] = "七级同福卡",
	}
end



function FamilyDataHandler:requestOpenFamily()
	wd.TranscodingSend:openFamily()
end

function FamilyDataHandler:requestGetAllFamilyInfo()
	wd.TranscodingSend:getAllFamilyInfo()
end

function FamilyDataHandler:requestCreateFamily(familyName)
	wd.TranscodingSend:createFamily(familyName)
end

function FamilyDataHandler:requestUpgradeFamily()
	wd.TranscodingSend:upgradeFamily()
end

function FamilyDataHandler:requestChangeNotice(noticeType,msg)
	wd.TranscodingSend:changeFamilyNotice(noticeType,msg)
end

function FamilyDataHandler:requestDissolveFamily()
	wd.TranscodingSend:dissolveFamily()
end

function FamilyDataHandler:requestExitFamily()
	wd.TranscodingSend:operateFamily(wd.GlobalData:getInstance():getRoleId(),wd.familyOperateType.FAM_NO)
end

function FamilyDataHandler:requestApplyerList()
	wd.TranscodingSend:getFamilyApplyerList()
end

function FamilyDataHandler:requestJoinFamily(familyId,joinTag)
	self.joinTag = joinTag
	wd.TranscodingSend:joinFamily(familyId)
end

function FamilyDataHandler:requestGetFamilyMemberList()
	wd.TranscodingSend:getFamilyMemberInfo()
end

function FamilyDataHandler:requestHandleApply(targetId,operateType)
	wd.TranscodingSend:operateFamily(targetId,operateType)
end

function FamilyDataHandler:requestImpeachChairman(chairmanId)
	wd.TranscodingSend:operateFamily(chairmanId,wd.familyOperateType.IMPEACH_FATH)
end

function FamilyDataHandler:requestKickout(memberId)
	wd.TranscodingSend:operateFamily(memberId,wd.familyOperateType.FAM_NO)
end

function FamilyDataHandler:requestChangeChairman(id)
	wd.TranscodingSend:operateFamily(id,wd.familyOperateType.FAM_FATH)
end

function FamilyDataHandler:requestHandleViceChairman(id,type)
	wd.TranscodingSend:operateFamily(id,type)
end

function FamilyDataHandler:requestOpenFamilyShop()
	wd.TranscodingSend:openFamilyShop()
end

function FamilyDataHandler:requestBuyShopItem(itemId)
	wd.TranscodingSend:buyFamilyShopItem(itemId)
end

function FamilyDataHandler:requestRefreshFamilyShop()
	wd.TranscodingSend:refreshFamilyShop()
end

function FamilyDataHandler:requestOpenFamilyCard()
	wd.TranscodingSend:openFamilyCard()
end

function FamilyDataHandler:requestGetFamilyGem(freeTag)
	wd.TranscodingSend:getFamilyGem(freeTag)
end

function FamilyDataHandler:requestBuyCishu()--守护BOSS攻打次数购买
	wd.TranscodingSend:buyFamilyBatTimes()
end

function FamilyDataHandler:requestStartFamilyBoss(id)--守护BOSS攻打请求
	wd.TranscodingSend:startFamilyBoss(id)
end

function FamilyDataHandler:requestGetFamilyBossBox()
	wd.TranscodingSend:getFamilyBossBox()
end

function FamilyDataHandler:requestfamilyBattleInit()
	wd.TranscodingSend:familyBattleInit()
end

function FamilyDataHandler:requestApplyFamilyBattle(id)--城市id
	wd.TranscodingSend:familyBattleApply(id)
end

function FamilyDataHandler:requestJoinFamilyBattle()--城市id
	wd.TranscodingSend:familyBattleJoin()
end

function FamilyDataHandler:requestGetFamilyBattlePay()--领取工资
	wd.TranscodingSend:familyBattleGetPay()
end

function FamilyDataHandler:requestGetFamilyBattleDate()--战斗日志
	wd.TranscodingSend:familyBattleGetDate()
end
------------------------------------------------------------------------------

function FamilyDataHandler:getFamilyList()
	return self.familyList
end

function FamilyDataHandler:getCanJoinFamilyList()
	return self.canJoinFamilyList
end

function FamilyDataHandler:getFamilyMemberList()
	return self.memberList
end

function FamilyDataHandler:getFamilyApplyerList()
	return self.applyerList
end

function FamilyDataHandler:setNoticeChangeMsg(changeType,msg)
	self.changeNotice[changeType] = msg
end

function FamilyDataHandler:getChangeNoticeMsgByType(changeType)
	return self.changeNotice[changeType] or ""
end

function FamilyDataHandler:getJoinTag()
	return self.joinTag
end

function FamilyDataHandler:setMyJob(myjob)
	self.myJob = myjob
end

function FamilyDataHandler:getMyJob()
	return self.myJob
end

function FamilyDataHandler:getChairmanId()
	return self.chairmanId
end

function FamilyDataHandler:getViceChairmanId()
	return self.viceChairmanId
end

function FamilyDataHandler:setMyFamilyLevel(level)
	self.myFamilyLevel = level
end

function FamilyDataHandler:getMyFamilyLevel()
	return self.myFamilyLevel
end

function FamilyDataHandler:setMyContribute(contribute)
	self.contribute = contribute
end

function FamilyDataHandler:getMyContribute()
	return self.contribute
end

function FamilyDataHandler:getFamilyShopShowList()
	return self.shopShowList
end

function FamilyDataHandler:getBuyerNameList()
	return self.buyNameList
end

function FamilyDataHandler:getMyFamilyCardInfo()
	return self.familyCard
end

function FamilyDataHandler:setHadJoinTag(hadJoinTag)
	self.hadJoinTag = hadJoinTag
end

function FamilyDataHandler:getHadJoinTag()
	return self.hadJoinTag
end

----------------------------------------------------------------------------------------------

function FamilyDataHandler:registerEventListener()
	
	-- 从服务器接收技能列表回调
	
	-- familyList所有家族
	local function onGetAllFamilyInfo(EventCustom)
		local familyListSize = wd.GlobalData:getInstance():getFamilyListSize()
		self.familyList = {}
		self.canJoinFamilyList = {}
		for i = 0,familyListSize -1 do
			local familyItem = wd.GlobalData:getInstance():getFamilyItem(i)
			local family = {}
			family.rank = i+1
			family.id = familyItem:getFamilyId()
			family.name = familyItem:getName()
			family.chairmanName = familyItem:getChaimanName()
			family.level = familyItem:getLevel()
			family.curMemberCount = familyItem:getCurrentCount()
			family.fullMemberCount = familyItem:getLimitCount()
			family.job = familyItem:getMyJob()
			family.declaration = familyItem:getDeclaration()
			table.insert(self.familyList,family)
			if family.curMemberCount < family.fullMemberCount then
				table.insert(self.canJoinFamilyList,family)
			end
		end
		local event = cc.EventCustom:new("Update_FamilyList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listener = cc.EventListenerCustom:create("Get_All_FamilyInfo", onGetAllFamilyInfo)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	-- memberList家族成员
	local function onGetMemberList(EventCustom)
		local memberListSize = wd.GlobalData:getInstance():getFamilyMemberListSize()
		self.memberList = {}
		for i = 0,memberListSize -1 do
			local memberItem = wd.GlobalData:getInstance():getFamilyMemberItem(i)
			local member = {}
			member.id = memberItem:getRoleId()
			member.level = memberItem:getLevel()
			member.contribute = memberItem:getContribute()
			member.fightPower = memberItem:getFightPower()
			member.vipLevel = memberItem:getVipLevel()
			member.name = memberItem:getName()
			member.job = memberItem:getJob()
			member.sex = memberItem:getSex()
			member.occupation = memberItem:getOccupation()
			member.jobStr = self.jobName[memberItem:getJob()]
			if memberItem:getOfflineTime() == 0 then
				member.offlineTime = "在线"
			else
				local d,h,m,timeStr
				d = math.floor(memberItem:getOfflineTime()/(24*3600))
				if d == 0 then
					h = math.floor(memberItem:getOfflineTime()/3600)
					if h == 0 then
						m = math.floor(math.abs(memberItem:getOfflineTime()-3600*h)/60)
						timeStr = string.format("离线%d分钟",m)
					else
						timeStr = string.format("离线%d小时",h)
					end
				elseif d > 7 then
					timeStr = "离线7天以上"
				else
					timeStr = string.format("离线%d天",d)
				end
				member.offlineTime = timeStr
			end
			
			table.insert(self.memberList,member)
			if member.job ==  wd.familyJobType.Family_Father then
				self.chairmanId = member.id
			elseif member.job == wd.familyJobType.Family_Mother then
				self.viceChairmanId = member.id
			end
		end
		local event = cc.EventCustom:new("Update_MemberList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listener = cc.EventListenerCustom:create("Get_Family_MemberList", onGetMemberList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	-- applyerList申请
	local function onGetApplyerList(EventCustom)
		local applyerListSize = wd.GlobalData:getInstance():getFamilyApplyerListSize()
		self.applyerList = {}
		for i = 0,applyerListSize -1 do
			local applyerItem = wd.GlobalData:getInstance():getFamilyApplyerItem(i)
			local applyer = {}
			applyer.id = applyerItem:getRoleId()
			applyer.level = applyerItem:getLevel()
			applyer.fightPower = applyerItem:getFightPower()
			applyer.vipLevel = applyerItem:getVipLevel()
			applyer.name = applyerItem:getName()
			applyer.sex = applyerItem:getSex()
			applyer.occupation = applyerItem:getOccupation()
			if applyerItem:getOfflineTime() == 0 then
				applyer.offlineTime = "在线"
			else
				local d,h,m,timeStr
				d = math.floor(applyerItem:getOfflineTime()/(24*3600))
				if d == 0 then
					h = math.floor(applyerItem:getOfflineTime()/3600)
					if h == 0 then
						m = math.floor(math.abs(applyerItem:getOfflineTime()-3600*h)/60)
						timeStr = string.format("离线%d分钟",m)
					else
						timeStr = string.format("离线%d小时",h)
					end
				elseif d > 7 then
					timeStr = "离线7天以上"
				else
					timeStr = string.format("离线%d天",d)
				end
				applyer.offlineTime = timeStr
			end
			table.insert(self.applyerList,applyer)
		end
		local event = cc.EventCustom:new("Update_ApplyerList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listener = cc.EventListenerCustom:create("Get_Family_ApplyerList", onGetApplyerList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	-- shopList
	local function onOpenFamilyShop(EventCustom)
		local showListSize = wd.GlobalData:getInstance():getFamilyShopShowListSize()
		self.shopShowList = {}
		for i = 0,showListSize -1 do
			local showItem = wd.GlobalData:getInstance():getFamilyShopShowItem(i)
			local show = {}
			show.id = showItem:getItemId()
			show.contribute = showItem:getContribute()
			show.itemInfo = self:parseItemStr(showItem:getItemString())
			table.insert(self.shopShowList,show)
		end
		local event = cc.EventCustom:new("Update_ShopList")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listener = cc.EventListenerCustom:create("Open_Family_Shop", onOpenFamilyShop)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	-- familyCard
	local function onOpenFamilyCard(EventCustom)
		local myFamilyCard = wd.GlobalData:getInstance():getMyFamilyCard()
		local buyNameListSize = wd.GlobalData:getInstance():getBuyerListCount()
		self.buyNameList = {}
		for i = 0,buyNameListSize-1 do
			local name = wd.GlobalData:getInstance():getBuyerName(i)
			--print(name)
			table.insert(self.buyNameList,name)
		end
		self.familyCard = {}
		self.familyCard.cardLevel = myFamilyCard:getCardLevel()
		if self.familyCard.cardLevel == 0 then
			self.familyCard.cardLevel = 1
		end
		self.familyCard.cardName = self.cardName[self.familyCard.cardLevel]
		self.familyCard.buyState = myFamilyCard:getBuyState()
		self.familyCard.allGem = myFamilyCard:getAllGem()
		self.familyCard.myGem = myFamilyCard:getMyGem()
		self.familyCard.allgetState = myFamilyCard:getAllGetState()
		self.familyCard.myGetState = myFamilyCard:getMyGetState()
		local event = cc.EventCustom:new("Update_Welfare_View")
		cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	end
	
	local listener = cc.EventListenerCustom:create("Open_Family_Card", onOpenFamilyCard)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	

end

function FamilyDataHandler:parseItemStr(str)
	local startIndex,endIndex
	local shopItem = {}
	local startIndex,endIndex,itemType,itemId,itemCount = string.find(str,"(%d+)#(%d+)|(%d+)")
	shopItem.itemId = tonumber(itemId)
	shopItem.itemCount = tonumber(itemCount)
	shopItem.itemType = tonumber(itemType)
	if shopItem.itemType == wd.ItemType.Tools then
		shopItem.item = wd.GlobalData:getInstance():getToolsItemInXml(itemId)
	elseif shopItem.itemType == wd.ItemType.Equip then
		shopItem.item = wd.GlobalData:getInstance():getEquipItemInXml(itemId)
	end
	return shopItem
end

return FamilyDataHandler
