
local Family_Operate_Layer = class("Family_Operate_Layer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function Family_Operate_Layer.create(pos,job,name,id)
    local layer = Family_Operate_Layer.new()
    layer:createLayerMenu(pos,job,name,id)
    return layer
end

function Family_Operate_Layer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function Family_Operate_Layer:clear()
	self:removeFromParent()
	local event = cc.EventCustom:new("Remove_Operate")
	cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
	--cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_AchieveList")
	
end

function Family_Operate_Layer:createLayerMenu(pos,job,name,id)
    local node = tolua.cast(cc.CSLoader:createNode("ui/family/Family_Operate_Node.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
	ccui.Helper:doLayout(node)
	
	local mainPanel =  tolua.cast(node:getChildByName("Main_Panel"), "ccui.Widget")
	mainPanel:setPosition(pos)
	
	local changeChairmanBtn = tolua.cast(mainPanel:getChildByName("Change_Chairman_Button"), "ccui.Widget")
	changeChairmanBtn:setPressedActionEnabled(true)
    changeChairmanBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local layerClass = require("src.game.family.Family_MessageBox_Layer")
				local msg = {}
				table.insert(msg,"是否将族长职位交给")
				table.insert(msg,string.format("{n=[%s]}",name))
				table.insert(msg,"(移交后您将成为普通成员)?")
				local function changeChairman()
					self.dataHandler:requestChangeChairman(id)
				end
				self.tipsLayer = layerClass.create("family_subtitle_change.png",msg,changeChairman)
				self:addChild(self.tipsLayer)
            end
        end
    )
	local changeOtherBtn =  tolua.cast(mainPanel:getChildByName("Change_Other_Button"), "ccui.Widget")
	local btnTitle = tolua.cast(changeOtherBtn:getChildByName("Change_Other_title"), "cc.Sprite")
	if job == wd.familyJobType.Family_Mother then
		btnTitle:setSpriteFrame("family_btntitle_recall.png")
	else
		btnTitle:setSpriteFrame("family_btntitle_vice_chairman.png")
	end
	changeOtherBtn:setPressedActionEnabled(true)
    changeOtherBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				if job == wd.familyJobType.Family_Mother then
					local layerClass = require("src.game.family.Family_MessageBox_Layer")
					local msg = {}
					table.insert(msg,"是否罢免")
					table.insert(msg,string.format("{n=[%s]}",name))
					table.insert(msg,"副族长职位")
					local function recall()
						self.dataHandler:requestHandleViceChairman(id,wd.familyOperateType.FAM_CHILD)
					end
					self.tipsLayer = layerClass.create("family_subtitle_recall.png",msg,recall)
					self:addChild(self.tipsLayer)
				else
					local layerClass = require("src.game.family.Family_MessageBox_Layer")
					local msg = {}
					table.insert(msg,"是否任命")
					table.insert(msg,string.format("{n=[%s]}",name))
					table.insert(msg,"为本家族副族长")
					local function commission()
						self.dataHandler:requestHandleViceChairman(id,wd.familyOperateType.FAM_MOTH)
					end
					self.tipsLayer = layerClass.create("family_subtitle_vice_chairman.png",msg,commission)
					self:addChild(self.tipsLayer)
				end
            end
        end
    )
end

return Family_Operate_Layer
