
local family_War_Battle = class("family_War_Battle",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function family_War_Battle.create(tag,city)
    local layer = family_War_Battle.new()
    layer:createLayerMenu(tag,city)
    return layer
end

function family_War_Battle:ctor()
   self.battleSchedule = nil
   self.nodeLeft = {}
   self.nodeRight = {}
end

function family_War_Battle:clear()
    if self.battleSchedule ~= nil then
        cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.battleSchedule)
        self.battleSchedule = nil
    end
    self:removeFromParent()

    --cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Create_Family")
    
end

function family_War_Battle:createLayerMenu(tag,city)
    local node = tolua.cast(cc.CSLoader:createNode("ui/familyWarProgress/familyWarBattle.csb"), "ccui.Widget")
    local mainPanel = tolua.cast(node:getChildByName("Panel_Main"), "ccui.Widget")
    
    local closeBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:clear()
            end
        end
    )
    
    local ListView_family1 = tolua.cast(mainPanel:getChildByName("ListView_family1"), "ccui.ListView")
    local ListView_family2 = tolua.cast(mainPanel:getChildByName("ListView_family2"), "ccui.ListView")

    local familyNameOne = tolua.cast(mainPanel:getChildByName("Text_Name1"), "ccui.Text")
    local familyNameTwo = tolua.cast(mainPanel:getChildByName("Text_Name2"), "ccui.Text")

    local teamSize = {
        wd.GlobalData:getInstance():getFamilyBattleOneSize(),
        wd.GlobalData:getInstance():getFamilyBattleTwoSize(),
        wd.GlobalData:getInstance():getFamilyBattleThreeSize()
    }

    local family = {}
    local familyOneMembers = {}
    local familyTwoMembers = {}
    local familyBattle = {}
    
    for i=0, teamSize[city]-1 do
        if i == tag then
            local aa
            if city == 1 then
                aa = wd.GlobalData:getInstance():getFamilyBattleOne(i)  
            elseif city == 2 then
                aa = wd.GlobalData:getInstance():getFamilyBattleTwo(i)
            elseif city == 3 then
                aa = wd.GlobalData:getInstance():getFamilyBattleThree(i)
            end

            local item = {}
            item.teamAId = aa:getTeamAFamilyId()
            item.teamAname = aa:getTeamAFamilyName()

            item.teamBId = aa:getTeamBFamilyId()
            item.teamBname = aa:getTeamBFamilyName()

            item.winerId = aa:getWinTeamId()
           
            item.cishuA = aa:getTeamACount()
            item.cishuB = aa:getTeamBCount()
            item.cishuC = aa:getTeamCCount()
           -- print(aa:getTeamACount(),aa:getTeamCCount(),aa:getTeamBCount()) 

            for j = 1, aa:getTeamACount() do
                local teamA = aa:getTeamA(j-1)
                familyOneMembers[j] = {}
                familyOneMembers[j][1] = teamA:getId()
                familyOneMembers[j][2] = teamA:getType()
                familyOneMembers[j][3] = teamA:getHp()
                familyOneMembers[j][4] = teamA:getMp()
                familyOneMembers[j][5] = teamA:getLevel()
                familyOneMembers[j][6] = teamA:getNichname() 
                familyOneMembers[j][7] = teamA:getSex()
                familyOneMembers[j][8] = teamA:getOccupation()
            end

            for k = 1, aa:getTeamBCount() do
                local teamB = aa:getTeamB(k-1)
                familyTwoMembers[k] = {}
                familyTwoMembers[k][1] = teamB:getId()
                familyTwoMembers[k][2] = teamB:getType()
                familyTwoMembers[k][3] = teamB:getHp()
                familyTwoMembers[k][4] = teamB:getMp()
                familyTwoMembers[k][5] = teamB:getLevel()
                familyTwoMembers[k][6] = teamB:getNichname() 
                familyTwoMembers[k][7] = teamB:getSex()
                familyTwoMembers[k][8] = teamB:getOccupation()
            end

            for m = 1, aa:getTeamCCount() do
                local teamC = aa:getTeamC(m-1)
                familyBattle[m] = {}
                familyBattle[m][1] = teamC:getRoleA()        --chushou
                familyBattle[m][2] = teamC:getRoleB()        --buchushou
                familyBattle[m][3] = teamC:getRoleAHp()
                familyBattle[m][4] = teamC:getRoleAMp()
                familyBattle[m][5] = teamC:getAddHp()
                familyBattle[m][6] = teamC:getAddMp()
            end
            
            family = item
        end
    end

    familyNameOne:setString(family.teamAname)
    familyNameTwo:setString(family.teamBname)
    if family.winerId == family.teamAId then
        familyNameOne:setColor(cc.c3b(255,0,0))
        familyNameTwo:setColor(cc.c3b(40,40,40))
    elseif family.winerId == family.teamBId then
        familyNameTwo:setColor(cc.c3b(255,0,0))
        familyNameOne:setColor(cc.c3b(40,40,40))
    end


    local function changeAnchorCallBack1(node,i)
        local a = {
            node:getChildByName("Panel_Main"):getChildByName("battle_player_box"),
            node:getChildByName("Panel_Main"):getChildByName("Hp_Progress"),
            node:getChildByName("Panel_Main"):getChildByName("Mp_Progress"),
            node:getChildByName("Panel_Main"):getChildByName("Level_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Name_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Hp_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Mp_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Player_Head"),
            node:getChildByName("Panel_Main"):getChildByName("Dead_Title")
        }

       --[[ for j=1,9 do
            a[j]:setPosition(a[j]:getPositionX()+170,a[j]:getPositionY()+45)
        end--]]
        ----------状态栏1
        local headSpriteName1 = wd.getHeadImageName(familyOneMembers[i][8], familyOneMembers[i][7])
        if headSpriteName1 then
            a[8]:setSpriteFrame(headSpriteName1)
        end
        a[5]:setString(familyOneMembers[i][6])--名字
        a[4]:setString(familyOneMembers[i][5])--等级
        a[6]:setString(string.format("%d/%d", familyOneMembers[i][3], familyOneMembers[i][3]))--血量
        a[2]:setPercent((familyOneMembers[i][3]/familyOneMembers[i][3])*100)--血量
        a[7]:setString(string.format("%d/%d", familyOneMembers[i][4], familyOneMembers[i][4]))--蓝量
        a[3]:setPercent((familyOneMembers[i][4]/familyOneMembers[i][4])*100)--蓝量
    end


    local function changeAnchorCallBack2(node,i)
        local b = {
            node:getChildByName("Panel_Main"):getChildByName("battle_player_box"),
            node:getChildByName("Panel_Main"):getChildByName("Hp_Progress"),
            node:getChildByName("Panel_Main"):getChildByName("Mp_Progress"),
            node:getChildByName("Panel_Main"):getChildByName("Level_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Name_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Hp_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Mp_Label"),
            node:getChildByName("Panel_Main"):getChildByName("Player_Head"),
            node:getChildByName("Panel_Main"):getChildByName("Dead_Title")
        }

        --[[for j=1,9 do
            b[j]:setPosition(b[j]:getPositionX()+170,b[j]:getPositionY()+45)
        end--]]
        ----------状态栏2
        local headSpriteName2 = wd.getHeadImageName(familyTwoMembers[i][8], familyTwoMembers[i][7])
        if headSpriteName2 then
            b[8]:setSpriteFrame(headSpriteName2)
        end
        b[5]:setString(familyTwoMembers[i][6])
        b[4]:setString(familyTwoMembers[i][5])
        b[6]:setString(string.format("%d/%d", familyTwoMembers[i][3], familyTwoMembers[i][3]))--血量
        b[2]:setPercent((familyTwoMembers[i][3]/familyTwoMembers[i][3])*100)--血量
        b[7]:setString(string.format("%d/%d", familyTwoMembers[i][4], familyTwoMembers[i][4]))--蓝量
        b[3]:setPercent((familyTwoMembers[i][4]/familyTwoMembers[i][4])*100)--蓝量
    end
    

    for i = 1, family.cishuA do
        self.nodeLeft[i] = tolua.cast(cc.CSLoader:createNode("ui/familyWarProgress/familyWar_NodeLeft.csb"), "ccui.Widget")
        
        changeAnchorCallBack1(self.nodeLeft[i],i)
        local widget1 = ccui.Widget:create()
        widget1:setAnchorPoint(cc.p(0,0))
        widget1:setContentSize(100,100)
        widget1:addChild(self.nodeLeft[i])
        ListView_family1:pushBackCustomItem(widget1)
       
    end

    for i = 1, family.cishuB do
        self.nodeRight[i] = tolua.cast(cc.CSLoader:createNode("ui/familyWarProgress/familyWar_NodeRight.csb"), "ccui.Widget")
        changeAnchorCallBack2(self.nodeRight[i],i)

        local widget2 = ccui.Widget:create()
        widget2:setContentSize(100,100)
        widget2:setAnchorPoint(cc.p(0,0))
        widget2:addChild(self.nodeRight[i])
        ListView_family2:pushBackCustomItem(widget2)
    end
    
    local item = 1 
    local function startBattleCallBack()

        local function setBattle()
            if item <= family.cishuC then --播放光效
                local FirstStatus = 0
                local LastStatus = 0

                for i,v in pairs(familyOneMembers) do
                    if v[1] == familyBattle[item][1] then
                        FirstStatus = i
                    end

                    if v[1] == familyBattle[item][2] then
                        LastStatus = i
                    end
                end 

                for i,v in pairs(familyTwoMembers) do
                    if v[1] == familyBattle[item][1] then
                        FirstStatus = -1*i
                    end

                    if v[1] == familyBattle[item][2] then
                        LastStatus = -1*i
                    end
                end 
                --FirstStatus = -1
                --LastStatus = 1
                --print("FirstStatus,LastStatus",FirstStatus,LastStatus)
                if FirstStatus > 0 then
                    if self.nodeLeft[FirstStatus] then
                        local valueLabel = ccui.Text:create()
                        valueLabel:setAnchorPoint(cc.p(0,0))
                        valueLabel:setPosition(150,70)
                        valueLabel:setColor(cc.c3b(0,255,0))
                        valueLabel:setTag(55)
                        valueLabel:setFontSize(20)
                        self.nodeLeft[FirstStatus]:addChild(valueLabel)
                        self.nodeLeft[FirstStatus]:stopAllActions()
                        local moveBy = cc.MoveBy:create(0.5,cc.p(20,0))
                        local reverse = moveBy:reverse()
                        local sequence = cc.Sequence:create(moveBy,reverse)
                        self.nodeLeft[FirstStatus]:runAction(sequence)
                    end

                    local hitSprite = cc.Sprite:create()
                    self.nodeRight[-1*LastStatus]:addChild(hitSprite)
                    hitSprite:setRotation(90)
                    --hitSprite:setFlippedX(targetTeam == wd.PlayerType.ENEMY)
                    hitSprite:setPosition(150,70)

                    local function AddBloodCallBack(aa,bb)
                        local function playOverCallBackFunc()
                            local hpp = familyBattle[item][3]+aa
                            local mpp = familyBattle[item][4]+bb
                            if hpp >= familyOneMembers[FirstStatus][3] then
                                hpp = familyOneMembers[FirstStatus][3]
                            end
                            if mpp >= familyOneMembers[FirstStatus][4] then
                                mpp = familyOneMembers[FirstStatus][4]
                            end

                            self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", hpp, familyOneMembers[FirstStatus][3]))
                            self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(((hpp)/familyOneMembers[FirstStatus][3])*100)
                            self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Label"):setString(string.format("%d/%d", mpp, familyOneMembers[FirstStatus][4]))
                            self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Progress"):setPercent(((mpp)/familyOneMembers[FirstStatus][4])*100)
                            self.nodeLeft[FirstStatus]:getChildByTag(55):removeFromParent()
                            item = item + 1
                        end
                       
                        -- local str = "增加10%血量蓝量"
                        local str = ""
                        self.nodeLeft[FirstStatus]:getChildByTag(55):setString(str)
                        self.nodeLeft[FirstStatus]:getChildByTag(55):setOpacity(0)
                        local witetime = cc.DelayTime:create(1) 
                        local op = cc.FadeTo:create(0.1,255) 
                        --local moveBy = cc.MoveBy:create(0.5,cc.p(100,100))
                        local moveBy = cc.FadeTo:create(1,0)
                        local playOverCallBack = cc.CallFunc:create(playOverCallBackFunc)
                        local sequence = cc.Sequence:create(witetime,op,moveBy,playOverCallBack)
                        self.nodeLeft[FirstStatus]:getChildByTag(55):runAction(sequence)

                    end

                    local animation = cc.Animation:create()
                    for i = 1, 6 do
                        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("attack_%02d.png", i)))
                    end
                    animation:setDelayPerUnit(0.083)
                    animation:setLoops(1)
                    local function playAnimateCallBackFunc()
                        hitSprite:removeFromParent()
                        self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", familyBattle[item][3], familyOneMembers[FirstStatus][3]))
                        self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(((familyBattle[item][3])/familyOneMembers[FirstStatus][3])*100)
                        self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Label"):setString(string.format("%d/%d", familyBattle[item][4], familyOneMembers[FirstStatus][4]))
                        self.nodeLeft[FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Progress"):setPercent(((familyBattle[item][4])/familyOneMembers[FirstStatus][4])*100)
                        self.nodeRight[-1*LastStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", 0, familyTwoMembers[-1*LastStatus][3]))
                        self.nodeRight[-1*LastStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(0)
                        self.nodeRight[-1*LastStatus]:getChildByName("Panel_Main"):getChildByName("Dead_Title"):setVisible(true)

                        AddBloodCallBack(familyBattle[item][5],familyBattle[item][6])
                    end
                    local playAnimateCallBack = cc.CallFunc:create(playAnimateCallBackFunc)
                    local animate = cc.Animate:create(animation)
                    local hitSequence = cc.Sequence:create(animate,playAnimateCallBack)
                    hitSprite:runAction(hitSequence)
                else
                    if self.nodeRight[-1*FirstStatus] then
                        local valueLabel = ccui.Text:create()
                        valueLabel:setAnchorPoint(cc.p(0,0))
                        valueLabel:setPosition(50,70)
                        valueLabel:setColor(cc.c3b(0,255,0))
                        valueLabel:setTag(55)
                        valueLabel:setFontSize(20)
                        self.nodeRight[-1*FirstStatus]:addChild(valueLabel)
                        self.nodeRight[-1*FirstStatus]:stopAllActions()
                        local moveBy = cc.MoveBy:create(0.5,cc.p(-20,0))
                        local reverse = moveBy:reverse()
                        local sequence = cc.Sequence:create(moveBy,reverse)
                        self.nodeRight[-1*FirstStatus]:runAction(sequence)
                    end
                    local hitSprite = cc.Sprite:create()
                    self.nodeLeft[LastStatus]:addChild(hitSprite)
                    hitSprite:setRotation(180)
                    --hitSprite:setFlippedX(targetTeam == wd.PlayerType.ENEMY)
                    hitSprite:setPosition(150,70)

                    local function AddBloodCallBack(aa,bb)
                        local function playOverCallBackFunc()
                            local hpp = familyBattle[item][3]+aa
                            local mpp = familyBattle[item][4]+bb
                            if hpp >= familyTwoMembers[-1*FirstStatus][3] then
                                hpp = familyTwoMembers[-1*FirstStatus][3]
                            end
                            if mpp >= familyTwoMembers[-1*FirstStatus][4] then
                                mpp = familyTwoMembers[-1*FirstStatus][4]
                            end
                            self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", hpp, familyTwoMembers[-1*FirstStatus][3]))
                            self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(((hpp)/familyTwoMembers[-1*FirstStatus][3])*100)
                            self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Label"):setString(string.format("%d/%d", mpp, familyTwoMembers[-1*FirstStatus][4]))
                            self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Progress"):setPercent(((mpp)/familyTwoMembers[-1*FirstStatus][4])*100)
                            self.nodeRight[-1*FirstStatus]:getChildByTag(55):removeFromParent()
                            item = item + 1
                        end
                       
                        -- local str = "增加10%血量蓝量"
                        local str = ""
                        self.nodeRight[-1*FirstStatus]:getChildByTag(55):setString(str)
                        self.nodeRight[-1*FirstStatus]:getChildByTag(55):setOpacity(0)
                        local witetime = cc.DelayTime:create(1) 
                        local op = cc.FadeTo:create(0.1,255) 
                        local moveBy = cc.FadeTo:create(1,0)
                        local playOverCallBack = cc.CallFunc:create(playOverCallBackFunc)
                        local sequence = cc.Sequence:create(witetime,op,moveBy,playOverCallBack)
                        self.nodeRight[-1*FirstStatus]:getChildByTag(55):runAction(sequence)

                    end


                    local animation = cc.Animation:create()
                    for i = 1, 6 do
                        animation:addSpriteFrame(cc.SpriteFrameCache:getInstance():getSpriteFrame(string.format("attack_%02d.png", i)))
                    end
                    animation:setDelayPerUnit(0.083)
                    animation:setLoops(1)
                    local function playAnimateCallBackFunc()
                        hitSprite:removeFromParent()
                        self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", familyBattle[item][3], familyTwoMembers[-1*FirstStatus][3]))
                        self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(((familyBattle[item][3])/familyTwoMembers[-1*FirstStatus][3])*100)
                        self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Label"):setString(string.format("%d/%d", familyBattle[item][4], familyTwoMembers[-1*FirstStatus][4]))
                        self.nodeRight[-1*FirstStatus]:getChildByName("Panel_Main"):getChildByName("Mp_Progress"):setPercent(((familyBattle[item][4])/familyTwoMembers[-1*FirstStatus][4])*100)
                        self.nodeLeft[LastStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Label"):setString(string.format("%d/%d", 0, familyOneMembers[LastStatus][3]))
                        self.nodeLeft[LastStatus]:getChildByName("Panel_Main"):getChildByName("Hp_Progress"):setPercent(0)
                        self.nodeLeft[LastStatus]:getChildByName("Panel_Main"):getChildByName("Dead_Title"):setVisible(true)

                        AddBloodCallBack(familyBattle[item][5],familyBattle[item][6])
                    end
                    local playAnimateCallBack = cc.CallFunc:create(playAnimateCallBackFunc)
                    local animate = cc.Animate:create(animation)
                    local hitSequence = cc.Sequence:create(animate,playAnimateCallBack)
                    hitSprite:runAction(hitSequence)
                end
            else
                if self.battleSchedule ~= nil then
                    cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.battleSchedule)
                    self.battleSchedule = nil
                end
                wd.showRichTips(4,"战斗结束")
            end
        end
    
        self.battleSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(setBattle, 3, false)  
    end


    startBattleCallBack()

    
    self:addChild(node)
    ccui.Helper:doLayout(node)

end

return family_War_Battle
