local PKSpeedUpTips = class("PKSpeedUpTips",function()
    return cc.Layer:create()
end)

function PKSpeedUpTips:create()
    local layer = PKSpeedUpTips.new()
    return layer
end

function PKSpeedUpTips:setup(useGem)
    local node = tolua.cast(cc.CSLoader:createNode("ui/map/PkSpeedUpTips.csb"), "ccui.Widget")
    self:addChild(node)
    
    local gemText = tolua.cast(ccui.Helper:seekWidgetByName(node,"use_gem"), "ccui.Text")
    gemText:setString(useGem)
    
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local finishBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Finish_Button"), "ccui.Button")
    finishBtn:setPressedActionEnabled(true)
    finishBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleGem() < useGem then
                    -- wd.showRichTips(4,"元宝不足")
                    local layerClass = require("src.game.charge.ChargeTipsScene")
                    local layer = layerClass:create()
                    self:getParent():addChild(layer)
                    self:removeFromParent()
                else
                    local packge = NetPackage:create()
                    packge:add("role_id",wd.GlobalData:getInstance():getRoleData():getRoleId())
                    packge = packge:encode()
                    wd.TranscodingSend:luaSend(packge,ePCJiasuExploration) 
                    wd.showRichTips(4,"加速完成")
                    self:removeFromParent()
                end
            end
        end
    )
end

return PKSpeedUpTips