local NewcomerGiftTips = class("NewcomerGiftTips",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function NewcomerGiftTips.create()
    local layer = NewcomerGiftTips.new()
    return layer
end

function NewcomerGiftTips:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()

end



function NewcomerGiftTips:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/main/NewcomerGiftTips.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
    


    local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:clear()
            end
        end
    )

    
    local getList = tolua.cast(ccui.Helper:seekWidgetByName(node,"Get_ListView"), "ccui.ListView")

    self.node = node

    local role = wd.GlobalData:getInstance():getRoleData()
    local giftNum = tonumber(role:getRoleExtendData("online_gift"))
    local giftTime = tonumber(role:getRoleExtendData("online_gift_time"))
    local data = require("res.config.xinshouhaoli")

    require("src.game.package.SetupTools"):create(getList,data[giftNum + 1].award)
    
    local leftTime = tolua.cast(ccui.Helper:seekWidgetByName(node,"time"), "ccui.Text")
    
    local nowTime,hour,minute,second
    local endTime = giftTime + data[giftNum + 1].time
    
    local function countDown()
        nowTime = endTime - os.time()
        if nowTime > 0 then
            hour = math.floor(nowTime/3600)
            minute = math.floor((nowTime - hour * 3600)/60)
            second = nowTime%60
            leftTime:setString(string.format("%02d:%02d:%02d",hour,minute,second).."后可领取")
        else
            self:stopAllActions()
            leftTime:setString("可领取")
        end
    end 
    local delay = cc.DelayTime:create(1.0)
    local sequence = cc.Sequence:create(cc.CallFunc:create(countDown),delay)
    self:runAction(cc.RepeatForever:create(sequence))
    
    -- print("--------------------------------------")
    -- print(os.time())
    -- print(giftTime)
    -- print(giftNum)
    -- print(data[giftNum + 1].time)
    -- print("--------------------------------------")

    local btn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Sure_Button"), "ccui.Widget")
    btn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if nowTime > 0 then
                    wd.showRichTips(4,"还没到领取时间")
                else
                    local packge = NetPackage:create()
                    packge:add("role_id",role:getRoleId())
                    packge:add("id",giftNum + 1)
                    packge = packge:encode()
                    wd.TranscodingSend:luaSend(packge,ePCOnlineGift)
                    self:removeFromParent()
                end
            end
        end
    )

    btn:setPressedActionEnabled(true)
    
end

function NewcomerGiftTips:clear()
	self:removeFromParent()
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item")
end

return NewcomerGiftTips