
local AllResolveLayer = class("AllResolveLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function AllResolveLayer.create()
    local layer = AllResolveLayer.new()
    layer:createLayerMenu()
    return layer
end

function AllResolveLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function AllResolveLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/soul/SoulResolveLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Soul_All_Resolve")
                self:removeFromParent()
            end
        end
    )
    
	local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
    for i = 1,4 do
		local gradeBox = tolua.cast(ccui.Helper:seekWidgetByName(node,string.format("Grade_Box_%d",i)), "ccui.Widget")
		local countLabel = tolua.cast(gradeBox:getChildByName("Count_Label"),"ccui.Text")
		countLabel:setString(string.format("X%d",wd.GlobalData:getInstance():getSoulItemCountByGrade(i)))
		local resolveBtn = tolua.cast(gradeBox:getChildByName("Resolve_Button"),"ccui.Button")
		resolveBtn:setPressedActionEnabled(true)
		resolveBtn:addTouchEventListener(
			function(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
					wd.soulHandler:requestSoulAllResolve(i)
					self.resolveGrade = i
				end
			end
		)
	end
	
	local function onSoulAllResolve(EventCustom)
        wd.showRichTips(4,"分解成功")
		if self.resolveGrade then
			local gradeBox = tolua.cast(ccui.Helper:seekWidgetByName(node,string.format("Grade_Box_%d",self.resolveGrade)), "ccui.Widget")
			local countLabel = tolua.cast(gradeBox:getChildByName("Count_Label"),"ccui.Text")
			countLabel:setString(string.format("X%d",wd.GlobalData:getInstance():getSoulItemCountByGrade(self.resolveGrade)))
		end
    end
	
    local listener = cc.EventListenerCustom:create("Soul_All_Resolve", onSoulAllResolve)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end


return AllResolveLayer