
local AllSaleLayer = class("AllSaleLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function AllSaleLayer.create()
    local layer = AllSaleLayer.new()
    layer:createLayerMenu()
    return layer
end

function AllSaleLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function AllSaleLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/AllSaleScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
	local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local  whiteBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SaleWhite_Button"), "ccui.Widget")
    whiteBtn:setPressedActionEnabled(true)
    whiteBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:setEquipSellForColor(wd.ColorType.WHITE)
                --self:getParent():filter(wd.FilterType.NO_FLITER, 0, true)
                self:removeFromParent()
            end
        end
    )
    local whiteLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"White_Label"), "ccui.Text")
    whiteLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.WHITE)))


    local greenBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SaleGreen_Button"), "ccui.Widget")
    greenBtn:setPressedActionEnabled(true)
    greenBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:setEquipSellForColor(wd.ColorType.GREEN)
                --self:getParent():filter(wd.FilterType.NO_FLITER, 0, true)
                self:removeFromParent()
            end
        end
    )
    local greenLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Green_Label"), "ccui.Text")
    greenLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.GREEN)))


    local blueBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SaleBlue_Button"), "ccui.Widget")
    blueBtn:setPressedActionEnabled(true)
    blueBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:setEquipSellForColor(wd.ColorType.BLUE)
                --self:getParent():filter(wd.FilterType.NO_FLITER, 0, true)
                self:removeFromParent()
            end
        end
    )
    local blueLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Blue_Label"), "ccui.Text")
    blueLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.BLUE)))

    local purpleBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SalePurple_Button"), "ccui.Widget")
    purpleBtn:setPressedActionEnabled(true)
    purpleBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:setEquipSellForColor(wd.ColorType.PURPLE)
                --self:getParent():filter(wd.FilterType.NO_FLITER, 0, true)
                self:removeFromParent()
            end
        end
    )
    local purpleLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Purple_Label"), "ccui.Text")
    purpleLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.PURPLE)))

    local goldBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"SaleGold_Button"), "ccui.Widget")
    goldBtn:setPressedActionEnabled(true)
    goldBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.TranscodingSend:setEquipSellForColor(wd.ColorType.GOLD)
                --self:getParent():filter(wd.FilterType.NO_FLITER, 0, true)
                self:removeFromParent()
            end
        end
    )
    local goldLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Gold_Label"), "ccui.Text")
    goldLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.GOLD)))

end


return AllSaleLayer