
local EquipTipsLayer = class("EquipTipsLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function EquipTipsLayer.create()
    local layer = EquipTipsLayer.new()
    return layer
end

function EquipTipsLayer:createWithSmeltingVisible(equipId, wearType, isOn, strengthen_level,tag)
    self:createLayerMenu(equipId, wearType, isOn, strengthen_level,tag)
    self.smeltingBtn:setVisible(true)
end

function EquipTipsLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function EquipTipsLayer:wear(item, wearType)

    if (item:getOccupation() ~= wd.GlobalData:getInstance():getRoleJob() and item:getOccupation() ~= 0) then
        wd.showRichTips(4,"角色职业不符")
    else
        if item:getLevel() > wd.GlobalData:getInstance():getRoleLevel() + 5 then
            wd.showRichTips(4,"角色等级不足")
        else
            if wearType ~= wd.WearRegion.NOTHING then
            
                if wearType == wd.WearRegion.RWRIST or wearType == wd.WearRegion.RRING then
                    wd.TranscodingSend:setEquipWear(item:getServerId(), 1) --right
                else
                    wd.TranscodingSend:setEquipWear(item:getServerId(), 0) --left
                end
            
                wd.GlobalData:getInstance():wearEquipForId(wearType, item:getServerId())
                self:getParent():wear(item:getServerId())  -- RoleLayer
            else
                if item:getRegion() == wd.RegionType.WRIST then
                    if wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.LWRIST) == nil then
                        wearType = wd.WearRegion.LWRIST
                    elseif wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.RWRIST) == nil then
                        wearType = wd.WearRegion.RWRIST
                    elseif wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.LWRIST):getPower() < wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.RWRIST):getPower() then
                        wearType = wd.WearRegion.LWRIST
                    else
                        wearType = wd.WearRegion.RWRIST
                    end
                elseif item:getRegion() == wd.RegionType.RING then
                    if wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.LRING) == nil then
                        wearType = wd.WearRegion.LRING
                    elseif wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.RRING) == nil then
                        wearType = wd.WearRegion.RRING
                    elseif wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.LRING):getPower() < wd.GlobalData:getInstance():getWearEquip(wd.WearRegion.RRING):getPower() then
                        wearType = wd.WearRegion.LRING
                    else
                        wearType = wd.WearRegion.RRING
                    end
                else
                    wearType = item:getRegion()
                end
                
                if wearType == wd.WearRegion.RWRIST or wearType == wd.WearRegion.RRING then
                    wd.TranscodingSend:setEquipWear(item:getServerId(), 1) --right
                else
                    wd.TranscodingSend:setEquipWear(item:getServerId(), 0) --left
                end
                
                wd.GlobalData:getInstance():wearEquipForId(wearType, item:getServerId())
                self:getParent():updateFliter() -- PackageEquipLayer
            end
--        else    
--            cclog("!! ERROR level not enough !!")
        end
--    else    
--        cclog("!! ERROR job not support !!")
    end
end

function EquipTipsLayer:createLayerMenu(equipId, wearType, isOn, strengthen_level,tag)   -- isOn 0 = package  1 = wear   2 = wear but showOlny  3 = other wear  4 = in mail
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/EquipTipsLayer.csb"), "ccui.Widget")
    self:addChild(node)
    self.node = node
    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
    
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
    local leftTitle = tolua.cast(mainPanel:getChildByName("leftBtn_title"), "cc.Sprite")
    local rightTitle = tolua.cast(mainPanel:getChildByName("RightBtn_title"), "cc.Sprite")
    local leftBtn = ccui.Helper:seekWidgetByName(mainPanel,"Left_Button") 
    local rightBtn = ccui.Helper:seekWidgetByName(mainPanel,"Right_Button")
    local closeBtn = ccui.Helper:seekWidgetByName(mainPanel,"Close_Button") 
    leftBtn:setPressedActionEnabled(true)
    rightBtn:setPressedActionEnabled(true)
    ------------------------------新手引导----------------------------
    local clippingLayer = require("src.game.guidance.GuidanceLayer"):create()
    if clippingLayer then
        clippingLayer:setGuidance(rightBtn,10,10,115,115)
        if isOn == 1 then
            local msgTable = {}
            local msg = {}
            table.insert(msg,"{r=[穿戴在身上]}")
            table.insert(msg,"的装备，才可以强化哦！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
        else
            local msgTable = {}
            local msg = {}
            table.insert(msg,"点击")
            table.insert(msg,"{r=[装备]}")
            table.insert(msg,",即可穿戴上去哟！")
            table.insert(msgTable,msg)
            clippingLayer:setMsg(msgTable)
        end
        self.clippingLayer = clippingLayer
        self:addChild(clippingLayer)
    end
    ------------------------------------------------------------------
    
    
	local x,y = rightBtn:getPosition()
	wd.newGuidePos[wd.newGuideStep.EquipWear] = {}
	wd.newGuidePos[wd.newGuideStep.EquipWear].pos = rightBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.EquipWear].size = rightBtn:getContentSize()
	wd.newGuidePos[wd.newGuideStep.Strength] = {}
	wd.newGuidePos[wd.newGuideStep.Strength].pos = rightBtn:getParent():convertToWorldSpace(cc.p(x,y))
	wd.newGuidePos[wd.newGuideStep.Strength].size = rightBtn:getContentSize()
    closeBtn:setPressedActionEnabled(true)

    
    local item
    
    if isOn == 0 then
        item = wd.GlobalData:getInstance():getEquipItem(equipId)
        local serverId = item:getServerId()
        --cclog(" serverid %d ", serverId)
        
        -- if item:getQuality() == 3 then
        --     leftTitle:setSpriteFrame("upgrade_title.png")
        --     leftBtn:addTouchEventListener(
        --         function(sender,eventType)
        --             if eventType == ccui.TouchEventType.ended then
        --                 local layerClass = require("src.game.equip.RingUpgradeLayer")
        --                 local layer = layerClass.create()
        --                 layer:createLayerMenu(serverId)
        --                 self:getParent():addChild(layer)
        --                 self:removeFromParent()
        --             end
        --         end
        --     )
        -- else
        if item:getQuality() >= 3 then
            leftTitle:setSpriteFrame("upgrade_title.png")
            leftBtn:addTouchEventListener(
                function(sender,eventType)
                    if eventType == ccui.TouchEventType.ended then
                        local layerClass = require("src.game.equip.EquipUpgradeLayer")
                        local layer = layerClass.create()
                        layer:createLayerMenu(serverId)
                        self:getParent():addChild(layer)
                        self:removeFromParent()
                    end
                end
            )
        else
            leftTitle:setSpriteFrame("equip_sold_title.png")
            leftBtn:addTouchEventListener(
                function(sender,eventType)
                    if eventType == ccui.TouchEventType.ended then
                        wd.TranscodingSend:setEquipSell(item:getServerId())
                        --wd.GlobalData:getInstance():removeEquipItemForId(item:getServerId())
                        --self:getParent():updateFliter() -- PackageEquipLayer
                        self:removeFromParent()
                    end
                end
            )

        end
        

        rightTitle:setSpriteFrame("equip_wear_title.png")

        rightBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    if clippingLayer then
                        local event = cc.EventCustom:new("guidance_strengthen")
		                cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                        clippingLayer:removeFromParent()
                        clippingLayer = nil
                    end
                    self:wear(item, wearType)
					--local event = cc.EventCustom:new("Handle_NewGuile")
					--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                    self:removeFromParent()
                end
            end
        )

    elseif isOn == 1 then
        item = wd.GlobalData:getInstance():getWearEquip(wearType)

        leftTitle:setSpriteFrame("equip_takeout_title.png")
        rightTitle:setSpriteFrame("equip_strengthen_title.png")
        leftBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    wd.TranscodingSend:setEquipUnwear(item:getServerId())
                    self:getParent():takeoff(wearType)
                    self:removeFromParent()
                end
            end
        )
        rightBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    local layerClass = require("src.game.StrengthenLayer")
                    local layer = layerClass.create()
                    layer:createLayerMenu(wearType)
                    self:getParent():addChild(layer)
					--local event = cc.EventCustom:new("Handle_NewGuile")
					--cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                    self:removeFromParent()
                end
            end
        )
    elseif isOn == 2 then
        item = wd.GlobalData:getInstance():getWearEquip(wearType)
        
        leftTitle:setVisible(false)
        rightTitle:setVisible(false)
        leftBtn:setVisible(false)
        rightBtn:setVisible(false)
        
        closeBtn:setVisible(true)
        closeBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    self:removeFromParent()
                end
            end
        )
        
    elseif isOn == 3 then

        item = wd.GlobalData:getInstance():getOtherWearEquip(wearType)

        leftTitle:setVisible(false)
        rightTitle:setVisible(false)
        leftBtn:setVisible(false)
        rightBtn:setVisible(false)
       
        closeBtn:setVisible(true)
        closeBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    self:removeFromParent()
                end
            end
        )
	elseif isOn == 4 then
		item = wd.GlobalData:getInstance():getEquipInMailByTag(tag)
		leftTitle:setVisible(false)
        rightTitle:setVisible(false)
        leftBtn:setVisible(false)
        rightBtn:setVisible(false)
       
        closeBtn:setVisible(true)
        closeBtn:addTouchEventListener(
            function(sender,eventType)
                if eventType == ccui.TouchEventType.ended then
                    self:removeFromParent()
                end
            end
        )

    end
    
     --装备锤炼
    local smeltingBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Button"), "ccui.Widget")
    self.smeltingBtn = smeltingBtn
    if isOn == 0 or isOn == 1 then
        smeltingBtn:setPressedActionEnabled(true)
        smeltingBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                -- self:wear(item, wearType)
                local layerClass = require("src.game.tripod.SmeltingLayer")
                local layer = layerClass.create(equipId,item)
                self:getParent():addChild(layer)
                self:removeFromParent()
            end
        end
        )
    else
        smeltingBtn:setVisible(false)
    end
   
    
    local color = item:getColor()
    
    if strengthen_level < 0 then
        strengthen_level = item:getStrengthenLevel()
    end
    
    if item:getQuality() >= 2 then
        color = 6
    end
    
    local image = tolua.cast(mainPanel:getChildByName("Equip_Sprite"), "cc.Sprite")
    local id = item:getEquipId()
    image:setSpriteFrame(string.format("%d.png",id%1000))
    
    wd.equipEffect(item, image)
    
    local colorSprite = tolua.cast(mainPanel:getChildByName("Color_Sprite"), "cc.Sprite")
    colorSprite:setSpriteFrame(string.format("%02d.png",color))
    
    local title = tolua.cast(mainPanel:getChildByName("Job_Title"), "cc.Sprite")
    if item:getOccupation() <= 0 then
        title:setVisible(false)
    else
        title:setSpriteFrame(wd.getEquipTitleName(item:getOccupation()))
    end
    
    local levelLabel = tolua.cast(mainPanel:getChildByName("Level_Label"), "ccui.TextBMFont")
    levelLabel:setString(string.format("Lv%d",item:getLevel()))
    
    local nameLabel = tolua.cast(mainPanel:getChildByName("EquipName_Label"), "ccui.Text")
    --nameLabel:setString(item:getName())
    nameLabel:setColor(wd.colorType(color))
    
    if item:getQuality() >= 2 and strengthen_level >= 15 then
        nameLabel:setString(string.format("%s%s+%d",wd.getEquipTitle(item:getOccupation()), item:getName(), strengthen_level))
    elseif strengthen_level >0 then
        nameLabel:setString(string.format("%s+%d",item:getName(), strengthen_level))
    else
        nameLabel:setString(item:getName())
    end
    
    local descLabel = tolua.cast(mainPanel:getChildByName("Desc_Text"), "ccui.Text")
    descLabel:setString(string.format("描述：%s",item:getDescription()))
    
    local regionLabel = tolua.cast(mainPanel:getChildByName("Region_Label"), "ccui.Text")
    regionLabel:setString(string.format("位置：%s",wd.getRegionString(item:getRegion())))
    
    local jobLabel = tolua.cast(mainPanel:getChildByName("Job_Label"), "ccui.Text")
    jobLabel:setString(string.format("职业：%s",wd.getEquipJobString(item:getOccupation())))
    
    local powerLabel = tolua.cast(mainPanel:getChildByName("Power_Label"), "ccui.TextAtlas")
    powerLabel:setString(string.format("%d",item:getPower()))
    
    local attrScroll = tolua.cast(ccui.Helper:seekWidgetByName(mainPanel,"Attr_Scroll"), "ccui.ScrollView")
    
    local attrLayer = item:createDataLayer(attrScroll:getContentSize().width, attrScroll:getContentSize().height, strengthen_level)
    attrScroll:setInnerContainerSize(attrLayer:getContentSize())
    attrScroll:addChild(attrLayer)

end


return EquipTipsLayer