
local FilterLayer = class("FilterLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function FilterLayer.create()
    local layer = FilterLayer.new()
    layer:createLayerMenu()
    return layer
end

function FilterLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
end

function FilterLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/package/FilterScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Back_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
    local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    

    local  weaponBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Weapon_Button"), "ccui.Widget")
    weaponBtn:setPressedActionEnabled(true)
    weaponBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.WEAPON, true)
                self:removeFromParent()
            end
        end
    )
    local weaponLabel = tolua.cast(weaponBtn:getChildByName("Weapon_Label"), "ccui.Text")
    weaponLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.WEAPON)))
    

    local  necklaceBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Necklace_Button"), "ccui.Widget")
    necklaceBtn:setPressedActionEnabled(true)
    necklaceBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.NECKLACE, true)
                self:removeFromParent()
            end
        end
    )
    local necklaceLabel = tolua.cast(necklaceBtn:getChildByName("Necklace_Label"), "ccui.Text")
    necklaceLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.NECKLACE)))
    

    local  helmetBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Helmet_Button"), "ccui.Widget")
    helmetBtn:setPressedActionEnabled(true)
    helmetBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.HELMET, true)
                self:removeFromParent()
            end
        end
    )
    local helmetLabel = tolua.cast(helmetBtn:getChildByName("Helmet_Label"), "ccui.Text")
    helmetLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.HELMET)))
    

    local  wristBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Wrist_Button"), "ccui.Widget")
    wristBtn:setPressedActionEnabled(true)
    wristBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.WRIST, true)
                self:removeFromParent()
            end
        end
    )
    local wristLabel = tolua.cast(wristBtn:getChildByName("Wrist_Label"), "ccui.Text")
    wristLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.WRIST)))
    
    

    local  breastplateBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Breastplate_Button"), "ccui.Widget")
    breastplateBtn:setPressedActionEnabled(true)
    breastplateBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.BREASTPLATE, true)
                self:removeFromParent()
            end
        end
    )
    local breastplateLabel = tolua.cast(breastplateBtn:getChildByName("Breastplate_Label"), "ccui.Text")
    breastplateLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.BREASTPLATE)))
    

    local  ringBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Ring_Button"), "ccui.Widget")
    ringBtn:setPressedActionEnabled(true)
    ringBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.RING, true)
                self:removeFromParent()
            end
        end
    )
    local ringLabel = tolua.cast(ringBtn:getChildByName("Ring_Label"), "ccui.Text")
    ringLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.RING)))
    

    local  shoeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Shoe_Button"), "ccui.Widget")
    shoeBtn:setPressedActionEnabled(true)
    shoeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.REGION, wd.RegionType.SHOE, true)
                self:removeFromParent()
            end
        end
    )
    local shoeLabel = tolua.cast(shoeBtn:getChildByName("Shoe_Label"), "ccui.Text")
    shoeLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.SHOE)))
    

    
    local allBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"All_Button"), "ccui.Widget")
    allBtn:setPressedActionEnabled(true)
    allBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.NO_FLITER, wd.RegionType.ALL, true)
                self:removeFromParent()
            end
        end
    )
    local allLabel = tolua.cast(allBtn:getChildByName("All_Label"), "ccui.Text")
    allLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipRegionCount(wd.RegionType.ALL)))
    
    
  
    local  whiteBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"White_Button"), "ccui.Widget")
    whiteBtn:setPressedActionEnabled(true)
    whiteBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.COLOR, wd.ColorType.WHITE, true)
                self:removeFromParent()
            end
        end
    )
    local whiteLabel = tolua.cast(whiteBtn:getChildByName("White_Label"), "ccui.Text")
    whiteLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.WHITE)))
    
    
    local greenBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Green_Button"), "ccui.Widget")
    greenBtn:setPressedActionEnabled(true)
    greenBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.COLOR, wd.ColorType.GREEN, true)
                self:removeFromParent()
            end
        end
    )
    local greenLabel = tolua.cast(greenBtn:getChildByName("Green_Label"), "ccui.Text")
    greenLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.GREEN)))
    
    
    local blueBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Blue_Button"), "ccui.Widget")
    blueBtn:setPressedActionEnabled(true)
    blueBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.COLOR, wd.ColorType.BLUE, true)
                self:removeFromParent()
            end
        end
    )
    local blueLabel = tolua.cast(blueBtn:getChildByName("Blue_Label"), "ccui.Text")
    blueLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.BLUE)))
    
    local purpleBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Purple_Button"), "ccui.Widget")
    purpleBtn:setPressedActionEnabled(true)
    purpleBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.COLOR, wd.ColorType.PURPLE, true)
                self:removeFromParent()
            end
        end
    )
    local purpleLabel = tolua.cast(purpleBtn:getChildByName("Purple_Label"), "ccui.Text")
    purpleLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.PURPLE)))
    
    local goldBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Gold_Button"), "ccui.Widget")
    goldBtn:setPressedActionEnabled(true)
    goldBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:getParent():filter(wd.FilterType.COLOR, wd.ColorType.GOLD, true)
                self:removeFromParent()
            end
        end
    )
    local goldLabel = tolua.cast(goldBtn:getChildByName("Gold_Label"), "ccui.Text")
    goldLabel:setString(string.format("X%d",  wd.GlobalData:getInstance():classifyEquipColorCount(wd.ColorType.GOLD)))
    
    
end


return FilterLayer