
local CdkeyLayer = class("CdkeyLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function CdkeyLayer.create()
    local layer = CdkeyLayer.new()
    layer:createLayerMenu()
    return layer
end

function CdkeyLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.dataHandler = wd.familyHandler 
end

function CdkeyLayer:clear()
	self:removeFromParent()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item")
end

function CdkeyLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/setting/CdKeyLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)
	
	local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	local inputBox = tolua.cast(mainPanel:getChildByName("Input_TextBox"), "ccui.TextField")
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Close_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				self:clear()
            end
        end
    )
	
		
	local exchangeBtn = ccui.Helper:seekWidgetByName(node,"Exchange_Button")
	exchangeBtn:setPressedActionEnabled(true)
    exchangeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				--兑换
				local text = inputBox:getString()
				if text ~= "" then
					wd.TranscodingSend:getAwardCdk(text)
					--self:clear()
				end
            end
        end
    )
	
	local function onGetAwardCdk()
		--wd.showSystemTips("兑换成功")
		local getData = wd.GlobalData:getInstance():getMessage("Get_Item")
        if getData:len() >= 5 then
            local layerClass = require("src.game.package.ToolsGetLayer")
            local layer = layerClass.create()
            layer:createLayerMenu(getData)
            self:getParent():addChild(layer)
        end
	end
	
	local listener = cc.EventListenerCustom:create("Get_Item", onGetAwardCdk)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	
end

return CdkeyLayer
