local ArtifactTipsLayer = class("ArtifactTipsLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function ArtifactTipsLayer.create()
    local layer = ArtifactTipsLayer.new()
    return layer
end

function ArtifactTipsLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
	self.dataHandler = wd.shopHandler
end

function ArtifactTipsLayer:createLayerMenu(item,colorNum)
    local node = tolua.cast(cc.CSLoader:createNode("ui/shop/ArtifactTipsLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)
   
    local backBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Close_Button"), "ccui.Widget")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
	
	local closeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Center_Close_Button"), "ccui.Widget")
    closeBtn:setPressedActionEnabled(true)
    closeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                self:removeFromParent()
            end
        end
    )
    
	
    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Main"), "ccui.Widget")
	if item then
		local image = tolua.cast(mainPanel:getChildByName("Equip_Sprite"), "cc.Sprite")
		image:setSpriteFrame(string.format("%d.png",item:getEquipId()%1000))
		
		wd.equipEffect(item, image)
		
        if not colorNum then
            colorNum = item:getColor()
        end
		local color = tolua.cast(mainPanel:getChildByName("Color_Sprite"), "cc.Sprite")
		color:setSpriteFrame(string.format("%02d.png",colorNum))
		
		local title = tolua.cast(mainPanel:getChildByName("Job_Title"), "cc.Sprite")
		if item:getOccupation() <= 0 then
			title:setVisible(false)
		else
			title:setSpriteFrame(wd.getEquipTitleName(item:getOccupation()))
		end
		
		local levelLabel = tolua.cast(mainPanel:getChildByName("Level_Label"), "ccui.TextBMFont")
		levelLabel:setString(string.format("Lv%d",item:getLevel()))
		
		local nameLabel = tolua.cast(mainPanel:getChildByName("Name_Label"), "ccui.Text")
		nameLabel:setColor(wd.colorType(colorNum))
		nameLabel:setString(item:getName())
		
		local descLabel = tolua.cast(mainPanel:getChildByName("Desc_Text"), "ccui.Text")
		descLabel:setString(string.format("描述：%s",item:getDescription()))
		
		local regionLabel = tolua.cast(mainPanel:getChildByName("Region_Label"), "ccui.Text")
		regionLabel:setString(string.format("位置：%s",wd.getRegionString(item:getRegion())))
		
		local jobLabel = tolua.cast(mainPanel:getChildByName("Job_Label"), "ccui.Text")
		jobLabel:setString(string.format("职业：%s",wd.getEquipJobString(item:getOccupation())))
		
		local powerLabel = tolua.cast(mainPanel:getChildByName("Power_Label"), "ccui.TextAtlas")
		powerLabel:setString(string.format("%d",item:getPower()))
		
		local attrScroll = tolua.cast(mainPanel:getChildByName("Attr_Scroll"), "ccui.ScrollView")
		
		
		local attrLayer = item:createDataLayer(attrScroll:getContentSize().width, attrScroll:getContentSize().height, 0)
		attrScroll:setInnerContainerSize(attrLayer:getContentSize())
		attrScroll:addChild(attrLayer)
    end
end


return ArtifactTipsLayer