
local ShopItemLayer = class("ShopItemLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function ShopItemLayer.create()
    local layer = ShopItemLayer.new()
    layer:createLayerMenu()
    return layer
end

function ShopItemLayer:ctor()
	--cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/toolsImage.plist", "ui/other/toolsImage.png")
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.itemNodeList = {}
	self.itemNodeSize = cc.size(770,128)
	self.gap = 30
	self.leftNodePosX = 44
	self.rightNodePosX = 44+314+54
	self.dataHandler = wd.shopHandler
end

function ShopItemLayer:clear()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Buy_Item")
    self:removeFromParent()
end

function ShopItemLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/shop/ShopItemScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
	ccui.Helper:doLayout(node)
	
    local backBtn = ccui.Helper:seekWidgetByName(node,"Back_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item_Msg")
				self:clear()
            end
        end
    )

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Main_Panel"), "ccui.Widget")
    --mainPanel:setContentSize(cc.size(self.visibleSize.width, self.visibleSize.height - 88))

   
	
    local artifactBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Artifact_Button"), "ccui.Button")
    artifactBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Get_Item_Msg")
                local layerClass = require("src.game.shop.ShopArtifactLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
				self:clear()
                -- wd.showRichTips(4,"暂未开放")
            end
        end
    )
	
	local rechargeBtn = tolua.cast(mainPanel:getChildByName("Recharge_Button"), "ccui.Button")
    rechargeBtn:setPressedActionEnabled(true)
    rechargeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                --wd.showSystemTips("暂未开放")
                local layerClass = require("src.game.charge.ChargeLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
                self:clear()
            end
        end
    )
	
	local gemLabel = tolua.cast(mainPanel:getChildByName("Gold_Label"), "ccui.Text")
	gemLabel:setString(wd.GlobalData:getInstance():getRoleGem())
	
	local itemScroll = tolua.cast(mainPanel:getChildByName("Item_Scroll"), "ccui.ScrollView")
	
	
	local itemCount = self.dataHandler:getItemCount()
    
    local nodeCount = math.ceil(itemCount/3)

    self.containerSize = cc.size(self.itemNodeSize.width,(self.itemNodeSize.height+self.gap*2)*nodeCount - self.gap)
    
	if nodeCount ~= 0 then
		itemScroll:setInnerContainerSize(self.containerSize)
		--[[for i = 1,nodeCount do
			local node = cc.Node:create()
			node:setContentSize(self.itemNodeSize)
			itemScroll:addChild(node)
			--node:setPosition(0,self.gap+(nodeCount-i)*(self.itemNodeSize.height+self.gap))
			node:setPosition(0,itemScroll:getInnerContainerSize().height - self.gap - i*(self.itemNodeSize.height+self.gap))
			self.itemNodeList[i] = node
		end--]]
	end
    local width = itemScroll:getContentSize().width 
	if itemCount > 0 then
		for i = 0,itemCount-1 do
			local mallItem = self.dataHandler:getMallItem(i)
			--local itemId = mallItem:getMallItemId()
			local function mallBtn(sender,eventType)
				if eventType == ccui.TouchEventType.ended then
                    local layerClass = require("src.game.shop.BuyItemLayer")
					local layer = layerClass.create()
					layer:createLayerMenu(mallItem)
					self:addChild(layer)
				end
			end
			local btn = ccui.Button:create("package_subbox.png", "package_subbox.png", "", ccui.TextureResType.plistType)
			btn:setTag(i)
			btn:addTouchEventListener(mallBtn)
			local itemNode = tolua.cast(cc.CSLoader:createNode("ui/shop/MallItemNode.csb"),"ccui.Widget")
			btn:setAnchorPoint(cc.p(0,0))
			btn:addChild(itemNode)
			local icon = tolua.cast(itemNode:getChildByName("Tools_Sprite"), "cc.Sprite")
			icon:setSpriteFrame(string.format("%d.png",mallItem:getMallItemId()))
			icon:setVisible(true)
			if mallItem:getQuality() == 5 then
				wd.itemEffect(icon)
			end
			local color = tolua.cast(itemNode:getChildByName("Color_Sprite"), "cc.Sprite")
			color:setSpriteFrame(string.format("%02d.png",mallItem:getQuality()))
			
			local nameLabel = tolua.cast(itemNode:getChildByName("Name_Label"), "ccui.Text")
			nameLabel:setString(mallItem:getName())
			nameLabel:setColor(wd.colorTable[mallItem:getQuality()])
			
			local priceLabel = tolua.cast(itemNode:getChildByName("Number_Label"), "ccui.Text")
			priceLabel:setString(string.format("%d",mallItem:getPrice()))
			
			--[[local mallBtn = tolua.cast(itemNode:getChildByName("Mall_Button"), "ccui.Button")
			mallBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
            local layerClass = require("src.game.shop.BuyItemLayer")
						local layer = layerClass.create()
						layer:createLayerMenu(mallItem)
						self:addChild(layer)
					end
				end
			)--]]
			
			local iconBtn = tolua.cast(itemNode:getChildByName("Item_Button"), "ccui.Button")
			iconBtn:addTouchEventListener(
				function(sender,eventType)
					if eventType == ccui.TouchEventType.ended then
                        local layerClass = require("src.game.shop.ItemDetailLayer")
						local layer = layerClass.create()
						layer:createLayerMenu(mallItem)
						self:addChild(layer)
					end
				end
			)
			--self.itemNodeList[tag]:addChild(btn)
			itemScroll:addChild(btn)
			btn:setPosition(width/3*(i%3) + (width/3 - btn:getContentSize().width)/2,itemScroll:getInnerContainerSize().height - math.floor(i/3+1)*(self.itemNodeSize.height + self.gap) - math.floor(i/3)*self.gap)
		
		end
	end
	itemScroll:jumpToTop()
	
	local function buyItemCallBack()
		gemLabel:setString(wd.GlobalData:getInstance():getRoleGem())
		--wd.showSystemTips("购买成功")
	end
	local listenerBuyItem = cc.EventListenerCustom:create("Buy_Item", buyItemCallBack)
	cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerBuyItem, 1)
	
	local function getCallback(EventCustom)
        local getData = wd.GlobalData:getInstance():getMessage("Get_Item_Msg")
		local itemInfo = wd.getItemInfo(getData)
		if itemInfo == nil or itemInfo.name == nil or itemInfo.color == nil or itemInfo.count == nil then
			return
		end
		local msg = {}
		table.insert(msg,"购买成功，获得")
		table.insert(msg,string.format("{t=[%s],c=[%d]}",itemInfo.name,itemInfo.color))
		table.insert(msg,string.format("*%d",itemInfo.count))
		wd.showRichTips(wd.tipsType.Buy,msg)
    end

    local listener = cc.EventListenerCustom:create("Get_Item_Msg", getCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

return ShopItemLayer