
local SkillLayer = class("SkillLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end


function SkillLayer.create()
    local layer = SkillLayer.new()
	-- todo
	--cc.SpriteFrameCache:getInstance():addSpriteFrames("ui/other/skillImage.plist", "ui/other/skillImage.png")
    layer:createLayerMenu()
    return layer
end

function SkillLayer:ctor()
	require("src.game.skill.SkillConfig")
	wd.TranscodingSend:getAllSkill()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
	self.selectSkill = 1
	self.dataHandler = wd.skillHandler
end

function SkillLayer:clear()
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_SkillData")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Update_SkillList")
	cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("SkillList_Set")
	self.dataHandler = nil
end

function SkillLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/skill/SkillScene.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    local backBtn = ccui.Helper:seekWidgetByName(node,"Back_Button")
	backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("Check_New_Tip")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
				self:clear()
                self:removeFromParent()
            end
        end
    )

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Box"), "ccui.Widget")
    --mainPanel:setContentSize(cc.size(self.visibleSize.width, self.visibleSize.height - 88))

	local helpBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Help_Button"), "ccui.Widget")
    helpBtn:setPressedActionEnabled(true)
    helpBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.setting.HelpLayer")
				local layer = layerClass.create(wd.helpType.Sub,wd.helpTag.Skill)
				self:addChild(layer)
            end
        end
    )
	
    local settingsBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Settings_Button"), "ccui.Button")
    settingsBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.skill.SkillSettingsLayer")
                local layer = layerClass.create()
                self:getParent():addChild(layer)
				self:clear()
                self:removeFromParent()
            end
        end
    )

	-- 升级按钮
	local upgradeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"DoUpgrade_Button"), "ccui.Button")
	upgradeBtn:setPressedActionEnabled(true)
	upgradeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				
                -- todo 升级
				if self.selectSkill then
					-- 请求升级
					--[[if self.dataHandler:checkCanUpGrade(self.selectSkill,wd.UpgradeType.eUpgrade) then
						self.dataHandler:requestUpgradeSkill(self.selectSkill,wd.UpgradeType.eUpgrade)
					else
						wd.showRichTips(4,"技能丹不足")
					end--]]
					self.dataHandler:requestUpgradeSkill(self.selectSkill,wd.UpgradeType.eUpgrade)
				end
				
            end
        end
    )
	-- 升级按钮图片
	local upgradeBtnImage = tolua.cast(upgradeBtn:getChildByName("title"), "cc.Sprite")
	
	
	-- 一键升级按钮
	local autoUpgradeBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Auto_Button"), "ccui.Button")
	autoUpgradeBtn:setPressedActionEnabled(true)
	autoUpgradeBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                -- todo 一键升级
				if self.selectSkill then
					-- 请求升级
					self.dataHandler:requestUpgradeSkill(self.selectSkill,wd.UpgradeType.eAutoUpgrade)
				end
            end
        end
    )
	
	 
	-- 技能列表
	local skillList = tolua.cast(ccui.Helper:seekWidgetByName(node,"Skill_List"), "ccui.ListView")
	local skillCount = wd.GlobalData:getInstance():getSkillItemCount()
		-- 升级条件
	local condictionLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Condition_Label"),"ccui.TextBMFont")
	
	-- 技能名字
	local skillNameLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Name_Label"),"ccui.Text")
	
	-- 技能图标
	local skillPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Skill"), "ccui.Widget")
	local skillIcon = tolua.cast(skillPanel:getChildByName("Skill_Sprite"), "cc.Sprite")
	skillIcon:setVisible(true)
	-- 本级效果
	local curEffect = tolua.cast(ccui.Helper:seekWidgetByName(node,"CurEffect_Text"),"ccui.Text")
	
	-- 下级效果
	local nextEffect = tolua.cast(ccui.Helper:seekWidgetByName(node,"NextEffect_Text"),"ccui.Text")
	
	-- 经验
	local expLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Exp_Label"),"ccui.Text")
	
	-- 当前道具
	
	local useLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Use_Text"),"ccui.Text")
	-- 技能丹数量
	local numberLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Number_Label"),"ccui.Text")
	
	-- 经验进度条
	local expBar = tolua.cast(ccui.Helper:seekWidgetByName(node,"Exp_Bar"),"ccui.LoadingBar")
	
	local function updateExp(skill)
		local skillItem = skill.skillItem
		if self.checkSkillIsFullLevel(skillItem) then	-- 神级
			expLabel:setString("已满级")
			expBar:setPercent(100)
		else
			expLabel:setString(string.format("%d/%d",skill.exp,skillItem:getRequiredExp()))
			expBar:setPercent(skill.exp/skillItem:getRequiredExp()*100)
		end
		local numberString
		if self.checkSkillIsFullLevel(skillItem) then	-- 神级
			numberLabel:setVisible(false)
			useLabel:setVisible(false)
		else
			numberLabel:setVisible(true)
			useLabel:setVisible(true)
			if self.checkNextSkillIsFullLevel(skillItem) and skill.exp == skillItem:getRequiredExp() then
				autoUpgradeBtn:setEnabled(false)
				upgradeBtnImage:setSpriteFrame("skill_advancedbtn_title.png")
				numberString = self.dataHandler:getSkillAdvancedDrugCount()
				useLabel:setString("当前拥有进阶丹：")
			else
				autoUpgradeBtn:setEnabled(true)
				upgradeBtnImage:setSpriteFrame("skill_upgradebtn_title.png")
				numberString = self.dataHandler:getSkillUpgradeDrugCount()
				useLabel:setString("当前拥有技能丹：")
			end
			numberLabel:setString(numberString)
		end
	end
	
	local function updateSkillInfo(skill)
		local skillItem = skill.skillItem
		condictionLabel:setString(string.format("Lv%d",skillItem:getRoleLevel()))
		local nameString
		if self.checkSkillIsFullLevel(skillItem) then
			nameString = skillItem:getName()
		else
			nameString = string.format("%sLv%d",skillItem:getName(),skillItem:getLevel())
		end
		skillNameLabel:setString(nameString)
		curEffect:setString(string.format("%s",skillItem:getDescription()))
		skillIcon:setSpriteFrame(string.format("%d.png",skillItem:getIconId()))
		nextEffect:setString(string.format("%s",(self.dataHandler:getNextSkillItemDescptionByCurrentSkillItem(skillItem) or "已达满级")))
	end
	
	local function updataSkillData(event)
		local skill = nil
		if event and event.tag then
			skill = self.dataHandler:getMySkillItemByTag(event.tag)
		else
		
			-- 初始显示第一个
			skill = self.dataHandler:getMySkillItemByTag(1)
		end
		if skill then
			updateExp(skill)
			updateSkillInfo(skill)
		end
	end
	
	-- 技能列表点击
	local function setSkillInfo(sender,eventType)
		if eventType == ccui.TouchEventType.ended then
			if self.selectSkill == sender:getTag() then
				return
			end
			wd.setSelectBox(skillList,self.selectSkill,sender:getTag())
			self.selectSkill = sender:getTag()
			local event = cc.EventCustom:new("Update_SkillData")
			event.tag = self.selectSkill
			
			
			cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
		end
	end
	local function setSkillList(event)
		local skillInfoList = self.dataHandler:getMySkillList()
		if skillInfoList then
			for i,v in ipairs(skillInfoList) do
				if v then
					local skillNode = tolua.cast(cc.CSLoader:createNode("ui/skill/SkillNode.csb"),"ccui.Widget")
					local btn = ccui.Button:create("smelting_item_box.png", "smelting_item_box.png", "", ccui.TextureResType.plistType)
					btn:setAnchorPoint(cc.p(0,0))
					btn:setTag(i)
					btn:addTouchEventListener(setSkillInfo)
					skillNode:setTag(i)
					btn:addChild(skillNode)
					
					local selectBox = tolua.cast(skillNode:getChildByName("Select_Sprite"), "cc.Sprite")
					if i == 1 then
						selectBox:setVisible(true)
					else
						selectBox:setVisible(false)
					end
					-- 技能icon
					local icon = tolua.cast(skillNode:getChildByName("Skill_Sprite"), "cc.Sprite")
					icon:setSpriteFrame(string.format("%d.png",v.skillItem:getIconId()))
					icon:setVisible(true)
					
					-- 技能名字
					local nameLabel = tolua.cast(skillNode:getChildByName("Name_Label"), "ccui.Text")
					nameLabel:setString(v.skillItem:getName())
					
					-- 技能类型
					local typeImage = tolua.cast(skillNode:getChildByName("Skill_Title"), "cc.Sprite")
					if v.skillItem:getType() == 1 then -- 主动
						typeImage:setSpriteFrame("skill_initiative_title.png")
					elseif v.skillItem:getType() == 2 then	-- 被动
						typeImage:setSpriteFrame("skill_passive_title.png")
					end
					-- 技能等级
					local levelLabel = tolua.cast(skillNode:getChildByName("Region_Label"), "ccui.Text")
					local levelString , levelTextColor , nameTextColor
					if not v.isLearned then
						levelString = "未学会"
						levelTextColor = cc.c4b(0x60,0x60,0x60,0xff)
						nameTextColor = cc.c4b(0x60,0x60,0x60,0xff)
					else
						if self.checkSkillIsFullLevel(v.skillItem) then
							levelString = "神级"
							levelTextColor=	cc.c4b(0xff,0xd7,0,0xff)
							nameTextColor =	cc.c4b(0xff,0xd7,0,0xff)
						else
							levelString = string.format("等级: %d",v.skillItem:getLevel())
							levelTextColor= cc.c4b(0xff,0xff,0xff,0xff)
							nameTextColor = cc.c4b(0xff,0x20,0x20,0xff)
						end
						if v.skillItem:getType() == 1 then	-- 主动
							levelString = levelString..string.format(" 法力:%d",v.skillItem:getUse_energy())
						end
					end
					levelLabel:setString(levelString)
					levelLabel:setColor(levelTextColor)
					nameLabel:setColor(nameTextColor)
					skillList:pushBackCustomItem(btn)
				end
			end
			updataSkillData()
		end
	end

	
	-- 更新左侧技能列表
	local function updataSkillList(event)
		local skillList = tolua.cast(ccui.Helper:seekWidgetByName(node,"Skill_List"), "ccui.ListView")
		if skillList and event and event.tag then
			--local btn = skillList:getItem(event.tag)
			local btn = skillList:getChildByTag(event.tag)
			if btn then
				local skillNode = btn:getChildByTag(event.tag)
				local skill = self.dataHandler:getMySkillItemByTag(event.tag)
				if skillNode and skill then
					-- 技能名字
					local nameLabel = tolua.cast(skillNode:getChildByName("Name_Label"), "ccui.Text")
					nameLabel:setString(skill.skillItem:getName())
					
					-- 技能等级
					local levelLabel = tolua.cast(skillNode:getChildByName("Region_Label"), "ccui.Text")
					local levelString , levelTextColor,nameTextColor
					if not skill.isLearned then
						levelString = "未学会"
						levelTextColor = cc.c4b(0x60,0x60,0x60,0xff)
						nameTextColor = cc.c4b(0x60,0x60,0x60,0xff)
					else
						if self.checkSkillIsFullLevel(skill.skillItem) then
							levelString = "神级"
							levelTextColor=	cc.c4b(0xff,0xd7,0,0xff)
							nameTextColor =	cc.c4b(0xff,0xd7,0,0xff)
						else
							levelString = string.format("等级: %d",skill.skillItem:getLevel())
							levelTextColor= cc.c4b(0xff,0xff,0xff,0xff)
						nameTextColor = cc.c4b(0xff,0x20,0x20,0xff)
						end
					end
					levelLabel:setString(levelString)
					levelLabel:setColor(levelTextColor)
					nameLabel:setColor(nameTextColor)
				end
			end
		end
	end
	
	
	
	
	local listener = cc.EventListenerCustom:create("Update_SkillData", updataSkillData)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    
	local listener = cc.EventListenerCustom:create("Update_SkillList", updataSkillList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
	
	local listener = cc.EventListenerCustom:create("SkillList_Set", setSkillList)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
    ccui.Helper:doLayout(node)
	
end

-- 当前是满级
function SkillLayer.checkSkillIsFullLevel(skillItem)
	if skillItem and skillItem:getLevel() == wd.FULL_LEVEL then
		return true
	end
	return false
end

-- 下级是满级
function SkillLayer.checkNextSkillIsFullLevel(skillItem)
	if skillItem and skillItem:getLevel() == wd.FULL_LEVEL-1 then
		return true
	end
	return false
end

return SkillLayer