local SmeltingLayer = class("SmeltingLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function SmeltingLayer.create(equipId,item)
    local layer = SmeltingLayer.new()
    layer:setItem(item)
    layer:createLayerMenu(equipId)
    return layer
end

function SmeltingLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    self.smeltingType = 0  -- change = 0  up = 1
    self.mainNode = nil
    self.dataLayer = nil
	self.initSelect = true
    self.changeStoneCount = 0
    self.upStoneCount = 0
    self.needStone = 0
    
    self.changeStoneNumber = nil

end

function SmeltingLayer:registerEventListener()

    local function changeCallback(EventCustom)
        self:showSmeltingEquip(self.equipId)
		wd.showRichTips(4,"洗练成功")
        
        self.changeStoneNumber:setString(string.format("%d", wd.GlobalData:getInstance():getToolsItemCountForId(wd.ItemId.ChangeStone)))
    end
    
    local function upCallback(EventCustom)
        self:getXueData()
        self:setXueData()
    end

    local listenerChange = cc.EventListenerCustom:create("Smelting_Change", changeCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerChange, 1);
    local listenerUp = cc.EventListenerCustom:create("Smelting_Up", upCallback)
    cc.Director:getInstance():getEventDispatcher():addEventListenerWithFixedPriority(listenerUp, 1); 
	
end

function SmeltingLayer:unregisterEventListener()
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Smelting_Change")
    cc.Director:getInstance():getEventDispatcher():removeCustomEventListeners("Smelting_Up")
end

function SmeltingLayer:showSmeltingEquip(equipId)

    if equipId == nil then
        return
    end

    local item = self:getItem()
    
    if item == nil then
        return
    end
    
    local equipName = tolua.cast(ccui.Helper:seekWidgetByName(self.mainNode,"equip_name"), "ccui.Text")
    equipName:setString(item:getName())
    
    local equipJob = tolua.cast(ccui.Helper:seekWidgetByName(self.mainNode,"Equip_Job"), "ccui.Text")
    equipJob:setString(wd.getEquipJobString(item:getOccupation()))
    
    local equipPosition = tolua.cast(ccui.Helper:seekWidgetByName(self.mainNode,"Equip_Position"), "ccui.Text")
    equipPosition:setString(wd.getRegionString(item:getRegion()))
    
    local panelAttr = tolua.cast(ccui.Helper:seekWidgetByName(self.mainNode,"Panel_Attr"), "ccui.Widget")
    
    local image = tolua.cast(panelAttr:getChildByName("Equip_Sprite"), "cc.Sprite")
    image:setVisible(true)
    image:setSpriteFrame(string.format("%d.png",item:getEquipId()%1000))
    
    image:removeAllChildren()
    wd.equipEffect(item, image)
    
    local color = tolua.cast(panelAttr:getChildByName("Color_Sprite"), "cc.Sprite")
    color:setVisible(true)
    color:setSpriteFrame(string.format("%02d.png",item:getColor()))
    
    local levelLabel = tolua.cast(panelAttr:getChildByName("Level_Label"), "ccui.TextBMFont")
    levelLabel:setVisible(true)
    levelLabel:setString(string.format("Lv %d",item:getLevel()))
    
   if self.dataLayer == nil then
    
        -- local bestTitle = tolua.cast(panelAttr:getChildByName("Best_Title"), "ccui.Text")
        -- bestTitle:setVisible(true)

        -- local x = bestTitle:getPositionX()
        -- local y = bestTitle:getPositionY()
    

        self.dataLayer = cc.Layer:create()
        -- self.dataLayer:setPosition(cc.p(x+20,y-25))
        panelAttr:addChild(self.dataLayer)
    else
        self.dataLayer:removeAllChildren()
    end

    local count = item:getBestAttrCount()
    local x = 0
    local y = 0
    for i=0,count-1 do
        y = y-25
        local bestAttr = item:getBestAttr(i)
        local attrLabel = wdui.BattleLabel:create()
        if self.count > 0 then
            attrLabel:setBestAttrString(bestAttr:getName(), string.format("  +%d  ",bestAttr:getValue()) ,string.format("(＋%d)",math.ceil(bestAttr:getValue()*self.count/100)))
        else
            attrLabel:setBestAttrString(bestAttr:getName(), string.format("  +%d  ",bestAttr:getValue()) ,"")
        end
        attrLabel:setPosition(cc.p(x,y))
        self.dataLayer:addChild(attrLabel)
    end
    
end

function SmeltingLayer:setItem(item)
    self.item = item
end

function SmeltingLayer:getItem()
    if self.item then
        return self.item
    else
        return wd.GlobalData:getInstance():getEquipItem(self.equipId)
    end
end



function SmeltingLayer:createLayerMenu(equipId)
    self.config = require("res/config/equipmentrefine2")
    self.equipId = equipId
    local node = tolua.cast(cc.CSLoader:createNode("ui/tripod/SmeltingScene.csb"), "ccui.Widget")
    self:addChild(node)
    self.node = node

    self.mainNode = node
    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)
    ccui.Helper:doLayout(node)


    local backBtn = ccui.Helper:seekWidgetByName(node,"Back_Button")
    backBtn:setPressedActionEnabled(true)
    backBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
				local event = cc.EventCustom:new("Check_New_Tip")
				cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
                self:unregisterEventListener()
                self:removeFromParent()
            end
        end
    )
	
	local helpBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Help_Button"), "ccui.Widget")
    helpBtn:setPressedActionEnabled(true)
    helpBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                local layerClass = require("src.game.setting.HelpLayer")
				local layer = layerClass.create(wd.helpType.Sub,wd.helpTag.Smelting)
				self:addChild(layer)
            end
        end
    )
    
    

  

    local mainPanel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Panel_Box"), "ccui.Widget")
    --mainPanel:setContentSize(cc.size(self.visibleSize.width, self.visibleSize.height - 88))

    local upCheck = tolua.cast(ccui.Helper:seekWidgetByName(node,"UpStone_Check"), "ccui.CheckBox")


    local stoneLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Stone_Label"), "ccui.Text")
    local numberLabel = tolua.cast(ccui.Helper:seekWidgetByName(node,"Number_Label"), "ccui.Text")

    
    
    local item = self:getItem()
    self.needStone = math.ceil(item:getLevel()/5*(item:getColor() >= 6 and 5 or item:getColor()))
    numberLabel:setString(string.format("x%d",self.needStone))


    local changeStoneNumber = tolua.cast(ccui.Helper:seekWidgetByName(node,"ChangeStone_Number"), "ccui.Text")

    self.changeStoneNumber = changeStoneNumber

    
    self.changeStoneCount = wd.GlobalData:getInstance():useToolsItemForId(wd.ItemId.ChangeStone, 0)
    self.upStoneCount = wd.GlobalData:getInstance():useToolsItemForId(wd.ItemId.UpStone, 0)

    changeStoneNumber:setString(string.format("%d", self.changeStoneCount))    
    
    local dosmeltingBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"DoSmelting_Button"), "ccui.Button")
    dosmeltingBtn:setPressedActionEnabled(true)
    dosmeltingBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if self.equipId ~= nil then
                    local item = self:getItem()
                    if wd.GlobalData:getInstance():useToolsItemForId(wd.ItemId.ChangeStone, self.needStone) >= 0 then  -- -1 not enough
                        wd.TranscodingSend:setEquipSmeltingChange(item:getServerId())
                    else
                        wd.showRichTips(4,"洗炼神石不足")
                    end
                end
            end
        end
    )
    
    local btn1 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Btn1"), "ccui.Button")
    btn1:setPressedActionEnabled(true)
    btn1:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleData():getGold() >= self.config[1].cost then
                    wd.TranscodingSend:setEquipSmeltingUp(self:getItem():getServerId(),1)
                else
                    wd.showRichTips(4,"金币不足")
                end
            end
        end
    )
    
    local btn2 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Btn2"), "ccui.Button")
    btn2:setPressedActionEnabled(true)
    btn2:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleData():getGold() >= self.config[2].cost then
                    wd.TranscodingSend:setEquipSmeltingUp(self:getItem():getServerId(),2)
                else
                    wd.showRichTips(4,"金币不足")
                end
            end
        end
    )
    
    local btn3 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Btn3"), "ccui.Button")
    btn3:setPressedActionEnabled(true)
    btn3:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleData():getGold() >= self.config[3].cost then
                    wd.TranscodingSend:setEquipSmeltingUp(self:getItem():getServerId(),3)
                else
                    wd.showRichTips(4,"金币不足")
                end
            end
        end
    )
    local btn4 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Btn4"), "ccui.Button")
    btn4:setPressedActionEnabled(true)
    btn4:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleData():getGem() >= self.config[4].cost then
                    wd.TranscodingSend:setEquipSmeltingUp(self:getItem():getServerId(),4)
                else
                    -- wd.showRichTips(4,"元宝不足")
                    local layerClass = require("src.game.charge.ChargeTipsScene")
                    local layer = layerClass:create()
                    self:getParent():addChild(layer)
                    self:removeFromParent()
                end
            end
        end
    )
    
    local btn5 = tolua.cast(ccui.Helper:seekWidgetByName(node,"Smelting_Btn5"), "ccui.Button")
    btn5:setPressedActionEnabled(true)
    btn5:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                if wd.GlobalData:getInstance():getRoleData():getGem() >= self.config[5].cost then
                    wd.TranscodingSend:setEquipSmeltingUp(self:getItem():getServerId(),5)
                else
                    -- wd.showRichTips(4,"元宝不足")
                    local layerClass = require("src.game.charge.ChargeTipsScene")
                    local layer = layerClass:create()
                    self:getParent():addChild(layer)
                    self:removeFromParent()
                end
            end
        end
    )
    local nameTable = 
    {
        [1] = "妖炼",
        [2] = "魔炼",
        [3] = "魂炼",
        [4] = "仙炼",
        [5] = "神炼"
    }
    for n =1,5 do
        local name = "xue_title_"
        local text = tolua.cast(ccui.Helper:seekWidgetByName(node,name..n), "ccui.Text")
        text:setString(nameTable[n].."（提升附加属性"..self.config[n].min_value.."~"..self.config[n].max_value.."%）")
        name = "Use_Gold"
        local useGold = tolua.cast(ccui.Helper:seekWidgetByName(node,name..n), "ccui.Text")
        useGold:setString(self.config[n].cost)
    end
    
    local equipText = tolua.cast(ccui.Helper:seekWidgetByName(node,"Equip_Text"), "ccui.Text")
    equipText:setString("描述:"..self:getItem():getDescription())
    
    self:registerEventListener()
 
    self:getXueData()
    self:setXueData()
end

function SmeltingLayer:getXueData()
    self.xue1 = tonumber(self:getItem():getExtendData("xue1"))
    self.xue2 = tonumber(self:getItem():getExtendData("xue2"))
    self.xue3 = tonumber(self:getItem():getExtendData("xue3"))
    self.xue4 = tonumber(self:getItem():getExtendData("xue4"))
    self.xue5 = tonumber(self:getItem():getExtendData("xue5"))
    self.xueTable = {}
    table.insert(self.xueTable,self.xue1)
    table.insert(self.xueTable,self.xue2)
    table.insert(self.xueTable,self.xue3)
    table.insert(self.xueTable,self.xue4)
    table.insert(self.xueTable,self.xue5)
    self.count = self.xue1+self.xue2+self.xue3+self.xue4+self.xue5
end

function SmeltingLayer:setXueData()
    for k,v in pairs(self.xueTable) do
        if v ~= 0 then
            local key = "Panel_xue"..k
            local panel = tolua.cast(ccui.Helper:seekWidgetByName(self.node,key), "ccui.Widget")
            if self.config[k].max_value == v then
                panel:setVisible(false)
                key = "perfect"..k
                local perfect = self.node:getChildByName("Panel_Box"):getChildByName(key)
                perfect:setVisible(true)
            else
                panel:setVisible(true)
            end
            key = "xue_"..k
            local xue = tolua.cast(ccui.Helper:seekWidgetByName(self.node,key), "ccui.Text")
            xue:setString(v.."%")
        else
            if k - 1 >= 1 then
                local key = "Panel_xue"..(k)
                local panel = tolua.cast(ccui.Helper:seekWidgetByName(self.node,key), "ccui.Widget")
                panel:setVisible(true)
            end
            break
        end
    end
    local xueText = tolua.cast(ccui.Helper:seekWidgetByName(self.node,"xue_text"), "ccui.Text")
    xueText:setString("血炼+"..self.count.."%")
    if self.count > 0 then
        xueText:setVisible(true)
    else
        xueText:setVisible(false)
    end
    self:showSmeltingEquip(self.equipId)
end

return SmeltingLayer