
require "cocos.extension.ExtensionConstants"

local UpdateCheckLayer = class("UpdateCheckLayer",function()
    return cc.Layer:create()
end)

-- cclog
local cclog = function(...)
    print(string.format(...))
end

function UpdateCheckLayer.create()
    local layer = UpdateCheckLayer.new()
    layer:autoCheckUpdate()
    return layer
end

function UpdateCheckLayer:ctor()
    self.visibleSize = cc.Director:getInstance():getVisibleSize()
    self.origin = cc.Director:getInstance():getVisibleOrigin()
    self.schedulerID = nil
    self.pathToSave = createDownloadDir()  -- 保存路径
    self.assetsManager = nil -- 资源管理器对象
    self.version = cc.UserDefault:getInstance():getStringForKey("version")
    
    self.checkSchedule = nil
end

function UpdateCheckLayer:getContentLength()
    local length = self.assetsManager:getContentLength()

    if length >= 1024*1024 then
        length = string.format("%0.1fMB", length/1024/1024)
    elseif length >= 1024 then
        length = string.format("%0.1fKB", length/1024)
    elseif length > 0 then
        length = string.format("%dB", length)
    else
        length = "0B"
    end
    
    return length
end


function UpdateCheckLayer:getAssetsManager()

    if nil == self.assetsManager then
        -- self.assetsManager = cc.AssetsManager:new(string.format("http://ttlx.oss-cn-hangzhou.aliyuncs.com/wending%%2Ftiantianliexue%%2F%s%%2Fupdate.zip",self.version) ,
        --     string.format("http://ttlx.oss-cn-hangzhou.aliyuncs.com/wending%%2Ftiantianliexue%%2F%s%%2Fversion",self.version),
        --     self.pathToSave)
            
        local url = "http://ttlx.oss-cn-hangzhou.aliyuncs.com/tianzheng%2Fliehuoguaji%2Fupdate%2F"
        self.assetsManager = cc.AssetsManager:new(url..self.version.."%2Fupdate.zip",url..self.version.."%2Fversion",self.pathToSave)
            
        self:addChild(self.assetsManager)

        self.assetsManager:setConnectionTimeout(3)
    end

    return self.assetsManager
end

function UpdateCheckLayer:checkUpdate()

    if self:getAssetsManager():checkUpdate() == true then
        return true
    else
        return false
    end

end

function UpdateCheckLayer:autoCheckUpdate()

    local function autoCheck()
        if self:checkUpdate() == true then
            self:createLayerMenu()
        end
    end
    
    self.checkSchedule = cc.Director:getInstance():getScheduler():scheduleScriptFunc(autoCheck, 60, false)
end

function UpdateCheckLayer:createLayerMenu()
    local node = tolua.cast(cc.CSLoader:createNode("ui/update/UpdateCheckLayer.csb"), "ccui.Widget")
    self:addChild(node)

    node:setContentSize(self.visibleSize)
    node:setPosition(self.origin)

    ccui.Helper:doLayout(node)

    local sureBtn = tolua.cast(ccui.Helper:seekWidgetByName(node,"Sure_Button"), "ccui.Widget")
    sureBtn:setPressedActionEnabled(true)
    sureBtn:addTouchEventListener(
        function(sender,eventType)
            if eventType == ccui.TouchEventType.ended then
                wd.SdkApi:logoutSdk()
            
                wd.TranscodingSend:disconnectServer()
            
                wd.GlobalData:destroyInstance()

                local scene = require("src.login.LoginScene")
                local gameScene = scene.create()

                if cc.Director:getInstance():getRunningScene() then
                    cc.Director:getInstance():replaceScene(gameScene)
                else
                    cc.Director:getInstance():runWithScene(gameScene)
                end
                
            end
        end
    )
end


return UpdateCheckLayer